/* minim_lib.c : 25/10/2006
  + rendu texture/fil de fer
  + synchro"automatique" son et animation
  + decodage de fap
  + support simpliste pour un pilotage par socket
  + slider articulatoire
  + slider independants pour les articulateurs non pilotes
  + multi camera (avec mirroir)
  + sauvegarde  BMP & PNM (hack pour VC++ et ses structures mal packees)
  + mov multiple (debugge)
  + lecture des ECH
  + interfacage avec Tobii (version 3 du demon TET Windows)
  + interfacage avec souris (a la TET, sous Linux)
  + logos/wav/art multiples"
  + BMP32 pour les dents
  + modeles a 2 niveaux & objets multiples
  + affichage possible d'un objet Face avec maillagee/texture
  + mesh compatible Mother pour les obj + choix couleur
  + lecture directe des .seq
  + device audio & contre-mesure pour les ecritures bloquantes, y compris ALSA/OSS
  + decoupage Linux/Windows en #define
  + choix possible de la couleur du fond
  + modele pour les yeux + texture
  + meilleur parsing des arguments multiples
  + lecture des SEG (pour les yeux) et  version de dico compatible snapshot
  + premiere version de l'insertion du clone dans le monde (pour Rackham)
  + partage du controle GLUT avec un client externe
  + debug de la lecture des ART multi-largeur
  + ajout de la liste de texture "PLUS" (multi-texture) pour les applis externes
  + globalisation des diverses textures (debut du -back seul)
  + gestion de l'image de fond incrementee (-backi) pour les pauses
  + debug/traits de construction pour le regard
  + machoire et dents (version SR/FE)
  + gestion des sauvegardes TV (interlace, progressive ou double)
  ? version 'beta' du point light (pour SF, obj "Face")
  ? version 'beta' du unproject
  ? eye pour les OBJ
  ? machoire et dents pour les OBJ
  ? points "extra" pour les modeles OBJ
  ? premier redecoupage en prevision d'une version SDL
  ? redecoupage des vecteurs/callbacks, AVANT l'appel de Minim_start_clone()
  ? pre-version des textures PNM non puissances de 2, SAUF POUR LES YEUX, via Scalef
  ? premiere version de pause/unpause (sans gestion de l'audio pour Windows)
  ? debug du restart en mode pause
  ? rotation de la tete (version avec rotation y indirecte)
  ? wrap de texture, en x SEULEMENT, pour -mdl et -obj
  ? pre-version de la "conscience" du point regarde(s)
  - acceleration GL des rot d'obj si jaw/mach : non generique et SANS les rot partielles
  - texture seulement mono-couche pour les obj
  - impossible de quitter proprement si on est dans un thread !
  - pas de raffinement des levres
  - BUG: texture manquante pour la machoire attachee a un obj
  - BUG: acceleration non fonctionnelle pour des suites de rot-trans (modele a 2 niveaux)
  mailto:elisei@icp.inpg.fr
*/

// -------------------------------------------
// Section du  choix des options

#ifdef __UNIX__

#define USE_AUDIO_LINUX
#define BUG_BLOCKING_AUDIOCARD
// #define USE_TET_LINUX
// #define USE_TIFF

#else

#define USE_AUDIO_WIN
//#define USE_TET_WIN

#endif

#define USE_DENTS
#define USE_EYES
//#define USE_SOCK
#define USE_FNC
#define USE_OBJS
#define USE_DICT

// Options pour le debug

//#define SHOW_SIGHT
//#define SHOW_SCREEN

// Fin de la section a options
// -------------------------------------------

#include "Minim_lib.h"

#ifdef USE_AUDIO_WIN
#define USE_AUDIO
#endif

#ifdef USE_AUDIO_LINUX
#define USE_AUDIO
#endif

#ifdef __LINUX__
#define PACKED __attribute__((packed))
#else
#define PACKED
#endif

#ifdef USE_TET_WIN
#define USE_TET
#endif

#ifdef USE_TET_LINUX
#define USE_TET
#endif

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define PI 3.1415926535897932

// Pour les dents par exemple
#ifdef USE_TIFF
#include "mytiff.h"
#endif

// Pour les primitives graphiques :
// #include <GL/gl.h>  // sera inclus par glut
// #include <GL/glu.h> // sera inclus par glut

// Seulement pour ouvrir et configurer une fenetre :
#include <GL/glut.h>

// Pour la synchro temporelle
#include <sys/timeb.h>

// Pour la gestion du son
#ifdef USE_AUDIO_WIN
#include <windows.h>
#include <MMSystem.h>
#define bcopy(A,B,C) memmove(B,A,C)
#endif

#ifdef USE_AUDIO_LINUX
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/soundcard.h>
#ifndef AUDIODEV
#define AUDIODEV   "/dev/dsp"    // Default path for audio device
#endif
#include <errno.h>
extern int errno;
#endif // USE_AUDIO

// Pour le reseau
#ifdef USE_SOCK
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <errno.h>
#include <stropts.h>
#endif // USE_SOCK

// Pour l'Eye Tracker
#ifdef USE_TET_WIN
#include <process.h>
#include <tet.h>
char *CAL_NAME;
#endif

// pour pouvoir montrer_cacher le clone :
int flg_clone_visible=1;
int USE_UNPROJ = 0;

// ---- STRUCTURES

typedef struct { // pt3D
    float x,y,z;
} pt3D; // Points ou vecteurs 3D

typedef struct { // uv2D
    float x,y;
} uv2D; // Coordonnee de texture

typedef struct { //ptTRI
    int i0,i1,i2;
    int d0,d1,d2; // decalages anti-wrap (en X) pour les textures
} ptTRI; // Indices de points, pour les triangles

typedef struct { // obj_mov
    float tx,ty,tz;
    float rx,ry,rz;
    float cx,cy,cz; // Centre de la rotation (par commodite)
} obj_mov; // Rotation et translation d'un objet

typedef struct PACKED { // BMP_HEADER
   unsigned short int type;                 /* Magic identifier            */
   unsigned int size;                       /* File size in bytes          */
   unsigned short int reserved1, reserved2;
   unsigned int offset;                     /* Offset to image data, bytes */
} BMP_HEADER;

typedef struct PACKED { // BMP_INFO
   unsigned int size;               /* Header size in bytes      */
   int width,height;                /* Width and height of image */
   unsigned short int planes;       /* Number of colour planes   */
   unsigned short int bits;         /* Bits per pixel            */
   unsigned int compression;        /* Compression type          */
   unsigned int imagesize;          /* Image size in bytes       */
   int xresolution,yresolution;     /* Pixels per meter          */
   unsigned int ncolours;           /* Number of colours         */
   unsigned int importantcolours;   /* Important colours         */
} BMP_INFO;

#ifdef USE_EYES
typedef struct { // eye_obj
		float cx,cy,cz; // Position de l'oeil dans le repere tete
		float radius;
		float dx,dy,dz; // Position de la pupille relativement a l'oeil
		float radius2;
		float sc1, sc2; // Pour le texturage
} eye_obj;
#endif // USE_EYES

// ---- TAILLES DES ALLOCATIONS STATIQUES

#define MAX_PTS 10000
#define MAX_ART 50
#define MAX_TRI 15000
#define MAX_STRING 500
#define MAX_SEQ 26000
#define MAX_CAM 5
#define MAX_LOGO 10
#define MAX_OBJS 8
#define MAX_FUNCT 200
#define MAX_MOTS 80
// Pour le visage (-mdl) et xtra seulement :
#define MAX_TEX 3
#define MAX_TEX_PLUS 3

// ---- VARIABLES GLOBALES

// identifiant GLUT
int WIN;
volatile int MINIM_NOT_READY=1;
volatile int MINIM_IS_SPEAKING=0;

// Pour memoriser le(s) modele(s) de camra
double CAM[MAX_CAM][16]; // Matrice stockee en colonne pour GL
int CAM_MIRROR[MAX_CAM]; // Repere indirect ?
volatile int MINIM_WIDTH, MINIM_HEIGHT, NB_CAM; // taille de l'ecran virtuel
int MINIM_X,MINIM_Y; // Position du coin haut droit

// Memoriser le modele articulatoire
int NB_ART_MDL=0;  // Nombre de parametres articulatoires
pt3D  MDL[MAX_PTS][1+MAX_ART]; // Points et vecteurs du modele articulatoire
#ifdef USE_FNC
int MDL_FNC[MAX_ART];
pt3D MDL_CROT[MAX_ART];
#endif

int NB_PMV=0;      // Nombre de points mobiles
int NB_PFX=0;      // Nombre de points fixes
pt3D  PTS[MAX_PTS];    // Points prets a etre affiches (calcules +  statiques)

// Mmoriser  le maillage
int NB_TLV=0;    // Nombre de triangles pour les levres
int NB_TMT=0;    // Nombre de triangles pres des levres (pour l'analyse)
int NB_TRI=0;    // Nombre de triangles (total)
int NB_TMSK=0;	 // Nombre de triangles de masque (a la fin du total)
int NB_XTR=0;	 // Nombre de triangles 'extra' (fil de fer)
ptTRI MSH[MAX_TRI];    // Liste des indices de triangle

// Stockage des parametres articulatoires
int NB_ART_LU=0; // Nombre de parametres articulatoires dans le fichier
float ART[MAX_SEQ][MAX_ART];
float *MINIM_ART=&ART[0][0];
int ART_CNT, ART_MAX, ART_MAX_CN; //Compteurs de sequence
int MINIM_PAUSED=0;
struct timeb PAUSE_TIME;

// commandes RPC "thread safe" du clone
int pending_close=0; // close demande
int pending_hc=0; // hide/show clone
int pending_swp=0, pending_swp_x=0, pending_swp_y=0; // Window Position
int pending_sws=0, pending_sws_w, pending_sws_h; // Window Size
int pending_input=0; // gestion de sequence
int pending_autorun=0;
int pending_delete=0;
int pending_input_done=0;
int i_m_a_thread=0; // stop exiting with 'q'
char pending_art_file[MAX_STRING];
char pending_wav_file[MAX_STRING];

// Gestion globale de toutes les textures
int TOT_TEX=0; // Total a reserver
volatile unsigned int *MINIM_TEX_ID;   // Stockage des identifiants GL
uv2D *TEX_MUL; // facteurs d'echelle des textures

// Stockage des donnees liees aux textures du visage (-mdl seulement)
int NB_TEX=0; // Pour le visage...
int USE_TEX_XTRA=1; // Flag pour le modele "extra" (non anime)
float TEX_POIDS[MAX_TEX];         // Coefficients d'influence
uv2D TEX_POS2D[MAX_TEX][MAX_PTS]; // Coordonnees de texture
pt3D TEX_PTS3D[MAX_TEX][MAX_PTS]; // Positions du modele
char TEX_FILE[MAX_TEX][MAX_STRING];       // Nom du fichier texture
float TEX_ALPHA[MAX_TEX];         // Calcul des transparences
float BACK_R=1.0, BACK_G=1.0, BACK_B=1.0; // Couleurs du fond

// Eventuelle image de fond "-back" (ou "-logo")
char TEX_BACK[MAX_STRING];
int SLOT_BACK=0;			// Offset dans MINIM_TEX_ID
int USE_BACK=0;
int USE_BACKI=0;
int USE_VIDEO=0;

// Texture "-plus"
char *MINIM_TEX_PLUS[MAX_TEX_PLUS];
volatile int MINIM_NB_TEX_PLUS=0;

// Stockage du mouvement objet, nul par defaut
obj_mov OBJ_MOV[MAX_SEQ]={{0.0,0.0,0.0, 0.0,0.0,0.0, 0.0,1.0,-6.0}};
int NB_MOV=0;

// Stockage d'un mouvement pour la vue
float OBJ_ROT[3]={0.0,0.0,0.0};

// stockage du modele d'inversion de fap
float FAP_ECH[68]; // Mise a l'echelle des faps
float FAP_DCL[68]; // Biais x/y/z des faps en cm
float FAP_INV[MAX_ART][68]; // Pseudo-inverse du modele
int NB_FAP; // Nombre de FAPs traites par le modele

// Noms des fichiers de sauvegarde eventuels
char *OUT_IMG=NULL; // pour la premiere image cree
char *OUT_PTS=NULL; // pour les coordonnees 3D associees
char *OUT_POS=NULL; // pour les positions 2D associees
int OUT_IMG_PNM;

// Gestion du monde reel ou s'affiche le clone
float dpcm_x=70, dpcm_y=70;
float clone_pos_world[3]={0.0, 0.0, 0.0};
float clone_rot_world[9]={1.0, 0.0, 0.0,  0.0, 1.0, 0.0,  0.0, 0.0, 1.0};
// Gestion du monde reel relatif ou s'effectuent les tracking
float clone_pos_base[3]={0.0, 0.0, 0.0};
float clone_rot_base[9]={1.0, 0.0, 0.0,  0.0, 1.0, 0.0,  0.0, 0.0, 1.0};

#ifdef USE_DICT
// Donnees du dico et de la segmentation audio
typedef enum {
  oCible2D, oCible3D
} tCible;
int	NB_MOTS=0;
int NB_MOTS_VUS=0;
char *DICO_MOT[MAX_MOTS];
pt3D DICO_CIBLE[MAX_MOTS];
tCible DICO_OBJET[MAX_MOTS];
long int SEG_START[MAX_MOTS+2], SEG_STOP[MAX_MOTS+2], SEG_IDX[MAX_MOTS+2];
int idx_seg=0;
int seg_flag=0;
#endif // USE_DICT

// gestion des sliders
int NB_SLD=0;

#ifdef USE_OBJS

typedef enum { // tFunct
	fLin, fCos, fSin
} tFunct;

typedef enum { // tObj
	oUnknown, oMdl2, oHand, oFace, oTexFace, oDiff
} tObj;

typedef struct { // tMdl
	tObj tObj;			// type de l'objet (Face, Hand...)
	char *filename; // fichier source
	char *meshfile;
	char *texfile;
	float mesh_r, mesh_g, mesh_b; // couleurs

	int nb_art;
	int nb_funct;

	float **funct; // stockage des functions
	tFunct *t_funct;
	int r_funct[MAX_FUNCT]; // rot ou pas ?
	float rx_funct[MAX_FUNCT];
	float ry_funct[MAX_FUNCT];
	float rz_funct[MAX_FUNCT];
	int use_GLtrans; // re-ecrit le modele pour l'acceleration

	int nb_pts_draw;
	int nb_pts_calc;
	int nb_tri;
	ptTRI tri[MAX_TRI];
	float *val;
	pt3D **mdl;
	pt3D *pts;

	int nb_tex;
	int slot_tex;
	uv2D *pos;
	int offset_art;
} tMdl;

tMdl OBJS[MAX_OBJS];
float USE_PL=0;
#endif // USE_OBJS
int  NB_OBJS=0;

#ifdef USE_DENTS
// PALAIS -------------------------------------- PALAIS
int   NB_PAL=0;           // nombre de points du fichier palais
pt3D *PAL;                // les points du palais
int   SLOT_PAL=0;         // numero de texture
uv2D  PAL_POS2D[MAX_PTS]; // Coordonnees de texture
pt3D  PAL_PTS3D[MAX_PTS]; // Positions du modele
char  *TEX_PAL_FILE ;     // pour la texture: le premier .pnm,
char  P2D_PAL_FILE[MAX_STRING] ; // le deuxieme .txt

int   TRACE_CONDYLE = 0;

int   NB_MACH=0;          // nombre de points du fichier machoire
pt3D *MACH;               // points de la machoire
int   SLOT_MACH=0;        // numero de texture
uv2D  MACH_POS2D[MAX_PTS];
char  *TEX_MACH_FILE ;    // pour la texture: le premier .pnm,
char  P2D_MACH_FILE[MAX_STRING] ;     // le deuxieme .txt

char *OUT_PTSPAL=NULL;    // pour les coordonnees 3D associees
char *OUT_POSPAL=NULL;    // pour les positions 2D associees
char *OUT_POSMACH=NULL;

pt3D  CONDYLE;
pt3D  MACH_ROT; // axe de rotation
float LGM,OM0,ANG_JW;
int PAL_REF=-1; // Numero de l'objet de rattachement (ou -1 pour le -mdl)
int IND_UT;
int MACH_REF=-1; // Numero de l'objet de rattachement (ou -1 pour le -mdl)
int IND_LT;
int USE_CLOSE_LIPS=0;
// PALAIS -------------------------------------- PALAIS
#endif // USE_DENTS

#ifdef USE_EYES
int SLOT_EYES=0;		// Numero du slot texture (ou oppose)
char TEX_EYES_FILE[MAX_STRING];
eye_obj EYES[2]; 		// Droite puis gauche par exemple
float EYE_ART[MAX_SEQ][4]={{0.0, 0.0, 0.0, 0.0}};
int EYE_ART_MAX=0;		// taille de la sequence lue
int EYE_REF=-1;			// Numero de l'objet de rattachement (ou -1 pour le -mdl)
int EYE_FROM_MDL=-1;	// Numero du 1er parametre de controle
int EYE_FROM_MDLn=0;		// Nombre de parametre par oeil
float LIGHT_X=-10;		// Position, en metres, dans le repere monde
float LIGHT_Y=80;
float LIGHT_Z=120;
#endif // USE_EYES

// stockage du frame rate demande
float F_RATE=-25; // Oppose de la valeur par defaut

// gestion du temps
struct timeb START_TIME;
struct timeb MINIM_END_TIME;

// gestion des sockets
int SOCK_SRV=-1, SOCK=-1;

#ifdef USE_AUDIO
typedef  struct
{
  unsigned long   uiSize;
  unsigned short  uiFormatTag;
  unsigned short  uiChannels;
  unsigned long   ulSamplesPerSec;
  unsigned long   ulAvgBytesPerSec;
  unsigned short  uiBlockAlign;
  unsigned short  uiBitsPerSample;
} myWAVEFORMAT;

// Pour la gestion du son
int WAV_DEV=0; // pour Linux seulement
void *WAV_DAT= NULL;
int MAX_AWR=4096; // defaut de la taille d'ecriture pour Linux seulement
char myAUDIODEV[MAX_STRING];

#endif // USE_AUDIO

int WAV_SIZ=0;     // Pas de donnees par defaut
int WAV_PTR=-120;  // Dmarrage automatique
int LOOP=-1;	   // Re-demarrage

// gestion des logos
typedef struct { // tLOGO
	float x0; // Bounding Box dans l'espace GL
	float y0;
	float x1;
	float y1;
	int wav_siz; // Pour le son
	void *wav_dat;
	int art_max; // pour l'articulation
	void *art;
#ifdef USE_DICT
	int idx_seg;
#endif // USE_DICT
} tLOGO;

int NB_LOGO=0;
tLOGO LOGOS[MAX_LOGO];

// ----  CONVERSION FAP VERS ARTICULATOIRE

void fap2art(float faps[68], float art[MAX_ART])
{
    int i,j;
    float fap_cm;

    // Initialize
    for(j=0;j<NB_ART_MDL;j++)
        art[j]=0.0;

    // Multiply-accumulate by "sparse" pseudo-inverse
    for(i=0;i<68;i++) if (FAP_ECH[i]!=0.0) {
        fap_cm=FAP_DCL[i]+FAP_ECH[i]*faps[i];
        for(j=0;j<NB_ART_MDL;j++)
            art[j]+=FAP_INV[j][i]*fap_cm;
    }

    // Range constrain
    for(j=0;j<NB_ART_MDL;j++)
        if (art[j]<-4.0) art[j]=-4.0; else if (art[j]>4.0) art[j]=4.0;

}

//  ---- LECTURES DES DIFFERENTES DONNEES

int TRACE_RES=0;

// Rejet sommaire des fichiers inexistants
FILE *my_fopen(char *filename, char *mode)
{
    FILE *fid;

    if ((fid=fopen(filename,mode))==NULL) {
        printf("Error, cannot open file '%s'\n",filename);
        exit(1);
    }

	if (TRACE_RES)
	  printf("RES: %s\n",filename);

    return(fid);
}

#ifdef USE_DICT
// On charge un dictionnaire de mots a reconnaitre
void read_dic(char *filename)
{
	FILE *fid;
    char *s, fline[10*MAX_STRING];
	float x,y;

    fid=my_fopen(filename,"r");
	while (fgets(fline,MAX_STRING,fid)!=NULL) {
	  strtok(fline," \n");
	  DICO_MOT[NB_MOTS]=strdup(fline);
	  s=strtok(NULL," \n");
	  if ((s!=NULL)&&(strcmp(s,"2D")==0)) {
		DICO_OBJET[NB_MOTS]=oCible2D;
		sscanf(strtok(NULL,""),"%f %f",&x,&y);
		DICO_CIBLE[NB_MOTS].x=(1+x)/2*MINIM_WIDTH;
		DICO_CIBLE[NB_MOTS].y=(1-y)/2*MINIM_HEIGHT;
	  } else if ((s!=NULL)&&(strcmp(s,"3D")==0)) {
		DICO_OBJET[NB_MOTS]=oCible3D;
		sscanf(strtok(NULL,""),"%f %f %f",&DICO_CIBLE[NB_MOTS].x,&DICO_CIBLE[NB_MOTS].y,&DICO_CIBLE[NB_MOTS].z);
	  } else {
		printf("Dictionnaire mal forme (ligne %d):\n  avec #%s#\ndans %s\n",1+NB_MOTS,fline,filename);
		exit(-1);
	  }
	  NB_MOTS++;
	}
	fclose(fid);
	printf("Chargement du dictionnaire (%d mots):\n  %s\n",NB_MOTS,filename);
}

// On lit la segmentation d'une phrase, a la recherche de mots connus
void read_seg(char *filename, int verb)
{
	FILE *fid;
    char fline[10*MAX_STRING];
	char *s;
	int rate, i;
	int pending=0;
	long int stamp;

//	NB_MOTS_VUS=0;
    fid=my_fopen(filename,"r");
	// skip PTS
	fgets(fline,MAX_STRING,fid);
	// read sampling rate
  	fgets(fline,MAX_STRING,fid);
	sscanf(fline,"FE: %d",&rate);
	while (fgets(fline,MAX_STRING,fid)!=NULL) {
	  // Recuperation des infos : mot eventuel et "date"
	  s=strchr(fline,'|');
	  sscanf(fline,"%ld",&stamp);

	  // Est-ce la fin d'un mot precedent ?
	  if (pending&& ((s!=NULL)||(strchr(fline,'_')!=NULL))) {
		  SEG_STOP[NB_MOTS_VUS-1]=1000*(stamp-1)/rate; // date en ms
		  pending=0;
	  }

	  // Recuperation d'un mot ?
	  if (s!=NULL) {
		// on detache le pointeur s de la suite eventuelle
		strtok(s++," \n");
		// ce mot fait-il partie du dictionnaire  ?
		for(i=0;i<NB_MOTS;i++) if (strcmp(s,DICO_MOT[i])==0) {
			SEG_IDX[NB_MOTS_VUS]=i;
			SEG_START[NB_MOTS_VUS]=1000*stamp/rate; // date en ms
			SEG_STOP[NB_MOTS_VUS++]=1<<31;
			pending=1;
		  break;
		}
	  }

	}
	fclose(fid);
	if (verb)
	  printf("Chargement de la segmentation (%d mots reconnus):\n  %s\n",NB_MOTS_VUS,filename);
}
#endif // USE_DICT

// Lecture d'un jeu de parametres articulatoires
void read_art(char *filename, int verb)
{
    FILE *fid;
    int i,j;
    char fline[10*MAX_STRING];
	char *s;
	int is_seq;

    if (verb) printf("Parametres d'articulation : %s\n",filename);
    NB_ART_LU=ART_MAX=ART_CNT=0;
    fid=my_fopen(filename,"r");
		is_seq=(strcmp(filename+strlen(filename)-3,"seq")==0);
		if (is_seq) {
			fgets(fline,10*MAX_STRING,fid);
		}
    while (fgets(fline,10*MAX_STRING,fid)!=NULL) {

			s=strtok(fline,"# ");
			j=0;
			while (s&&(j<MAX_ART)&&sscanf(s,"\t%f\t",&ART[ART_MAX][j])) {
				j++;
				s=strtok(NULL," ");
			}
			if (NB_ART_LU==0) NB_ART_LU=j;
			if (j!=NB_ART_LU) {
			  printf("Erreur: lecture de %d puis %d parametres\n  dans %s\n  %d:%s\n",NB_ART_LU,j+1,filename,ART_MAX,fline);
			  exit(1);
			}
			ART_MAX++;
    }
    fclose(fid);

    if ((NB_OBJS==0)&&(NB_ART_LU>NB_ART_MDL)) {
	printf("!!! Erreur: Lecture de %d parametres au lieu de %d max,\n  dans %s\n",NB_ART_LU,NB_ART_MDL,filename);
//	exit(1);
    }

	if (verb) {
      printf("  1/%d:",ART_MAX);
      for(i=0;i<NB_ART_LU;i++)
        printf("  %f",ART[0][i]);
      printf("\n");
	}

#ifdef USE_DICT
	// Lecture de la segmentation associee ?
	if (verb) NB_MOTS_VUS=0;
	if (seg_flag) {
		char seg_file[MAX_STRING];
		int l=strlen(filename);

		strncpy(seg_file,filename,MAX_STRING);
		if (l>3) strcpy(&seg_file[l-3],"seg");
		read_seg(seg_file,verb);
	}
#endif // USE_DICT
}

#ifdef USE_EYES
// Lecture d'un jeu de parametres articulatoires
void read_eyes_art(char *filename)
{
    FILE *fid;
    int i,cnt;
    char fline[2*MAX_STRING];

    printf("Parametres d'articulation (yeux) : %s\n",filename);
    cnt=0;
    fid=my_fopen(filename,"r");
    while ((cnt<MAX_SEQ)&&(fgets(fline,2*MAX_STRING,fid)!=NULL)) {
        if (sscanf(fline,"%f %f %f %f",
			      &EYE_ART[cnt][0],&EYE_ART[cnt][1],
			      &EYE_ART[cnt][2],&EYE_ART[cnt][3])==4) cnt++;
    }
    fclose(fid);

    printf("  1/%d:",EYE_ART_MAX=cnt);
    for(i=0;i<4;i++)
        printf("  %f",EYE_ART[0][i]);
    printf("\n");
}
#endif // USE_EYES

// Lecture d'un jeu de parametres articulatoires
void read_fap(char *fap_file)
{
    FILE *fid;
    int i,j;
    char fline[2*MAX_STRING];
    float fap_vals[68];
    int fap_mask[68];

#ifdef USE_DICT
	NB_MOTS_VUS=0;
#endif // USE_DICT

    if (NB_FAP==0) {
        printf("\n Inversion des FAPs impossible sans modele compatible !\n");
        exit(1);
    }

    // Initialisation des FAPs
    for(i=0;i<68;i++)
        fap_vals[i]=0.0;

    // Lecture d'un fichier de FAPs
    printf("Parametres d'articulation (d'apres FAP): %s\n",fap_file);
    ART_CNT=0;
    fid=my_fopen(fap_file,"r");
    do {
        fgets(fline,2*MAX_STRING,fid);
    } while (fline[0]=='#');
    sscanf(fline,"%*f %*s %f %d",&F_RATE,&ART_MAX);
    for(i=0;i<ART_MAX;i++) {
        for(j=0;j<68;j++)
            fscanf(fid,"%d",&fap_mask[j]);
        fscanf(fid,"%d",&j);
        for(j=0;j<68;j++)
            if (fap_mask[j]) fscanf(fid,"%f",&fap_vals[j]);
        fap2art(fap_vals,ART[i]);
    }
    fclose(fid);

    NB_ART_LU=6; /// !!!! non compatible avec les sliders de forme/modeles simplifies
    printf("  1/%d (%d params pour %d):",ART_MAX,NB_ART_LU,NB_ART_MDL);
    for(i=0;i<NB_ART_LU;i++)
        printf("  %f",ART[0][i]);
    printf("\n");
}

// Lecture d'une configuration camera
void read_cam(char *filename,double cam[MAX_CAM][16], int cam_mirror[MAX_CAM])
{
    FILE *fid;
    char fline[MAX_STRING];
    char cam_type[MAX_STRING];
    int i;

    printf("Modele de camera : %s\n",filename);
    fid=my_fopen(filename,"r");
    fgets(fline, MAX_STRING,fid);
    sscanf(fline,"%d %d",&MINIM_WIDTH,&MINIM_HEIGHT);
    NB_CAM=0;
    fgets(fline, MAX_STRING,fid);
    while (!feof(fid)) {
	for(i=0;i<4;i++) {
	  cam_type[0]='\0'; // par defaut, repere direct
	  if (sscanf(fline,"%lf %lf %lf %lf %s",
		     &cam[NB_CAM][i],&cam[NB_CAM][i+4],&cam[NB_CAM][i+8],
		     &cam[NB_CAM][i+12],cam_type)<4)
	    break;
	  if (i==0)
	    cam_mirror[NB_CAM]=(strcmp(cam_type,"mirror")==0);
	  fgets(fline, MAX_STRING,fid);
	}
	NB_CAM++;
    }
    fclose(fid);
    printf("  image en %dx%d, avec %d camera(s).\n",MINIM_WIDTH,MINIM_HEIGHT,NB_CAM);
}

// Traitement des coordonnees de texture (X wrap)
void tex_wrap_uv(uv2D tex_pos[], int nb_tri, ptTRI msh[]) {
  int i;
  float px1,px2,px3;
  int nbr,nbl;

  for(i=0;i<nb_tri;i++) {
	px1=tex_pos[msh[i].i0].x;
	px2=tex_pos[msh[i].i1].x;
	px3=tex_pos[msh[i].i2].x;
	// nombre de points references a droite / puis a gauche ?
	nbr=(px1>.75)+(px2>.75)+(px3>.75);
	nbl=(px1<=.25)+(px2<=.25)+(px3<=.25);
	// traitement des points qui traversent la frontiere :
	msh[i].d0=msh[i].d1=msh[i].d2=0;
	if ((nbr!=0)&&(nbl!=0)) {
	    msh[i].d0=(px1>.75);
    	msh[i].d1=(px2>.75);
    	msh[i].d2=(px3>.75);
	}
  }
}

#ifdef USE_OBJS

// Lecture d'un modele a deux niveaux (hand...)
void read_obj_def(char *filename, tMdl *mdl, int offset) {
  FILE *fid;
  char fline[2000], *s;
  char t;
  int i,j;

  int flag_eye=-1;

  fid=my_fopen(filename,"r");
  // lecture du nombre de fonctions de niveau 1
  fgets(fline,500,fid);
  sscanf(fline,"%dtrans%c",&mdl->nb_funct,&t);

  // lecture du nombre de parametres d'entree
  fgets(fline,500,fid);
  sscanf(fline,"%d",&mdl->nb_art);
  // parsing des parametres de niveau 1
  s=strtok(fline," ");
  for(i=0;i<mdl->nb_art;i++) {
	s=strtok(NULL," ");
	// Parametre de controle de l'oeil ?
	if (strncmp(s,"oeil",4)==0) {
	  if (flag_eye) {
		flag_eye=0;
		EYE_FROM_MDLn=1;
	  } else
		EYE_FROM_MDLn++;
	  if (EYE_FROM_MDL<0) EYE_FROM_MDL=i;
	}
  }
  if (!flag_eye) EYE_FROM_MDLn>>=1;

  // lecture des fonctions
  mdl->use_GLtrans=0;
  mdl->t_funct=(tFunct *)calloc(mdl->nb_funct,sizeof(tFunct));
  mdl->funct=(float **)calloc(mdl->nb_funct,sizeof(float*));
  for(i=0;i<mdl->nb_funct;i++) {
	fgets(fline,2000,fid);
	s=strtok(fline," ");
	// rotation ? centre ?
	mdl->r_funct[i]=(sscanf(s,"ROT%c%c_%f_%f_%f",&t,&t,&mdl->rx_funct[i],&mdl->ry_funct[i],&mdl->rz_funct[i])==5);
	// Potentiellement accelerable ?
	if (mdl->r_funct[i]||(sscanf(s,"TRL%c%c",&t,&t)==2))
	  mdl->use_GLtrans-=1;
	// type de la fonction ?
	s=strtok(NULL," ");
	if (strcmp(s,"COS")==0)
		mdl->t_funct[i]=fCos;
	else if (strcmp(s,"SIN")==0)
		mdl->t_funct[i]=fSin;
	else if (strcmp(s,"LIN")==0)
		mdl->t_funct[i]=fLin;
	else {
		printf("\nErreur: function %s inconnue,\n  dans le modele %s\n",s,filename);
		exit(1);
	}
	// on memorise les valeurs
	mdl->funct[i]=(float *)calloc(1+mdl->nb_art,sizeof(float));
	for(j=0;j<=mdl->nb_art;j++)
			sscanf(strtok(NULL," "),"%f",&(mdl->funct[i][j]));
  }

	// lecture du nombre de points a articuler
	fgets(fline,200,fid);
	sscanf(fline,"%d",&mdl->nb_pts_calc);
	mdl->nb_pts_draw=mdl->nb_pts_calc;

	// Mise a jour de l'offset ?
	if (mdl->offset_art==-1)
	  mdl->offset_art=offset;

	// lecture des points
	mdl->mdl=(pt3D **)calloc(mdl->nb_pts_calc,sizeof(pt3D*));
	for(i=0;i<mdl->nb_pts_calc;i++) {
		mdl->mdl[i]=(pt3D *)calloc(1+mdl->nb_funct,sizeof(pt3D));
		// numero de la ligne
		fgets(fline,2000,fid);
		// les x
		sscanf(strtok(fgets(fline,2000,fid)," "),"%f",&(mdl->mdl[i][0].x));
		for(j=1;j<=mdl->nb_funct;j++)
			sscanf(strtok(NULL," "),"%f",&(mdl->mdl[i][j].x));
		// les y
		sscanf(strtok(fgets(fline,2000,fid)," "),"%f",&(mdl->mdl[i][0].y));
		for(j=1;j<=mdl->nb_funct;j++)
			sscanf(strtok(NULL," "),"%f",&(mdl->mdl[i][j].y));
		// les z
		sscanf(strtok(fgets(fline,2000,fid)," "),"%f",&(mdl->mdl[i][0].z));
		for(j=1;j<=mdl->nb_funct;j++)
			sscanf(strtok(NULL," "),"%f",&(mdl->mdl[i][j].z));
	}

	// Y-a-t'il des points supplementaires ?
	if (fgets(fline,2000,fid)) {
	  sscanf(fline,"%d",&(mdl->nb_pts_draw));
	  mdl->nb_pts_draw+=mdl->nb_pts_calc;
	}

	// On le convertit en Face meshee/texturee ?
	if ((mdl->tObj==oMdl2)&&(mdl->nb_tri==0)&&(NB_TRI!=0)&&(NB_PMV==0)) {
		mdl->tObj=oTexFace;
		NB_PMV=-mdl->nb_pts_calc; // Marqueur negatif
		mdl->pts=PTS; // NULL; // PTS; // Non utilise...
	} else
		mdl->pts=(pt3D *)calloc(mdl->nb_pts_draw,sizeof(pt3D));

	// Lecture des points supplementaires
	if (mdl->nb_pts_draw!=mdl->nb_pts_calc) {
	  for(i=mdl->nb_pts_calc;i<mdl->nb_pts_draw;i++) {
		fgets(fline,2000,fid);
		sscanf(fline,"%f %f %f\n", &(mdl->pts[i].x), &(mdl->pts[i].y), &(mdl->pts[i].z));
if (0) { // Ne marche pas !
  float x,y,z;
  float cx=0.9578, cy=6.1524, cz=-4.7294;
  float tx=-1.8085, ty= 0.2373, tz=-0.0418;
  float rx=-0.1046, ry=-0.1187, rz= 0.0581;
  						// centre
						x=mdl->pts[i].x-cx;
						y=mdl->pts[i].y-cy;
						z=mdl->pts[i].z-cz;

						// tambouille rotative
						if (rx) {
							t=y*cos(rx)-z*sin(rx);
							z=y*sin(rx)+z*cos(rx);
							y=t;
						}
						if (ry) { // on tourne dans le sens indirect !
							t=z*cos(ry)-x*sin(ry);
							x=z*sin(ry)+x*cos(ry);
							z=t;
						}
						if (rz) {
							t=x*cos(rz)-y*sin(rz);
							y=x*sin(rz)+y*cos(rz);
							x=t;
						}
						// centre
						mdl->pts[i].x=x+cx+tx;
						mdl->pts[i].y=y+cy+ty;
						mdl->pts[i].z=z+cz+tz;
}
	  }
	}

	fclose(fid);

	mdl->nb_tri=0;
	if (mdl->meshfile!=NULL) {
	// Lecture d'un mesh
		fid=my_fopen(mdl->meshfile,"rt");
		fgets(fline,2000,fid);
		sscanf(fline,"%d",&mdl->nb_tri);
		for(i=0;i<mdl->nb_tri;i++) {
			fgets(fline,2000,fid);
			sscanf(fline,"%d %d %d",&mdl->tri[i].i0,&mdl->tri[i].i1,&mdl->tri[i].i2);
			--mdl->tri[i].i0;
			--mdl->tri[i].i1;
			if (mdl->tri[i].i2!=-1) --mdl->tri[i].i2;
		}
		fclose(fid);
		// Lecture d'une texture ?
		if (mdl->texfile!=NULL) {
		  char posfile[MAX_STRING], ptsfile[MAX_STRING],texfile[MAX_STRING];
		  float tmp;
		  int i;
		  // Header
		  fid=my_fopen(mdl->texfile,"rt");
		  fgets(fline,2000,fid);
		  if ((mdl->nb_tex=atoi(fline))!=1)
			printf("\nWARNING:\n  Implementation can read first texture only,\n  in %s\n\n",mdl->texfile);
		  fgets(fline,2000,fid);
		  // if (mdl->nb_tex)
		  sscanf(fline,"%f %s %s %s\n",&tmp,texfile,ptsfile,posfile);
		  free(mdl->texfile);
		  mdl->texfile=strdup(texfile);
		  fclose(fid);
		  // read tex coords
		  fid=my_fopen(posfile,"rt");
		  mdl->pos=(uv2D*)malloc(sizeof(uv2D)*mdl->nb_pts_draw);
		  for(i=0;i<mdl->nb_pts_draw;i++) {
			fgets(fline,2000,fid);
			sscanf(fline,"%f %f",&mdl->pos[i].x,&mdl->pos[i].y);
		  }
		  // Wrap U parameter
		  tex_wrap_uv(mdl->pos, mdl->nb_tri, mdl->tri);
		  fclose(fid);
		}
	}

	printf("Lecture d'un objet de type %d \n  %s\n",mdl->tObj,mdl->filename);
	if (mdl->nb_tri)
	  printf("  avec %d triangles, et %d texture,\n",mdl->nb_tri,mdl->nb_tex);
	printf("  pour %d points, dont %d animes via %d fonctions de %d parametres.\n",mdl->nb_pts_draw,mdl->nb_pts_calc,mdl->nb_funct,mdl->nb_art);

	// allocation des tableaux de resultats
	mdl->val=(float *)calloc(mdl->nb_funct,sizeof(float));

}
#endif // USE_OBJS

// Lecture d'un modele de points (animes et fixes)
void read_mdl(char *filename, pt3D mdl[MAX_PTS][1+MAX_ART], pt3D pts[MAX_PTS])
{
    FILE *fid;
    char fline[200];
    int a,p;
		char *s;

    printf("Modele pour les points 3D : %s\n",filename);
    fid=my_fopen(filename,"r");
    // lecture du nombre de points mobiles
    fgets(fline,200,fid);
    sscanf(fline,"%d",&NB_PMV);
    // lecture du nombre de paramtres articulatoires
    fgets(fline,200,fid);
    sscanf(fline,"%d",&NB_ART_MDL);

#ifdef USE_FNC
		s=strtok(fline," ");
		for (a=0;a<NB_ART_MDL;a++) {
			s=strtok(NULL," ");
			MDL_FNC[a]=(sscanf(s,"ROT_%f_%f_%f",&MDL_CROT[a].x,&MDL_CROT[a].y,&MDL_CROT[a].z)==3);
		}
#endif // USE_FNC

    for(p=0;p<NB_PMV;p++) {
        fgets(fline,200,fid); // skip number
        // Lire composante x (moyenne puis deplacements)
        fgets(fline,200,fid);
				s=strtok(fline," ");
				for(a=0;a<=NB_ART_MDL;a++) {
					sscanf(s,"%f",&mdl[p][a].x);
					s=strtok(NULL," ");
				}
        // Lire composante y
        fgets(fline,200,fid);
				s=strtok(fline," ");
				for(a=0;a<=NB_ART_MDL;a++) {
					sscanf(s,"%f",&mdl[p][a].y);
					s=strtok(NULL," ");
				}
         // Lire composante z
        fgets(fline,200,fid);
				s=strtok(fline," ");
				for(a=0;a<=NB_ART_MDL;a++) {
					sscanf(s,"%f",&mdl[p][a].z);
					s=strtok(NULL," ");
				}
     }
    // lecture du nombre de points fixes
		fline[0]='\0';
    fgets(fline,200,fid);
    sscanf(fline,"%d",&NB_PFX);
    // mmorisation des points fixes
    for(p=NB_PMV;p<NB_PMV+NB_PFX;p++) {
        fgets(fline,200,fid);
        sscanf(fline,"%f %f %f",&pts[p].x,&pts[p].y,&pts[p].z);
    }
    printf("  compose de %d points mobiles (selon %d parametres)\n",NB_PMV,NB_ART_MDL);
    printf("  et de %d points statiques.\n",NB_PFX);

    // Prsence d'un modele d'inversion ?
    if ((fgets(fline,200,fid)==NULL)||(sscanf(fline,"%d",&NB_FAP)!=1)) {
        fclose(fid);
        return;
    }

    // Lecture d'un modele d'inversion de FAP
    printf("Modele reconnaissant %d FAPs.\n",NB_FAP);
    for(a=0;a<68;a++)
        fscanf(fid,"%f",&FAP_ECH[a]);
    for(a=0;a<68;a++)
        fscanf(fid,"%f",&FAP_DCL[a]);
    // lecture de la matrice "creuse" d'inversion
    for(a=0;a<68;a++)
        if (FAP_ECH[a]!=0.0)
				for(p=0;p<NB_ART_MDL;p++)
					fscanf(fid,"%f",&FAP_INV[p][a]);

    fclose(fid);
}

// Lecture d'un maillage
void read_msh(char *filename, ptTRI *msh)
{
    FILE *fid;
    char fline[MAX_STRING];
    int i,d;

    printf("Modele de maillage : %s\n",filename);
    fid=my_fopen(filename,"r");
    // Lecture du nombre de triangles (autour de la bouche, total, dont masques)
    fgets(fline, MAX_STRING,fid);
    if (sscanf(fline,"%d %d %d",&NB_TMT,&NB_TRI,&NB_TMSK)==2)
			NB_TMSK=0;
    // Cration du mesh (invariable) pour les lvres
    if (NB_TMT!=0) {
        NB_TLV=40;
        for(i=0;i<10;i++) {
            d=(i==9)?0:(i+1); // point a droite du point i
            msh[i].i0=i; msh[i].i1=d; msh[i].i2=10+d;
            msh[i+10].i0=i; msh[i+10].i1=10+d; msh[i+10].i2=10+i;
            msh[i+20].i0=10+i; msh[i+20].i1=10+d; msh[i+20].i2=20+d;
            msh[i+30].i0=10+i; msh[i+30].i1=20+d; msh[i+30].i2=20+i;
        }
    } else
        NB_TLV=0;
    NB_TMT+=NB_TLV;
    NB_TRI+=NB_TLV;
    // Lecture du mesh propre au sujet
    for(i=NB_TLV;i<NB_TRI;i++) {
        fgets(fline,MAX_STRING,fid);
        sscanf(fline,"%d %d %d",&msh[i].i0,&msh[i].i1,&msh[i].i2);
    }
	// Lecture d'un eventuel mesh 'statique'
	if (fgets(fline,MAX_STRING,fid)&&(sscanf(fline,"%d",&NB_XTR)==1)) {
		for(i=NB_TRI;i<NB_TRI+((NB_XTR>0)?NB_XTR:(-NB_XTR));i++) {
          fgets(fline,MAX_STRING,fid);
          sscanf(fline,"%d %d %d",&msh[i].i0,&msh[i].i1,&msh[i].i2);
		}
	} else
		NB_XTR=0;

    fclose(fid);
    printf("  compose de %d triangles,\n",NB_TRI);
    printf("  dont %d pour l'analyse (%d pour les levres).\n",NB_TMT,NB_TLV);
	printf("  plus %d triangles fil-de-fer\n",NB_XTR);
}

// Lecture de positions 2D
void read_pos_all(char *filename, uv2D *pos)
{
    FILE *fid;
    char fline[MAX_STRING];
    int i,nb_pmv;

	nb_pmv=(NB_PMV>0)?NB_PMV:(-NB_PMV);
    fid=my_fopen(filename,"r");
    for(i=0;i<nb_pmv+NB_PFX;i++) {
        fgets(fline,MAX_STRING,fid);
        sscanf(fline,"%f %f",&pos[i].x,&pos[i].y);
    }
}

// Lecture de coordonnees 3D
void read_pts_mobiles(char *filename, pt3D *pts)
{
    FILE *fid;
    char fline[MAX_STRING];
    int i,nb_pmv;
		nb_pmv=(NB_PMV>0)?NB_PMV:(-NB_PMV);
    fid=my_fopen(filename,"r");
    for(i=0;i<nb_pmv;i++) {
        fgets(fline,MAX_STRING,fid);
        sscanf(fline,"%f %f %f",&pts[i].x,&pts[i].y,&pts[i].z);
    }
    fclose(fid);
}

// Lecture du fichier de configuration de texture du visage (-mdl) et mesh xtra
void read_tex(char *filename, float TEX_POIDS[MAX_TEX], char TEX_FILE[MAX_TEX][MAX_STRING])
{
    FILE *fid;
    char fline[2*MAX_STRING];
    char pts_name[MAX_STRING];
    char pos_name[MAX_STRING];
    int i;
	int abs_nb_tex;

    fid=my_fopen(filename,"r");
    // Lecture du nombre de textures
    fgets(fline, 2*MAX_STRING,fid);
    sscanf(fline,"%d",&NB_TEX);
    printf("Modele de texture (%d): %s\n",NB_TEX,filename);
	TOT_TEX+=(abs_nb_tex=((NB_TEX<0)?-NB_TEX:NB_TEX));
    for(i=0;i<abs_nb_tex;i++) {
        fgets(fline,2*MAX_STRING,fid);
        // Lecture du poids et des noms de fichier
        sscanf(fline,"%f %s %s %s",&TEX_POIDS[i],TEX_FILE[i],pts_name,pos_name);
        printf("  %f %s\n",TEX_POIDS[i],TEX_FILE[i]);
        read_pts_mobiles(pts_name,TEX_PTS3D[i]);
        read_pos_all(pos_name,TEX_POS2D[i]);
    }
    fclose(fid);

    // On retraite le mesh pour eviter les retournements !
    if (NB_TEX!=0) tex_wrap_uv(TEX_POS2D[0],NB_TRI+((NB_XTR>0)?NB_XTR:(-NB_XTR)),MSH);
}

// Lecture eventuelle d'un mouvement d'objet (translation+rotation)
void read_mov(char *filename, obj_mov mov[MAX_SEQ])
{
    FILE *fid;
    char fline[MAX_STRING];
    int ok;

    NB_MOV=0;
    fid=my_fopen(filename,"r");
    do {
      if ((ok=fgets(fline,MAX_STRING,fid)!=NULL)) {
				ok=sscanf(fline,"%f %f %f %f %f %f %f %f %f",
					&mov->tx,&mov->ty,&mov->tz,&mov->rx,
					&mov->ry,&mov->rz,&mov->cx,&mov->cy,&mov->cz);
				if (ok==3) {
					fgets(fline,MAX_STRING,fid);
					ok+=sscanf(fline,"%f %f %f",&mov->rx,&mov->ry,&mov->rz);
					fgets(fline,MAX_STRING,fid);
					ok+=sscanf(fline,"%f %f %f",&mov->cx,&mov->cy,&mov->cz);
				}
				if (ok==9) {
					mov->rx*=180.0/3.1415926535897932;
					mov->ry*=180.0/3.1415926535897932;
					mov->rz*=180.0/3.1415926535897932;
					mov++;
					NB_MOV++;
				}
      }
    } while (!feof(fid)&&(ok==9)&&(NB_MOV<MAX_SEQ));
    fclose(fid);
}
#ifdef USE_DENTS
// Lecture d'un fichier de descriptions des dents (inferieures ou superieures)
void read_dents( char *nom, pt3D **pts, int *nb, int mach,char **tex_file, char p2d_file[MAX_STRING] ){

  /* ce fichier contient 3 lignes:
     - le nom du fichier des points  afficher
    - les coordonnees du condyle (fichier machoire) ou le nombre de texture (1, fichier palais)
     - celui avec la texture
     - celui avec les points de la texture
  */

  FILE *fid = my_fopen( nom, "r");
  int i;
  char file[MAX_STRING];
  char fline[MAX_STRING];
  float d;
  pt3D *tmp;

  *tex_file = malloc(MAX_STRING*sizeof(char));

  // nom du fichier des points
  fgets(fline,MAX_STRING,fid);
  sscanf(fline,"%s\n",file);

  // coord du CONDYLE (machoire, ou nombre de textures)
  if (mach) {
    fgets(fline, MAX_STRING, fid);
    if (3==sscanf(fline,"%f %f %f %f %f %f\n", &(CONDYLE.x), &(CONDYLE.y), &(CONDYLE.z), &(MACH_ROT.x), &(MACH_ROT.y), &(MACH_ROT.z)))
	  MACH_ROT.x=1.0+(MACH_ROT.y=MACH_ROT.z=0.0); // Comportement par defaut
  }

  // fichiers de coordonnees pour les textures
  fgets(fline,MAX_STRING,fid);
  if (fline[0]!='#') {
	TOT_TEX++;
    sscanf(fline,"%s\n",*tex_file);
    if (mach) SLOT_MACH=1; else SLOT_PAL=1;
    fgets(fline,MAX_STRING,fid);
    sscanf(fline,"%s\n", p2d_file);
  }
  fclose(fid);

  // maintenant on lit les points  afficher
  fid = my_fopen( file, "r" );
  printf("Modele pour %s : %s\n",mach?"la machoire":"le palais",nom);
  fgets(fline,MAX_STRING,fid);
  sscanf(fline,"%d",nb);

  // si c'est la machoire, on lit l'indice de LT
  if ( mach ) {
    fgets(fline,MAX_STRING,fid);
    sscanf(fline,"%d",&IND_LT);
  } else {
  // sinon c'est l'indice UT
    fgets(fline,MAX_STRING,fid);
    sscanf(fline,"%d",&IND_UT);
  }

  tmp = (pt3D *) malloc(*nb*sizeof(pt3D));
  for (i=0; i<*nb; i++){
    fgets( fline, MAX_STRING, fid );
    sscanf( fline, "%f %f %f\n", &(tmp[i].x), &(tmp[i].y), &(tmp[i].z));
  }

  fclose( fid );
  *pts = tmp;
  printf("  compose de %d points (%s).\n",NB_PAL,file );
  if ((mach)?SLOT_MACH:SLOT_PAL)
    printf("  avec une texture (%s).\n",*tex_file);

  if (mach) {
    // calcul des donnees initiales du modele (machoire)
    LGM=sqrt(CONDYLE.x*CONDYLE.x+CONDYLE.y*CONDYLE.y+CONDYLE.z*CONDYLE.z);
    d=-(cos(ANG_JW)*CONDYLE.z+sin(ANG_JW)*CONDYLE.y);
    OM0=ANG_JW-acos(d/LGM);
  }

}
// Transfert d'un buffer image en une texture GL, identifiee par MINIM_TEX_ID[slot]
void Minim_raw2tex(unsigned char *tex_ptr, int tex_w,int tex_h, int img_w,int img_h, int my_slot) {
  glBindTexture(GL_TEXTURE_2D,MINIM_TEX_ID[my_slot]);
  // Configurations diverses du mode texture
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
   // Transfert effectif
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,tex_w,tex_h,0,GL_RGB,GL_UNSIGNED_BYTE,tex_ptr);
  glBindTexture(GL_TEXTURE_2D,0);

    // on memorise les caracteristiques pour l'utilisation
  TEX_MUL[my_slot].x=(float)img_w/tex_w;
  TEX_MUL[my_slot].y=(float)img_h/tex_h;
}

// Lecture d'une image avec Alpha (tiff ou BMP32), transfert en texture GL
void load_tif2tex(char *filename, int my_slot)
{
  int i;
	int failed=1;
  unsigned char *image      = (unsigned char *) NULL;
  int width, height;
	FILE *fid;
	BMP_INFO info;
	BMP_HEADER hdr;

	fid=my_fopen(filename,"rb");
	fread(&hdr,1,2,fid); // sizeof(BMP_HEADER)
	fread((sizeof(hdr)-12)+(unsigned char*)&hdr,1,12,fid);
	if (hdr.type==0x4d42) { // BMP !
		fread(&info,1,sizeof(BMP_INFO),fid);
		width=info.width;
		height=info.height;
//		fseek(fid,hdr.offset,SEEK_SET);
//		printf("%d %d %d %d\n",width,height,info.planes,info.bits);
		if ((info.planes==1)&&(info.bits==32)) {
		  image=(void *)malloc(4*width*height);
			for(i=height;--i>=0;)
				fread(image+4*i*width,4,width,fid);
			for(i=4*width*height;(i-=4)>=0;) {
				unsigned char swp;
				swp=image[i];
				image[i]=image[i+2]; // bgra -> rgba
				image[i+2]=swp;
				swp=image[i+3];
				image[i+3]=(swp==255)?0:255; // not A, sature
			}
			failed=0;
		}
		fclose(fid);
	} else { // Pas BMP !
	  fclose(fid);

#ifdef USE_TIFF
{
	int       res;
  TIFF*     sourceFile;
  uint32*   memoryS         = (uint32*)NULL;
	uint32 w,h;

  /* Open tiff file */
  sourceFile = TIFFOpen (filename, "r");
  if (sourceFile == (TIFF*)NULL) {
    printf ("Could not open file named %s for reading.\n", filename);
    exit (1);
  }
  /*
      *  Allocate memory for image pixels and load pixels from file
      *  swap the buffer
      */
  res = LoadPixels (sourceFile,(uint32**) &memoryS, &w, &h);
	width=(int)w;
	height=(int)h;
  if (res == 0) {
//    printf ("Swaping buffer\n");
    res = SwapBuffer ((uint32 **)&image, memoryS, w, h);
  }
  if (memoryS != (uint32*)NULL) {
    _TIFFfree ((tdata_t)memoryS);
    memoryS = (uint32*)NULL;
		failed=0;

		// Saturation du masque
		for (i=3; i<width*height*4; i+=4)
    if (image[i] != 0) {
      image[i]=255;
    }
  }
  TIFFClose (sourceFile);
}
#endif // USE_TIFF
}

  // Taille en puissance de 2 ?
  if (failed || (width&~-width) || (height&~-height) ) {
    printf("Format/taille d'image non reconnu :\n  pour %s\n",filename);
    return;
  }

  // Transfert de l'image en une texture GL, identifiee par MINIM_TEX_ID
  glBindTexture(GL_TEXTURE_2D,MINIM_TEX_ID[my_slot]);
  // Configurations diverses du mode texture
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
  // Transfert effectif
  glTexImage2D(GL_TEXTURE_2D,0,4,width,height,0,GL_RGBA,GL_UNSIGNED_BYTE,image);
  glBindTexture(GL_TEXTURE_2D,0);

}
#endif // USE_DENTS
#ifdef USE_EYES
// Lecture du fichier de descrition des yeux
void read_eyes_def(char *filename, eye_obj eyes[2])
{
	FILE *fid;
	char fline[MAX_STRING];
	int i;

	fid=my_fopen(filename,"r");
	for(i=0;i<2;i++) {
		fgets(fline,MAX_STRING,fid);
		sscanf(fline,"%f %f %f %f",&eyes[i].cx,&eyes[i].cy,&eyes[i].cz,&eyes[i].radius);
	}
	for(i=0;i<2;i++) {
		fgets(fline,MAX_STRING,fid);
		sscanf(fline,"%f %f %f %f",&eyes[i].dx,&eyes[i].dy,&eyes[i].dz,&eyes[i].radius2);
	}
	printf("Modele pour les yeux : %s\n",filename);
	// Y a t-il une texture ?
	if (fgets(fline,MAX_STRING,fid)&&(SLOT_EYES=(fline[0]!='#'))) {
	  float d2,d,l;
	  TOT_TEX++;
	  sscanf(fline,"%s",TEX_EYES_FILE);
	  printf("  avec texture : %s\n",TEX_EYES_FILE);
	  // setup des parametres de texture pour draw_eyes()
	  for(i=0;i<2;i++) {
	    d2=eyes[i].dx*eyes[i].dx+eyes[i].dy*eyes[i].dy+eyes[i].dz*eyes[i].dz;
		d=sqrt(d2);
	    l=(eyes[i].radius*eyes[i].radius-eyes[i].radius2*eyes[i].radius2-d2)/2/d;
		eyes[i].sc1=(eyes[i].radius+d+l)/2/eyes[i].radius;
		eyes[i].sc2=(eyes[i].radius2-l)/2/eyes[i].radius2;
	  }
	}
	fclose(fid);
}
#endif // USE_EYES
// Calcul de la puissance de 2 superieure ou egal
int next_pow2(int res)
{
  int i;

  while (res!=(i=res&-res))
	res+=i;

  return(res);
}

// Lecture d'une image .pnm, transfert en texture GL
void load_pnm2tex(char *filename, int my_slot)
{
    unsigned char *image=NULL;
    char garb[80];
    FILE *fid;
    char img_type;
    int img_w,img_h;
    int c;

    // Lecture de l'image qui deviendra une texture
    fid=my_fopen(filename,"rb");
    // Lecture des infos du header (PNM)
    fscanf(fid,"P%c ",&img_type);
    // Skip comments
    while ((c=getc(fid))=='#')
        fgets(garb,80,fid);
    ungetc(c,fid);
    fscanf(fid,"%d %d %*d",&img_w,&img_h);
    fgetc(fid);
    // Lecture des donnees (RGB raw) ssi l'image est reconnue (taille en puissance de 2)
    if ((img_type=='6')&&!(img_w&~-img_w)&&!(img_h&~-img_h)) {
	  image=malloc(3*img_w*img_h);
      fread(image,3,img_w*img_h,fid);
	  Minim_raw2tex(image, img_w,img_h, img_w,img_h, my_slot);
    } else {
	// Il va falloir se compliquer la vie...
	  int y,tex_w, tex_h;
	  unsigned char*ptr;

	  // arrondi a la taille superieure (puissance de 2)
	  tex_w=next_pow2(img_w);
	  tex_h=next_pow2(img_h);
// printf("  %dx%d -> %dx%d\n",img_w,img_h,tex_w,tex_h);

	  // on lit ligne a ligne
	  ptr=image=malloc(3*tex_w*tex_h);
	  for(y=0;y<img_h;y++,ptr+=3*tex_w)
		fread(ptr,3,img_w,fid);
	  Minim_raw2tex(image, tex_w,tex_h, img_w,img_h, my_slot);
	}
    fclose(fid);
    free(image);
}

void load_tex_img(char *filename,int my_slot)
{
    // L'extension est-elle ".tif" ou ".pnm" ?
    char *ext=filename+strlen(filename)-4;

	// Assez de slots de texture ?
	if (my_slot>=TOT_TEX) {
	  printf("\nERROR:\n  Cannot read texture #%d with %d reserved ones.\n\n",my_slot,TOT_TEX);
	  exit(-1);
	} else {
	  printf("Texture %2d: %s\n",my_slot,filename);
	}

	// Echelle par defaut
	TEX_MUL[my_slot].x=TEX_MUL[my_slot].y=1.0;

	// Choix du format
	if ( strcmp(ext,".pnm") == 0 )
		load_pnm2tex(filename,my_slot);
#ifdef USE_DENTS
	else if ( strcmp(ext,".tif") == 0 )
		load_tif2tex(filename,my_slot);
	else if ( strcmp(ext-1,".tiff") == 0 )
		load_tif2tex(filename,my_slot);
	else if ( (strcmp(ext,".bmp")==0) || (strcmp(ext,".BMP")==0) )
		load_tif2tex(filename,my_slot);
#endif // USE_DENTS
	else
		printf( "   Type non reconnu (.tif, .bmp ou .pnm) pour la texture %s\n",filename);
}

// Activation d'une texture deja memorisee
void bind_tex2D(int my_slot)
{
  GLint old;

  glBindTexture(GL_TEXTURE_2D,MINIM_TEX_ID[my_slot]);
  glGetIntegerv(GL_MATRIX_MODE,&old);
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  glScalef(TEX_MUL[my_slot].x,TEX_MUL[my_slot].y,1.0);
  glMatrixMode(old);
}
// Mise a jour eventuelle de l'image du fond
void update_pause(int frame_nb, int verb)
{
  char *tex_name=strdup(TEX_BACK);
  int  i,ptr,ptr0=strlen(tex_name)-5;

  // Y a-t-il une texture a mettre a jour ?
  if (USE_BACK&&USE_BACKI&&(ptr0>=0)) {
	// on incremente ce qu'on trouve...
	for (i=0;i<frame_nb;i++) {
	  tex_name[ptr=ptr0]++;
	  // flip _A ou _B  ?
	  if ((ptr>=2)&&(tex_name[ptr]=='C')) {
		tex_name[ptr]='A';
		ptr-=2;
		tex_name[ptr]++;
	  }
	  // retenue a propager sur des chiffres ?
	  while ((ptr>0)&&(tex_name[ptr]=='9'+1)) {
		tex_name[ptr]='0';
		tex_name[--ptr]++;
	  }
	}
	// on charge
	if (verb) printf("Paused at frame: %d/%d %s\n",frame_nb,ART_MAX-1,tex_name);
	load_tex_img(tex_name,SLOT_BACK);
  } else {
	// il n'y avait rien a lire !
	if (verb) printf("Paused at frame: %d/%d\n",frame_nb,ART_MAX-1);
  }
  free(tex_name);
}
// ---- GESTION DU SON
#ifdef USE_AUDIO
int init_wav(int dev, int iDataBits, int iChannel,unsigned long ulSamplingRate)
{
#ifdef USE_AUDIO_LINUX
//  if ( ioctl(dev,SNDCTL_DSP_GETBLKSIZE,&m_DSPblkSize) < 0 )
//    return 0;
  //if (m_DSPblkSize < 4096 || m_DSPblkSize > 65536)
  //  return FALSE;
	int memb=iDataBits, memc=iChannel;
	unsigned long mems=ulSamplingRate;
  if (( ioctl(dev,SNDCTL_DSP_SAMPLESIZE,&iDataBits)<0 ) || (memb!=iDataBits)) {
		printf("!!! Can't switch to %d bits audio samples (%d).\n",memb,iDataBits);
    return 0;
	}
  if ((ioctl(dev,SNDCTL_DSP_STEREO,&iChannel)<0) || (memc!=iChannel)) {
		printf("!!! Can't set %d audio channels (%d).\n",memc,iChannel);
    return 0;
	}
  if ((ioctl(dev,SNDCTL_DSP_SPEED,&ulSamplingRate) < 0 ) || (mems!=ulSamplingRate)) {
		printf("!!! Can't set %ld Hertz (%ld).\n",mems,ulSamplingRate);
		return 0;
	}
//  if ( fcntl(dev,F_SETFL,O_NONBLOCK) <0)
//    return 0;
	if ( ioctl(dev,SNDCTL_DSP_NONBLOCK) < 0 )
    return 0;
#endif // Linux
  return -1;
}

void open_wav(char *filename,int verb)
{
    FILE *fid;
    myWAVEFORMAT fmt;
    int ok;
	int force_stereo=0;
    float fps;
    unsigned char tmp[128];

	fid=my_fopen(filename,"rb");
    ok=(fread(&tmp,8,1,fid))&&(memcmp(tmp,"RIFF",4)==0);

		if (ok) { // Format WAV
			fscanf(fid,"WAVEfmt ");
			ok=ok&&(ftell(fid)==16L)&&fread(&fmt,sizeof(myWAVEFORMAT),1,fid);
			if (fmt.uiChannels==0) fmt.uiChannels=1;
			if (fmt.uiSize-sizeof(myWAVEFORMAT)+4)
					ok=ok&&fread(&fmt,fmt.uiSize-sizeof(myWAVEFORMAT)+4,1,fid);
			ok=ok&&fread(&tmp,4,1,fid)&&(memcmp(tmp,"data",4)==0);
			ok=ok&&fread(&tmp,4,1,fid);
			WAV_SIZ=tmp[0]+256*(tmp[1]+256*(tmp[2]+256*tmp[3]));
		} else { // Format ECH ?
			ok=fread(tmp+8,120,1,fid); // lecture de la fin de l'entete
			fmt.uiChannels=1; // Mono
			fmt.ulSamplesPerSec=tmp[122]+256*tmp[123];
			while(tmp[120]--) fmt.ulSamplesPerSec*=10;
			fmt.uiBitsPerSample=16; // 16 bits par echantillon
			WAV_SIZ=2*(tmp[14]+256*(tmp[15]+256*(tmp[16]+256*tmp[17]))); // en octets
		}

    if (!ok) {
        fclose(fid);
        printf("Error, file '%s' not understood as a .WAV or .ECH\n",filename);
        exit(1);
    }

		// Devinette du frame rate...
    if (F_RATE<0) {
        fps=1/300.0*(int)(.5+300.0*(float)(ART_MAX+1)/(8.0*WAV_SIZ/fmt.uiChannels/fmt.ulSamplesPerSec/fmt.uiBitsPerSample));
				printf("  pour un debit probable de %d FPS.\n",(int)(F_RATE=fps));
		}

		// Calcul du flux audio pour 12 fps
		MAX_AWR=fmt.ulSamplesPerSec/12*fmt.uiChannels*fmt.uiBitsPerSample/8;

		if (verb) printf("Piste sonore a %ld Hz, %dx%d bits, %3f seconde(s) :\n  %s\n", \
		fmt.ulSamplesPerSec,fmt.uiChannels,fmt.uiBitsPerSample, \
		8.0*WAV_SIZ/fmt.uiChannels/fmt.ulSamplesPerSec/fmt.uiBitsPerSample, filename);

#ifdef USE_AUDIO_LINUX
	// Faut-il fermer et rouvrir le device audio ?
	if (WAV_DEV) {
	  close(WAV_DEV);
	  WAV_DEV=0;
	}
	ok&=((WAV_DEV=open(myAUDIODEV,O_WRONLY,0))!=-1);
	if (ok) {
	  if ((!init_wav(WAV_DEV,(int)fmt.uiBitsPerSample,fmt.uiChannels-1,fmt.ulSamplesPerSec))&&(fmt.uiChannels==1))
		force_stereo=ok=init_wav(WAV_DEV,(int)fmt.uiBitsPerSample,fmt.uiChannels-1+1,fmt.ulSamplesPerSec);
	}

    if (!ok) {
      if (WAV_DEV) close(WAV_DEV);
	  fclose(fid);
      printf("\n%c!!! Impossible d'ouvrir le peripherique audio !\n\n",7);
	  WAV_DEV=0;
	  return;
//      exit(1);
    }

	if (force_stereo) {
	  register unsigned short int *src, *dst;
	  int i;
	  printf(" !!! Forcing stereo\n");
	  ok&=((WAV_DAT=malloc(2*WAV_SIZ))!=NULL);
	  fread(WAV_DAT,1,WAV_SIZ,fid);
	  src=WAV_DAT+WAV_SIZ;
	  dst=WAV_DAT+WAV_SIZ*2;
	  for(i=WAV_SIZ/2;--i>=0;) {
		*(--dst)=*(--src);
		*(--dst)=*src;
	  }
	  WAV_SIZ*=2;
	} else {
	  ok&=((WAV_DAT=malloc(WAV_SIZ))!=NULL);
	  fread(WAV_DAT,1,WAV_SIZ,fid);
	}
#endif // Linux

#ifdef USE_AUDIO_WIN
		fseek(fid,0L,SEEK_END);
		WAV_SIZ=ftell(fid);
		WAV_DAT=malloc(WAV_SIZ);
		fseek(fid,0L,SEEK_SET);
		fread(WAV_DAT,1,WAV_SIZ,fid);
#endif // Win

  fclose(fid);
}
#endif // USE_AUDIO

// lecture d'une configuration logos/art/wav_file
void read_logo(char *filename)
{
	FILE *fid;
	char fline[MAX_STRING];
	char tmp[MAX_STRING];
	int x0,y0,w,h;
	int bw,bh;
	void *art_dat;

#ifdef USE_DICT
	NB_MOTS_VUS=0;
#endif // USE_DICT
	NB_LOGO=0;
	fid=my_fopen(filename,"r");
	if (fgets(fline,MAX_STRING,fid)) {
	  // On a une texture en fond :
	  TOT_TEX++;
	  sscanf(fline,"%dx%d %s ",&bw,&bh,TEX_BACK);
	}
	do if (fgets(fline,MAX_STRING,fid)) {
	  if(sscanf(fline,"%dx%d+%d+%d",&w,&h,&x0,&y0)==4) {
			// Bounding Box
			x0-=4;y0-=4;w+=8;h+=8;
			LOGOS[NB_LOGO].x0=(float)x0*2.0/bw-1.0;
			LOGOS[NB_LOGO].y0=1.0-(float)y0*2.0/bh;
			LOGOS[NB_LOGO].x1=(float)(x0+w)*2.0/bw-1.0;
			LOGOS[NB_LOGO].y1=1.0-(float)(y0+h)*2.0/bh;
#ifdef USE_DICT
			LOGOS[NB_LOGO].idx_seg=NB_MOTS_VUS;
			SEG_START[NB_MOTS_VUS]=1<<31;
#endif // USE_DICT
			// Art associe (sauf derniere BB) :
			if (fgets(fline,MAX_STRING,fid)) {
				sscanf(fline,"%s ",tmp);
				read_art(tmp,0);
				art_dat=malloc(sizeof(ART));
				bcopy(ART,art_dat,sizeof(ART));
			} else {
				art_dat=NULL;
				ART_MAX=0;
			}
#ifdef USE_DICT
			NB_MOTS_VUS++;
#endif // USE_DICT
			// Wav associe :
			if (fgets(fline,MAX_STRING,fid)) {
				sscanf(fline,"%s ",tmp);
//				if (NB_LOGO) close(WAV_DEV);
				open_wav(tmp,0);
			} else {
				WAV_DAT=NULL;
				WAV_SIZ=0;
			}
			LOGOS[NB_LOGO].art_max=ART_MAX;
			LOGOS[NB_LOGO].art=art_dat;
			LOGOS[NB_LOGO].wav_dat=WAV_DAT;
			LOGOS[NB_LOGO].wav_siz=WAV_SIZ;
		}
		NB_LOGO++;
	} while (!feof(fid)&&(NB_LOGO<MAX_LOGO));
	fclose(fid);

	printf("Configuration a %d logos :\n  %s\n",NB_LOGO,filename);

	// Pas de (re)demarrage automatique des sequences !
	LOOP=0;
	WAV_PTR=-1;
//	Minim_stop_msg();
}

// ---- Gestion de l'Eye Tracker
#ifdef USE_TET

typedef struct {
	float X;
	float Y;
	int zone;
	long int rdv;
	float col;
	int click;
	int off;
	long int rdv_oeillade_s;
	long int rdv_oeillade_ms;
} TET_state;

TET_state myTET_state={0.0,0.0, 0, 0L, 0.0, 0,0, 0L,0L};

int TET_ACTIF=0;
#endif // USE_TET

void mouse_mov_handler(int x, int y)
{
#ifdef USE_TET
	if (TET_ACTIF) {
		myTET_state.off=0;
		myTET_state.X=x*2.0/MINIM_WIDTH-1.0;
		myTET_state.Y=1.0-y*2.0/MINIM_HEIGHT;
    }
#endif // USE_TET
}

#ifdef USE_TET_WIN
/* Prints latest error on stdout */
void PrintError(void)
{
	char pError[255];
	Tet_GetLastErrorAsText(pError);
	printf("Erreur TET:\n  %s\n",pError);
}

// Traitant des pacquets envoyes par Tobii
void  __stdcall MyGazeDataReceiver(ETet_CallbackReason reason, STet_GazeData *pGazeData, void *appData)
{
	float x,y;
	unsigned int val;
	TET_state *myState=(TET_state *)appData;

	// On choisit le meilleur (ou la combinaison)
	val=pGazeData->validity_righteye;
	if (pGazeData->validity_lefteye==val) {
		x=(pGazeData->x_gazepos_lefteye+pGazeData->x_gazepos_righteye)/2.0;
		y=(pGazeData->y_gazepos_lefteye+pGazeData->y_gazepos_righteye)/2.0;
	} else {
		if (pGazeData->validity_lefteye>pGazeData->validity_righteye) {
			x=pGazeData->x_gazepos_righteye;
			y=pGazeData->y_gazepos_righteye;
		} else {
			val=pGazeData->validity_lefteye;
			x=pGazeData->x_gazepos_lefteye;
			y=pGazeData->y_gazepos_lefteye;
		}
	}

	// On met a jour (en oubliant les clignements !)
	if (val<=2) {
		myState->off=0;
		myState->X=x*2-1.0;
		myState->Y=1.0-y*2;
	} else {
		myState->off++;
		myState->click++;
	}
}

// thread pour la reception "bloquante"
void track_thread()
{
	// Connexion a un serveur local
	if (Tet_Connect("127.0.0.1", SERVER_PORT_NUMBER, NULL) ) {
	 	PrintError();
		Tet_Disconnect();
		return;
	} else {
		TET_ACTIF=1;
	}

	if (Tet_Start(MyGazeDataReceiver,(void *)&myTET_state,0))
	  PrintError();
}

// Chargement d'une calibration (via une connection)
void track_cal(char *cal_name)
{
	char cal_file[255];
	sprintf(cal_file,"C:\\Program Files\\Tobii\\ClearView\\Application Data\\ClearViewData\\Subjects\\%s\\Calibrations\\%s\\%s.cd",cal_name,cal_name,cal_name);

	// Connexion a un serveur local
	if (Tet_Connect("127.0.0.1", SERVER_PORT_NUMBER, NULL) ) {
	 	PrintError();
		Tet_Disconnect();
		return;
	} else {
		TET_ACTIF=1;
	}

	// Memorisation d'un fichier de calibration
	if (Tet_CalibLoadFromFile(cal_file)) {
		PrintError();
		Tet_Disconnect();
		return;
	} else
		printf("Calibration TET :\n  %s\n",cal_file);

	Tet_Disconnect();
}

void track_start(char *cal_name)
{
	// Creation d'un fils...
	_beginthread(track_thread,0,NULL);
	// Chargement d'une calibration
	track_cal(cal_name);
}

#endif // USE_TET_WIN

// ---- SAUVEGARDES OPTIONNELLES DES RESULTATS

// Sauvegarde de l'image resultat
void save_img2pnm(unsigned char *image, char *filename)
{
    FILE *fid;
    int y;

    fid=fopen(filename,"wb");
    if (fid!=NULL) {
        fprintf(fid,"P6\n%d %d\n255\n",MINIM_WIDTH,MINIM_HEIGHT);
        for (y=3*MINIM_HEIGHT*MINIM_WIDTH;(y-=3*MINIM_WIDTH)>=0;)
            fwrite(image+y,3,MINIM_WIDTH,fid);
        fclose(fid);
    } else {
	  printf("Can't create PNM file %s\n",filename);
	  exit(-1);
    }
}

void save_img2bmp(unsigned char *image, char *filename)
{
    FILE *fid;
    BMP_HEADER hdr={0x4d42,3*MINIM_WIDTH*MINIM_HEIGHT+0x66,0,0,0x36};
    BMP_INFO   info={0x28,MINIM_WIDTH,MINIM_HEIGHT,1,24,0,3*MINIM_WIDTH*MINIM_HEIGHT,0xb6d,0xb6d,0,0};

    fid=fopen(filename,"wb");
    if (fid!=NULL) {
	  fwrite(&hdr,1,2,fid);  // BMP_HEADER should be packed...
      fwrite((sizeof(hdr)-12)+(unsigned char*)&hdr,1,12,fid);  // should be sizeof(hdr) !
      fwrite(&info,1,sizeof(info),fid); // 40 ??
      fwrite(image,3*MINIM_HEIGHT,MINIM_WIDTH,fid);
      fclose(fid);
    } else {
	  printf("Can't create BMP file %s\n",filename);
	  exit(-1);
    }
}

unsigned char *Minim_gl2pnm(unsigned char *image)
{
  glFinish();
  if (image==NULL)
	image=(unsigned char *)malloc(3*MINIM_WIDTH*MINIM_HEIGHT);
  glReadPixels(0,0,MINIM_WIDTH,MINIM_HEIGHT,GL_RGB,GL_UNSIGNED_BYTE,image);
  return(image);
}

unsigned char *Minim_gl2bmp(unsigned char *image)
{
  glFinish();
  if (image==NULL)
  image=(unsigned char *)malloc(3*MINIM_WIDTH*MINIM_HEIGHT);
  // BGR, ou RGB -> BGR
#ifdef __UNIX__
  glReadPixels(0,0,MINIM_WIDTH,MINIM_HEIGHT,GL_BGR,GL_UNSIGNED_BYTE,image);
#else
  glReadPixels(0,0,MINIM_WIDTH,MINIM_HEIGHT,GL_RGB,GL_UNSIGNED_BYTE,image);
  {
	register int i;
	register unsigned char swp;

	for(i=0;i<3*MINIM_HEIGHT*MINIM_WIDTH;i+=3) {
	  swp=image[i];
	  image[i]=image[i+2];
	  image[i+2]=swp;
	}
  }
#endif
  return(image);
}

// Sauvegarde des coordonnees 3D
void save_pts3D(char *filename)
{
    FILE *fid;
    int i,n_pmv;
//~ pt3D *PTS=OBJS[0].pts;
		n_pmv=(NB_PMV>0)?NB_PMV:(-NB_PMV);
  //~ n_pmv=OBJS[0].nb_pts_calc;

    fid=fopen(filename,"w");
    for(i=0;i<n_pmv+NB_PFX;i++) {
        fprintf(fid,"%f %f %f\n",PTS[i].x,PTS[i].y,PTS[i].z);
    }
    fclose(fid);
}

// Sauvegardes des positions 2D de texture
void save_pos2D(char *filename)
{
    FILE *fid;
    int i;
    double mat_obj[16];
    int viewport[4];
    double x,y,depth;

    // !!! On n'utilise seulement la premiere camera

    // Lecture du contexte GL
    glGetIntegerv(GL_VIEWPORT,viewport);
    glGetDoublev(GL_MODELVIEW_MATRIX,mat_obj);

    fid=fopen(filename,"w");
    for(i=0;i<((NB_PMV<0)?-NB_PMV:NB_PMV)+NB_PFX;i++) {
        gluProject(PTS[i].x,PTS[i].y,PTS[i].z,mat_obj,CAM[0],
		   viewport,&x,&y,&depth);
        // Normalisation dans [0-1[ et compensation du tete-beche
        fprintf(fid,"%f %f\n",x/MINIM_WIDTH,(MINIM_HEIGHT-y)/MINIM_HEIGHT);
    }
    fclose(fid);
}

#ifdef USE_DENTS
// Sauvegarde des coordonnees 3D des dents
void save_pts3D_pal(char *filename)
{
    FILE *fid;
    int i;

    glMatrixMode(GL_PROJECTION);
    glLoadMatrixd(CAM[1]);
    glFrontFace(CAM_MIRROR[1]? GL_CW : GL_CCW);

    fid=fopen(filename,"w");
    for(i=0;i<NB_PAL;i++) {
        fprintf(fid,"%f %f %f\n",PAL[i].x,PAL[i].y,PAL[i].z);
    }
    fclose(fid);
}


// Sauvegardes des positions 2D de texture pour les dents
void save_pos2D_pal(char *filename, int mach)
{
	FILE *fid;
	int i,cam;
	double mat_cam[16],mat_obj[16];
	int viewport[4];
	double x,y,depth;
	float d,omega;
	pt3D ptLT = PTS[IND_LT+29];

	if ( NB_CAM > 2 )
		cam = 2;
	else
      cam = 0;
	//~ cam = 3;

	glMatrixMode(GL_PROJECTION);
	glLoadMatrixd(CAM[cam]);
	glFrontFace(CAM_MIRROR[cam]? GL_CW : GL_CCW);

	// Lecture du contexte GL
	glGetIntegerv(GL_VIEWPORT,viewport);
	glGetDoublev(GL_PROJECTION_MATRIX,mat_cam);
	glGetDoublev(GL_MODELVIEW_MATRIX,mat_obj);

	fid=fopen(filename,"w");
	if ( mach ) {
      // calcul de l'angle actuel
      d=-cos(ANG_JW)*(CONDYLE.z-ptLT.z)-sin(ANG_JW)*(CONDYLE.y-ptLT.y);
      omega=(ANG_JW-acos(d/LGM)-OM0)*180/(2*acos(0.0)); // en degres pour gl.
      glMatrixMode(GL_MODELVIEW);

      glTranslatef(ptLT.x, ptLT.y, ptLT.z);
      glRotatef(omega, MACH_ROT.x, MACH_ROT.y, MACH_ROT.z);

      glGetIntegerv(GL_VIEWPORT,viewport);
      glGetDoublev(GL_PROJECTION_MATRIX,mat_cam);
      glGetDoublev(GL_MODELVIEW_MATRIX,mat_obj);

      for(i=0;i<NB_MACH;i++) {
			gluProject(MACH[i].x,MACH[i].y,MACH[i].z,
							mat_obj,mat_cam,viewport,&x,&y,&depth);
			fprintf(fid,"%f %f\n",x/MINIM_WIDTH,(MINIM_HEIGHT-y)/MINIM_HEIGHT);
      }
	}
	else {
      for(i=0;i<NB_PAL;i++) {
			gluProject(PAL[i].x,PAL[i].y,PAL[i].z,mat_obj,mat_cam,
								viewport,&x,&y,&depth);
			// Normalisation dans [0-1[ et compensation du tete-beche
			fprintf(fid,"%f %f\n",x/MINIM_WIDTH,(MINIM_HEIGHT-y)/MINIM_HEIGHT);
      }
	}
	fclose(fid);
}

#endif // USE_DENTS
// ---- CALCUL DES TRANSPARENCES DE TEXTURE
void set_alpha()
{
    int i_tex,i_points,n_pmv;
    float dist, norm;
    float dx,dy,dz;

    norm=0.0;    // Somme partielle des transparences
		n_pmv=(NB_PMV>0)?NB_PMV:(-NB_PMV);
    for(i_tex=0;i_tex<NB_TEX;i_tex++) {
        dist=0.0; // Somme partielle des distances point a point
        for(i_points=0;i_points<n_pmv;i_points++) {
            dx=PTS[i_points].x-TEX_PTS3D[i_tex][i_points].x;
            dy=PTS[i_points].y-TEX_PTS3D[i_tex][i_points].y;
            dz=PTS[i_points].z-TEX_PTS3D[i_tex][i_points].z;
            dist+=sqrt(dx*dx+dy*dy+dz*dz);
        }
        norm+=(TEX_ALPHA[i_tex]=exp(-TEX_POIDS[i_tex]*dist)+.000001);
	// Non nul !
    }
    // Renormalisation a 1 de la somme des transparences
    for(i_tex=0;i_tex<NB_TEX;i_tex++)
        TEX_ALPHA[i_tex]/=norm;

}

// ---- UTILISATION d'OpenGL

void attach_glut();

// On place le repere pour la tete (et ses sous-objets)
void move_head()
{
    obj_mov mov;
  /*
static float a1=0,a2=0;
float dx,dy,dz;
dx=8*cos(a1)*cos(a2);
dy=8*cos(a1)*sin(a2);
dz=3*sin(a1);
a1+=.037/3.0;
a2+=.041/3.0;
*/
    mov=OBJ_MOV[(ART_CNT<NB_MOV)?ART_CNT:0];

    // Avant d'utiliser l'objet...
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

//glTranslatef(dx,dy,dz);

    // ...  on lui applique un mouvement rigide (rotation + translation)
    glTranslatef(mov.tx, mov.ty, mov.tz);
    glTranslatef(mov.cx, mov.cy, mov.cz);
    glRotatef(mov.rx-OBJ_ROT[0], 1.0, 0.0, 0.0);
    glRotatef(-mov.ry-OBJ_ROT[1], 0.0, 1.0, 0.0);
    glRotatef(mov.rz, 0.0, 0.0, 1.0);
    glTranslatef(-mov.cx, -mov.cy, -mov.cz);
    // pour amener son repere intrinseque "sur" l'image
}

// Affichage d'une image en fond de fenetre ou effacage du fond
void draw_background()
{
	GLenum gl_md=GL_DEPTH_BUFFER_BIT;

#ifdef USE_EYES
	// S'il y a des yeux a afficher... on efface le stencil
	if (NB_TMSK>0) {
	  glClearStencil(0);
	  gl_md|=GL_STENCIL_BUFFER_BIT;
	}
#endif // USE_EYES

	// S'il n'y a pas d'image de fond a afficher, on efface tous les buffers utiles
	if ((!USE_BACK)||USE_UNPROJ) {
	  glClearColor(BACK_R,BACK_G,BACK_B,1.0);
	  glClear(gl_md | GL_COLOR_BUFFER_BIT);
	  return;
	}

	// Sinon on va l'effacer en 2 fois :

    // ... Z-buffer (voire stencil)
    glClear(gl_md);
		// ... et plan image par des triangles textures
    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
    glFrontFace(GL_CCW);
    glEnable(GL_TEXTURE_2D);

    // On active la texture du fond
    bind_tex2D(SLOT_BACK);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

    // On reconfigure le mode de trace
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    // Plus de lecture ni d'ecriture du Z-buffer
    glDisable(GL_DEPTH_TEST);
    glDepthMask(GL_FALSE);

    // On cree un quadrilatere texture (tete-beche) qui recouvre tout l'ecran
    glBegin(GL_QUADS);
        glTexCoord2f(0.0,1.0); glVertex2f(-1.0,-1.0);
        glTexCoord2f(1.0,1.0); glVertex2f(1.0,-1.0);
        glTexCoord2f(1.0,0.0); glVertex2f(1.0,1.0);
        glTexCoord2f(0.0,0.0); glVertex2f(-1.0,1.0);
    glEnd();

    glBindTexture(GL_TEXTURE_2D,0);

    // On restaure le contexte de trace
    glDisable(GL_TEXTURE_2D);
    glEnable(GL_DEPTH_TEST);
    glDepthMask(GL_TRUE);

}

// Variable globale : pointeur vers la function de redraw (client, ou interne par defaut)
void (*DO_draw_background)()=draw_background;

// Function qui retourne le pointeur de la fonction d'affichage du fond par defaut,
// et memorise celle voulue par le client externe (si non NULL), ou restaure
// le comportement par defaut.
void ( *Minim_myBackgroundFunc(void (*back_func)()) )()
{
  DO_draw_background=(back_func==NULL)?draw_background:back_func;
  return draw_background;
}

// Affichage de l'objet tete
void draw_head()
// dessine les triangles du modele de visage, avec les textures
// ou en fil de fer
{
  int i,i_tex;
  int i0,i1,i2;
//  int front_face;

  int nb_tri;
  nb_tri=NB_TRI-((NB_TMSK>0)?NB_TMSK:0);

	// mode fil de fer/points ou  texture ?
  if ((NB_TEX<=0)||(nb_tri<0)) {
	if (nb_tri>=0) {
	  // Cas simple du fil de fer
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glColor4f(1.0,0.0,0.0,1.0);
//		glColor4f(1.0, 1.0, 1.0, 1.0);
	  glBegin(GL_TRIANGLES);
	  for(i=0;i<nb_tri;i++) {
		  glVertex3f(PTS[MSH[i].i0].x,PTS[MSH[i].i0].y,PTS[MSH[i].i0].z);
		  glVertex3f(PTS[MSH[i].i1].x,PTS[MSH[i].i1].y,PTS[MSH[i].i1].z);
		  glVertex3f(PTS[MSH[i].i2].x,PTS[MSH[i].i2].y,PTS[MSH[i].i2].z);
	  }
	  glEnd();
	} else {
	  // Rendu points
	  glPointSize(4.0);
	  glColor4f(0.0,0.0,0.0,1.0);
	  glBegin(GL_POINTS);
	  for(i=0;i<NB_PMV+NB_XTR;i++)
		glVertex3f(PTS[i].x,PTS[i].y,PTS[i].z);
	  glEnd();
	}
  } else {
/*
      // une premiere passe pour le dos des polygones: en sombre
      // on les remplit, et on change le 'FRONT_FACE', puisqu'on les trace
      // dans le meme ordre mais on veut que ce soit l'arrire qui soit colore
      glGetIntegerv(GL_FRONT_FACE,&front_face);
      glFrontFace(front_face==GL_CCW ? GL_CW : GL_CCW);
      glDisable(GL_DEPTH_TEST);
      glPolygonMode(GL_BACK,GL_FILL);
      glColor4f(0.4, 0.0, 0.0, 1.0);
      glBegin(GL_TRIANGLES);
      for(i=0;i<nb_tri;i++) {
				glVertex3f(PTS[MSH[i].i0].x,PTS[MSH[i].i0].y,PTS[MSH[i].i0].z);
				glVertex3f(PTS[MSH[i].i1].x,PTS[MSH[i].i1].y,PTS[MSH[i].i1].z);
				glVertex3f(PTS[MSH[i].i2].x,PTS[MSH[i].i2].y,PTS[MSH[i].i2].z);
      }
      glEnd();
      glEnable(GL_DEPTH_TEST);
      // on remet le "front_face" pour que la texture soit plaquee du bon cote
      glFrontFace(front_face==GL_CCW ? GL_CCW : GL_CW);
*/
      // Calcul des coefficients de transparence
      set_alpha(PTS,TEX_ALPHA);

      // On va utiliser des triangles pleins, avec texture,
      // partiellement transparente
      glPolygonMode(GL_FRONT,GL_FILL);
      glEnable(GL_TEXTURE_2D);
      glEnable(GL_BLEND);

      // !!! A desactiver pour voir les auto-collisions de triangles !!!
      //glDisable(GL_DEPTH_TEST);
      glEnable(GL_DEPTH_TEST);

      // Rendu multi-passes
      for(i_tex=0;i_tex<NB_TEX;i_tex++) {
				// On active une des textures...
				bind_tex2D(MINIM_NB_TEX_PLUS+i_tex);
				glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
				// ... avec la transparence calculee
				glColor4f(0.0,0.0,0.0,TEX_ALPHA[i_tex]);
				// Toutes sont transparentes. La premiere ecrase le fond eventuel
				glBlendFunc(GL_SRC_ALPHA,(i_tex==0)?GL_ZERO:GL_ONE);
				// et on trace tous les triangles
				glBegin(GL_TRIANGLES);
				for(i=0;i<nb_tri;i++) {
					i0=MSH[i].i0;
					i1=MSH[i].i1;
					i2=MSH[i].i2;
					glTexCoord2f(TEX_POS2D[i_tex][i0].x-MSH[i].d0,TEX_POS2D[i_tex][i0].y);
					glVertex3f(PTS[i0].x,PTS[i0].y,PTS[i0].z);
					glTexCoord2f(TEX_POS2D[i_tex][i1].x-MSH[i].d1,TEX_POS2D[i_tex][i1].y);
					glVertex3f(PTS[i1].x,PTS[i1].y,PTS[i1].z);
					// Positions 2D et coordonnees 3D du dernier point du ieme triangle
					glTexCoord2f(TEX_POS2D[i_tex][i2].x-MSH[i].d2,TEX_POS2D[i_tex][i2].y);
					glVertex3f(PTS[i2].x,PTS[i2].y,PTS[i2].z);
				}
				glEnd();
				glBindTexture(GL_TEXTURE_2D,0);
      }

      glDisable(GL_TEXTURE_2D);
      glDisable(GL_BLEND);

    }

	// On trace les eventuels triangles 'extra'
	if (NB_XTR>=0) {
		glPolygonMode(GL_FRONT,GL_LINE);
		glColor4f(0.6, 0.3, 0.3, 1.0);

		if ((NB_TEX!=0)&USE_TEX_XTRA) {
			glPolygonMode(GL_FRONT,GL_FILL);
			glEnable(GL_TEXTURE_2D);
		} else {
//			glColor4f(0.3, 1.0, 0.3, 1.0);
			glPolygonMode(GL_FRONT,GL_LINE);
		}
		i_tex=0;
		bind_tex2D(MINIM_NB_TEX_PLUS+i_tex);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
		glBegin(GL_TRIANGLES);
		for(i=NB_TRI;i<NB_TRI+NB_XTR;i++) {
			i0=MSH[i].i0;
			i1=MSH[i].i1;
			i2=MSH[i].i2;
			glTexCoord2f(TEX_POS2D[i_tex][i0].x-MSH[i].d0,TEX_POS2D[i_tex][i0].y);
			glVertex3f(PTS[i0].x,PTS[i0].y,PTS[i0].z);
			glTexCoord2f(TEX_POS2D[i_tex][i1].x-MSH[i].d1,TEX_POS2D[i_tex][i1].y);
			glVertex3f(PTS[i1].x,PTS[i1].y,PTS[i1].z);
			// Positions 2D et coordonnees 3D du dernier point du ieme triangle
			glTexCoord2f(TEX_POS2D[i_tex][i2].x-MSH[i].d2,TEX_POS2D[i_tex][i2].y);
			glVertex3f(PTS[i2].x,PTS[i2].y,PTS[i2].z);
		}
		glEnd();
		glBindTexture(GL_TEXTURE_2D,0);
		glDisable(GL_TEXTURE_2D);
	}

}

// Retro-projection de l'objet tete
void draw_head_rev()
// reprojecte les triangles du modele de visage :
// depuis la texture de fond vers l'image
{
  int i,i_tex=0;
  int i0,i1,i2;
  static double lex[MAX_PTS], ley[MAX_PTS], lez;

  GLdouble model[16];
  GLint view[4];

  int nb;

  // On recupere le contexte de projection :
  glGetDoublev(GL_MODELVIEW_MATRIX,model);
  //La matrice de projection, c'est l'une des CAM... la 0 par exemple !
  glGetIntegerv(GL_VIEWPORT,view);

    // On va utiliser des triangles pleins, avec texture,
    glPolygonMode(GL_FRONT,GL_FILL);
    glEnable(GL_TEXTURE_2D);
	glDisable(GL_CULL_FACE);

    // !!! A desactiver pour voir les auto-collisions de triangles !!!
    glDisable(GL_DEPTH_TEST);
    //glEnable(GL_DEPTH_TEST);

	// On active la texture du fond
	bind_tex2D(SLOT_BACK);
	glMatrixMode(GL_TEXTURE);
	glLoadIdentity();
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

	// on projette tous les points
	nb=(NB_PMV>0)?NB_PMV:-NB_PMV;
	for(i=0;i<nb;i++) {
//printf("%f %f %f\n",PTS[i].x,PTS[i].y,PTS[i].z);
	  gluProject(PTS[i].x,PTS[i].y,PTS[i].z,model,CAM[USE_UNPROJ-1],view,&lex[i],&ley[i],&lez);
	  lex[i]=lex[i]/((float)MINIM_WIDTH)*TEX_MUL[SLOT_BACK].x;
	  ley[i]=(1.0-ley[i]/((float)MINIM_HEIGHT))*TEX_MUL[SLOT_BACK].y;
//printf("%f %f\n",lex[i],ley[i]);
//printf("%f %f\n",TEX_POS2D[i_tex][i].x,TEX_POS2D[i_tex][i].y);
	}

	// Projection nulle
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	// et on trace tous les triangles
	nb=NB_TRI-((NB_TMSK>0)?NB_TMSK:0);
	glBegin(GL_TRIANGLES);
	for(i=0;i<nb;i++) {
		i0=MSH[i].i0;
		i1=MSH[i].i1;
		i2=MSH[i].i2;
		glTexCoord2f(lex[i0],ley[i0]);
		glVertex2f(2.0*(TEX_POS2D[i_tex][i0].x)-1.0,1.0-2.0*TEX_POS2D[i_tex][i0].y);
		glTexCoord2f(lex[i1],ley[i1]);
		glVertex2f(2.0*(TEX_POS2D[i_tex][i1].x)-1.0,1.0-2.0*TEX_POS2D[i_tex][i1].y);
		glTexCoord2f(lex[i2],ley[i2]);
		glVertex2f(2.0*(TEX_POS2D[i_tex][i2].x)-1.0,1.0-2.0*TEX_POS2D[i_tex][i2].y);
	}
	glEnd();
	glBindTexture(GL_TEXTURE_2D,0);
    glDisable(GL_TEXTURE_2D);
	glEnable(GL_CULL_FACE);

	// glViewport(0,0,MINIM_WIDTH,MINIM_HEIGHT);
}

#ifdef USE_OBJS

// On modelise via le MODEL_VIEW de GL la partie rigide du ROT_/trans d'un MDL a 2 niveaux de l'objet
void trans_obj(tMdl *aObj) {
  int f;
  int n=0;

  glMatrixMode(GL_MODELVIEW);
  // On applique "dans l'ordre inverse" pour que l'effet SUR LES PTS soit celui voulu par le calcul du modele
  for(f=aObj->nb_funct;--f>=0;) if (aObj->r_funct[f]) {
	// Derniere transfo= translation residuelle
	if (n==0) glTranslatef(aObj->val[f+1]-aObj->rx_funct[f], aObj->val[f+2]-aObj->ry_funct[f], aObj->val[f+3]-aObj->rz_funct[f]);
	// On tourne autour du bon axe, en tenant compte du centre de rotation
//	if (n==0) glTranslatef(-aObj->rx_funct[f],-aObj->ry_funct[f],-aObj->rz_funct[f]);
	glRotatef(180.0/PI*aObj->val[f],(n==0)?1.0:0.0,(n==1)?-1.0:0.0,(n==2)?1.0:0.0); // point transforme selon z, puis -y, puis x
	if (n==2) glTranslatef(aObj->rx_funct[f],aObj->ry_funct[f],aObj->rz_funct[f]);
	// Y-aura-t-il plusieurs mouvements en cascade ?
	if (++n==6) n=0;
  }
}

void draw_nomo(tMdl *MDL) {
  int i;

  glColor3f(MDL->mesh_r,MDL->mesh_g,MDL->mesh_b);

if (MDL==&OBJS[1]) {
  glPointSize(3.0);
  glBegin(GL_POINTS);
  for(i=0;i<OBJS[0].nb_pts_draw;i++)
	glVertex3f(MDL->pts[i].x,MDL->pts[i].y,MDL->pts[i].z);
  glEnd();
} else
  glLineWidth(3.0);

  glPolygonMode(GL_FRONT,GL_LINE);
  glPolygonMode(GL_BACK,GL_FILL);

  glBegin(GL_LINES);
  for(i=0;i<OBJS[0].nb_pts_draw;i++) {
	glVertex3f(OBJS[0].pts[i].x,OBJS[0].pts[i].y,OBJS[0].pts[i].z);
	glVertex3f(MDL->pts[i].x,MDL->pts[i].y,MDL->pts[i].z);
  }
  glEnd();
  glLineWidth(1.0);
}

GLUquadricObj *q;

void my_gluSphere(GLUquadricObj *q, float radius, int slices, int stacks)
{
  int i,j;
  float ai,r;
  float x,y,z;
  float px,py,pz;
  float ox[200],oy[20];
  float tx[200],ty[200];

slices=16; // !!! BUG

  glBegin(GL_QUADS);
  for(j=0;j<stacks;j++) {
	z=2.0*radius*j/(stacks-1)-radius;
	r=sqrt(radius*radius-z*z);
	ty[j]=(float)j/(stacks-1);
	for(i=0;i<=slices;i++) {
	  ai=2.0*PI*i/slices;
	  y=cos(ai)*r;
	  x=sin(ai)*r;
	  tx[i]=(float)i/slices;
	  if(i>0) {
		if (j>0) {
		  glTexCoord2f(tx[i-1],ty[j-1]);		glVertex3f(ox[i-1],oy[i-1],pz);
		  glTexCoord2f(tx[i-1],ty[j]);		glVertex3f(px,py,z);
		  glTexCoord2f(tx[i],ty[j]);			glVertex3f(x,y,z);
		  glTexCoord2f(tx[i],ty[j-1]);		glVertex3f(ox[i],oy[i],pz);
		}
		ox[i-1]=px;oy[i-1]=py;
	  }
	  px=x;py=y;
	}
	pz=z;
	ox[slices]=px;oy[slices]=py;
  }
  glEnd();
}

// On trace les points et/ou triangles potentiellement textures
void draw_obj(tMdl *MDL)
{
	int i;

	// Y-a-t-il un mouvement global optimise en GL ?
	if (MDL->use_GLtrans>0) {
	  glMatrixMode(GL_MODELVIEW);
	  glPushMatrix();
	  trans_obj(MDL);
	}

	if (MDL->nb_tri==0) {
	  // Rendu en points ou point_light ?
	  if (USE_PL>0) {
		int i0,i1,i2, md_tri=2;
		// On altere d'abord le Z-buffer (mais pas le rendu)
		glColorMask(GL_FALSE,GL_FALSE,GL_FALSE,GL_FALSE);
		//~ glColor3f(1.0,0,0);
		glPolygonMode(GL_FRONT,GL_FILL);
		glPolygonMode(GL_BACK,GL_FILL);
		for(i=0;i<NB_TRI;i++) {
			i0=MSH[i].i0;
			i1=MSH[i].i1;
			i2=MSH[i].i2;
			// Factorisation des glBegin/glEnd
			if ((i2!=-1)!=md_tri) {
				if (i!=0) glEnd();
				glBegin((i2==-1)?GL_LINES:GL_TRIANGLES);
			}
			glVertex3f(MDL->pts[i0].x,MDL->pts[i0].y,MDL->pts[i0].z);
			glVertex3f(MDL->pts[i1].x,MDL->pts[i1].y,MDL->pts[i1].z);
			if ((md_tri=(i2!=-1))) glVertex3f(MDL->pts[i2].x,MDL->pts[i2].y,MDL->pts[i2].z);
		}
		glEnd();
		glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);

		// On trace les spheres

		//~ q = gluNewQuadric();
		//~ gluQuadricNormals(q, GLU_OUTSIDE);
		//~ gluQuadricTexture(q, GL_FALSE);
		//~ glEnable(GL_LIGHTING);
		//~ glEnable(GL_LIGHT0);
		//~ glLightPosition();

		glEnable(GL_DEPTH_TEST);
		glColor3f(MDL->mesh_r,MDL->mesh_g,MDL->mesh_b);
		for(i=10;i<MDL->nb_pts_draw;i++) if ((i!=29+6)&&(i!=29+7)) {
			glPushMatrix();
			glTranslatef(MDL->pts[i].x,MDL->pts[i].y,MDL->pts[i].z);
			//my_gluSphere(NULL, USE_PL, 6,6);
			gluSphere(q, USE_PL, 6,6);
			glPopMatrix();
		}
		glEnd();
	  } else {
		glColor3f(MDL->mesh_r,MDL->mesh_g,MDL->mesh_b);
		glPointSize(4);
		glBegin(GL_POINTS);
		for(i=0;i<MDL->nb_pts_draw;i++)
			glVertex3f(MDL->pts[i].x,MDL->pts[i].y,MDL->pts[i].z);
		glEnd();
	  }
	} else {
	  if (MDL->nb_tex<=0) {
		// rendu en lignes ou triangles
		int i0,i1,i2, md_tri=2;

		glColor3f(MDL->mesh_r,MDL->mesh_g,MDL->mesh_b);
		glPolygonMode(GL_FRONT,GL_LINE);
		glPolygonMode(GL_BACK,GL_FILL);
		for(i=0;i<MDL->nb_tri;i++) {
			i0=MDL->tri[i].i0;
			i1=MDL->tri[i].i1;
			i2=MDL->tri[i].i2;
			// Factorisation des glBegin/glEnd
			if ((i2!=-1)!=md_tri) {
				if (i!=0) glEnd();
				glBegin((i2==-1)?GL_LINES:GL_TRIANGLES);
			}
			glVertex3f(MDL->pts[i0].x,MDL->pts[i0].y,MDL->pts[i0].z);
			glVertex3f(MDL->pts[i1].x,MDL->pts[i1].y,MDL->pts[i1].z);
			if ((md_tri=(i2!=-1))) glVertex3f(MDL->pts[i2].x,MDL->pts[i2].y,MDL->pts[i2].z);
		}
		glEnd();
	  } else {
		// Rendu avec texture
		int i0,i1,i2, md_tri=2;
		glPolygonMode(GL_FRONT,GL_FILL);
		glPolygonMode(GL_BACK,GL_LINE);
		glEnable(GL_TEXTURE_2D);
		glColor4f(0.0,0.0,0.0,1.0);
		bind_tex2D(MDL->slot_tex);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

		for(i=0;i<MDL->nb_tri;i++) {
			i0=MDL->tri[i].i0;
			i1=MDL->tri[i].i1;
			i2=MDL->tri[i].i2;
			// Factorisation des glBegin/glEnd
			if ((i2!=-1)!=md_tri) {
				if (i!=0) glEnd();
				glBegin((i2==-1)?GL_LINES:GL_TRIANGLES);
			}
			glTexCoord2f(MDL->pos[i0].x-MDL->tri[i].d0,MDL->pos[i0].y);
			glVertex3f(MDL->pts[i0].x,MDL->pts[i0].y,MDL->pts[i0].z);
			glTexCoord2f(MDL->pos[i1].x-MDL->tri[i].d1,MDL->pos[i1].y);
			glVertex3f(MDL->pts[i1].x,MDL->pts[i1].y,MDL->pts[i1].z);
			if ((md_tri=(i2!=-1))) {
			  glTexCoord2f(MDL->pos[i2].x-MDL->tri[i].d2,MDL->pos[i2].y);
			  glVertex3f(MDL->pts[i2].x,MDL->pts[i2].y,MDL->pts[i2].z);
			}
		}
		glEnd();
		glBindTexture(GL_TEXTURE_2D,0);
		glDisable(GL_TEXTURE_2D);
	  }
	}

	// On restaure le contexte
	if (MDL->use_GLtrans>0) {
	  glMatrixMode(GL_MODELVIEW);
	  glPopMatrix();
	}
}
#endif // USE_OBJS

#ifdef USE_DENTS
// Affichage des dents du palais
void draw_palate()
{
  int j,k;

  // Y a-t-il un mouvement d'OBJ a appliquer ?
  if (PAL_REF>-1) {
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	trans_obj(&OBJS[PAL_REF]);
  }

  if (SLOT_PAL <= 0 ) { // rendu fil de fer
    glPolygonMode(GL_FRONT,GL_LINE);

    for (k=0;k<3;++k){
      glBegin(GL_TRIANGLE_STRIP);
      for (j=0;j<NB_PAL/4;j++) {
//	if ( (j/(NB_PAL/(4*7)))%2 == 1)
//	  glColor3f(1.0,0.0,0.0);
//	else
	  glColor3f(0.0,0.0,0.0);
	glVertex3f( PAL[j+(k+1)*NB_PAL/4].x,PAL[j+(k+1)*NB_PAL/4].y, PAL[j+(k+1)*NB_PAL/4].z);
	glVertex3f( PAL[j+k*NB_PAL/4].x, PAL[j+k*NB_PAL/4].y, PAL[j+k*NB_PAL/4].z);
      }
      glEnd();
    }

    glColor3f(0.0,0.0,0.0);
    glBegin(GL_TRIANGLE_STRIP);
    for (j=0;j<NB_PAL/4;j++) {
      glVertex3f( PAL[j].x, PAL[j].y, PAL[j].z);
      glVertex3f( PAL[j+3*NB_PAL/4].x, PAL[j+3*NB_PAL/4].y,PAL[j+3*NB_PAL/4].z);
    }
    glEnd();
  } else { //  rendu avec texture
//	glEnable(GL_ALPHA_TEST);
//	glEnable(GL_BLEND);
//	glAlphaFunc(GL_GREATER,0.0);

	glEnable(GL_TEXTURE_2D);
	bind_tex2D(SLOT_PAL);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

	glPolygonMode(GL_FRONT,GL_FILL);

//	glEnable(GL_DEPTH_TEST);

// glColor4f(0.0,0.0,0.0,aire);
// glBlendFunc(GL_SRC_ALPHA,GL_ZERO);
	glMatrixMode(GL_MODELVIEW);
	glColor4f(1.0,0.0,0.0,1.0);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	for (k=0;k<3;++k){
	    glBegin(GL_TRIANGLE_STRIP);
	    for (j=0;j<NB_PAL/4;j++) {
		glTexCoord2f(PAL_POS2D[j+(k+1)*NB_PAL/4].x, PAL_POS2D[j+(k+1)*NB_PAL/4].y);
		glVertex3f( PAL[j+(k+1)*NB_PAL/4].x, PAL[j+(k+1)*NB_PAL/4].y,PAL[j+(k+1)*NB_PAL/4].z);
		glTexCoord2f(PAL_POS2D[j+k*NB_PAL/4].x,PAL_POS2D[j+k*NB_PAL/4].y);
		glVertex3f( PAL[j+k*NB_PAL/4].x,PAL[j+k*NB_PAL/4].y,PAL[j+k*NB_PAL/4].z);
	    }
	    glEnd();
	}
	glBindTexture(GL_TEXTURE_2D,0);
//	glDisable(GL_BLEND);
	glDisable(GL_ALPHA_TEST);
	glDisable(GL_TEXTURE_2D);
   }

  if (PAL_REF>-1){
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
  }
}

// Affichage des dents de la machoire
void draw_jaw()
{
  int j,k;
  pt3D ptLT;
  float d;
  float omega;

  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();

  // Y a-t-il un mouvement d'OBJ a appliquer ?
  if ((MACH_REF>-1)) { // &&(OBJS[MACH_REF].tObj!=oFace)) {
	int ind=29+IND_LT; // !!! Y-a-t-il toujours des levres a sauter ?

	trans_obj(&OBJS[MACH_REF]);
	ptLT.x=OBJS[MACH_REF].pts[ind].x;
	ptLT.y=OBJS[MACH_REF].pts[ind].y;
	ptLT.z=OBJS[MACH_REF].pts[ind].z;
  } else {
	ptLT= PTS[IND_LT+29];
  }

  if (TRACE_CONDYLE) {
    glBegin(GL_POINTS);
    glColor3f(0.0,1.0,0.0);
    glVertex3f(CONDYLE.x,CONDYLE.y,CONDYLE.z);
    glColor3f(0.0,0.0,1.0);
    glVertex3f(ptLT.x,ptLT.y,ptLT.z);
    glEnd();
  }

  glColor3f(0.0,0.0,0.0);

  // calcul de l'angle actuel
  d=-cos(ANG_JW)*(CONDYLE.z-ptLT.z)-sin(ANG_JW)*(CONDYLE.y-ptLT.y);
  omega=(ANG_JW-acos(d/LGM)-OM0)*180/(2*acos(0.0)); // en degres pour gl...

  // mise en place de la machoire
  glMatrixMode(GL_MODELVIEW);

  glTranslatef(ptLT.x, ptLT.y, ptLT.z);
  glRotatef(omega, MACH_ROT.x, MACH_ROT.y, MACH_ROT.z);
// Pour utiliser l'axe des comissures :
// glRotatef(omega,MDL[22][0].x-MDL[28][0].x,MDL[22][0].y-MDL[28][0].y,MDL[22][0].z-MDL[28][0].z);

if (0) { // Alignement manuel
  glRotatef(0.0+ART[0][3]*10, 1.0,0.0,0.0);
  glRotatef(0.0+ART[0][4]*10, 0.0,1.0,0.0);
  glRotatef(0.0+ART[0][5]*10, 0.0,0.0,1.0);
}

  if (SLOT_MACH<=0) { // rendu fil de fer
    for (k=2;k>=0;--k) {
      glBegin(GL_TRIANGLE_STRIP);
      for (j=0;j<NB_MACH/4;++j) {
	glVertex3f( MACH[j+k*NB_MACH/4].x,MACH[j+k*NB_MACH/4].y,MACH[j+k*NB_MACH/4].z);
	glVertex3f( MACH[j+(k+1)*NB_MACH/4].x,MACH[j+(k+1)*NB_MACH/4].y,MACH[j+(k+1)*NB_MACH/4].z);
      }
      glEnd();
    }

    glBegin(GL_TRIANGLE_STRIP);
    for (j=0;j<NB_MACH/4;j++) {
      glVertex3f( MACH[j+3*NB_MACH/4].x,MACH[j+3*NB_MACH/4].y,MACH[j+3*NB_MACH/4].z);
      glVertex3f( MACH[j].x,MACH[j].y,MACH[j].z);
    }
    glEnd();

  } else {  // Rendu avec texture
    glPolygonMode(GL_FRONT,GL_FILL);
    glEnable(GL_TEXTURE_2D);
    glDisable(GL_BLEND);

    glEnable(GL_ALPHA_TEST);
    glAlphaFunc(GL_GREATER,0.0);

    bind_tex2D(SLOT_MACH);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

    for (k=0;k<3;++k){
      glBegin(GL_TRIANGLE_STRIP);
      for (j=0;j<NB_MACH/4;j++) {
		glTexCoord2f(MACH_POS2D[j+k*NB_MACH/4].x,MACH_POS2D[j+k*NB_MACH/4].y);
		glVertex3f( MACH[j+k*NB_MACH/4].x,MACH[j+k*NB_MACH/4].y,MACH[j+k*NB_MACH/4].z);
		glTexCoord2f(MACH_POS2D[j+(k+1)*NB_MACH/4].x,MACH_POS2D[j+(k+1)*NB_MACH/4].y);
      	glVertex3f( MACH[j+(k+1)*NB_MACH/4].x,MACH[j+(k+1)*NB_MACH/4].y,MACH[j+(k+1)*NB_MACH/4].z);
      }
      glEnd();
    }

    glDisable(GL_ALPHA_TEST);

    glBegin(GL_TRIANGLE_STRIP);
    for (j=0;j<NB_MACH/4;j++) {
      glVertex3f( MACH[j+3*NB_MACH/4].x,MACH[j+3*NB_MACH/4].y,MACH[j+3*NB_MACH/4].z);
      glVertex3f( MACH[j].x,MACH[j].y,MACH[j].z);
    }
    glEnd();

    glBindTexture(GL_TEXTURE_2D,0);
    glDisable(GL_TEXTURE_2D);
  }

  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();
}

#endif // USE_DENTS

/* ******************************************
 *  GESTION DE L'ESPACE PHYSIQUE DE l'ECRAN *
 * **************************************** */

// Calcul du pixel ratio
void Minim_set_screen_resolution(int width_pix,float width_cm, int height_pix, float height_cm)
{
  dpcm_x=width_pix/width_cm;
  dpcm_y=height_pix/height_cm;
}

// On memorise la transformation qui transforme les points 3D du monde
// en points 3D lies a l'ecran du clone.
void Minim_move_screen_in_world(float rot[9], float trans[3])
{
	bcopy(trans,clone_pos_world,3*sizeof(float));
	bcopy(rot,clone_rot_world,9*sizeof(float));
}

// On memorise la transformation qui transforme les points 3D trackes
// relativement a la base en points 3D lies a l'ecran du clone.
void Minim_move_screen_from_base(float rot[9], float trans[3])
{
	bcopy(trans,clone_pos_base,3*sizeof(float));
	bcopy(rot,clone_rot_base,9*sizeof(float));
}

// On applique la transformation du monde physique (repere fixe)
// vers le repere lie a l'ecran "3D", avec son echelle physique.
void trans3D_W2S(float xt, float yt, float zt, float *nx, float *ny, float *nz)
{
        xt-=clone_pos_world[0];
        yt-=clone_pos_world[1];
        zt-=clone_pos_world[2];

        *nx=clone_rot_world[0]*xt+clone_rot_world[1]*yt+clone_rot_world[2]*zt;
        *ny=clone_rot_world[3]*xt+clone_rot_world[4]*yt+clone_rot_world[5]*zt;
        *nz=clone_rot_world[6]*xt+clone_rot_world[7]*yt+clone_rot_world[8]*zt;
}

// On applique la transformation du monde physique (repere fixe)
// vers le repere lie a la base du clone.
void trans3D_B2S(float xt, float yt, float zt, float *nx, float *ny, float *nz)
{
        xt-=clone_pos_base[0];
        yt-=clone_pos_base[1];
        zt-=clone_pos_base[2];

        *nx=clone_rot_base[0]*xt+clone_rot_base[1]*yt+clone_rot_base[2]*zt;
        *ny=clone_rot_base[3]*xt+clone_rot_base[4]*yt+clone_rot_base[5]*zt;
        *nz=clone_rot_base[6]*xt+clone_rot_base[7]*yt+clone_rot_base[8]*zt;
}

// On oriente la tete (partiellement) vers la direction cible (xt,yt,zt)
// (repere relatif au clone, en cm a priori)
// jusqu'a un certain degre  (0<prop<1)
// le mouvement n'est effectue que pour partie (non instantane),
// avec une certaine vitesse (0<spd<1)
// Il n'y a pas de memorisation de la cible
void Minim_head_direction3D(float spd,float prop, float xt,float yt,float zt)
{
	float rx, ry;
	float nx, ny, nz;

	trans3D_B2S(xt,yt,zt,&nx,&ny,&nz);

	ry=-180.0/PI*atan2(nx,nz);
	rx=-180.0/PI*atan2(ny,nz);

	OBJ_MOV[0].rx+=.25*spd*(prop*.6*rx-OBJ_MOV[0].rx);
	OBJ_MOV[0].ry+=.2*spd*(prop*.4*ry-OBJ_MOV[0].ry);
}




// On oriente la tete, comme precedemment
// avec une cible (wx,wy) dans l'ecran
void Minim_head_direction2D(float spd,float prop,int wx,int wy)
{
	GLdouble model[16]={1,0,0,0,  0,1,0,0,  0,0,1,0,  0,0,0,1};
	GLdouble proj[16];
	GLint view[4];
	double xt,yt,zt;

	// On recupere le contexte de projection 3D
	move_head();
//	glGetDoublev(GL_MODELVIEW_MATRIX,model);
	glGetDoublev(GL_PROJECTION_MATRIX,proj);
	glGetIntegerv(GL_VIEWPORT,view);

	// On inverse un point du plan ecran
	gluUnProject(wx,view[3]-1-wy,0.0,model,CAM[0],view, &xt,&yt,&zt);

	Minim_head_direction3D(spd,prop,xt,yt,zt);
}

#ifdef USE_EYES

#define Minim_dot_product(x,y,z,xx,yy,zz)  ((x)*(xx)+(y)*(yy)+(z)*(zz))

void Minim_cross_product(float ax,float ay,float az, float bx,float by,float bz, float *cx,float *cy,float *cz) {
  *cx=ay*bz-by*az;
  *cy=az*bx-bz*ax;
  *cz=ax*by-bx*ay;
}

float cex[2],cey[2],cez[2];	// Le point regarde par chaque oeil, dans le monde
double lex[2],ley[2];		// Le point regarde par chaque oeil, sur l'ecran
float nex,ney,nez; 			// Normale a l'ecran
double cx0,cy0,cz0, cx1,cy1,cz1, cx2,cy2,cz2, cx3,cy3,cz3;

int MEMO_X,MEMO_Y;
float Z_OFF=0;


// On oriente le regard vers la direction (nx,ny,nz)/wt,
// avec wt=1 (pour un point reel) ou wt=0 pour l'infini (direction)
// suivant la vitesse 0<spd<1
// Le mouvement n'est effectue que partiellement (non instantanne),
// Il est DANS LE REPERE DE LA TETE (qui peut avoir tourne par rapport au buste)
void eyes_direction3D(float spd,float xt,float yt,float zt,float wt)
{
	float x,y,z;
	float lx,lz;
	float xb,yb,zb;
	float a,b, n;
	int oeil;
	float nx, ny, nz;

	trans3D_B2S(xt,yt,zt, &nx,&ny,&nz);
	for (oeil=0;oeil<2;oeil++) {
	  // Centre de cet oeil :
	  x=EYES[oeil].cx;
	  y=EYES[oeil].cy;
	  z=EYES[oeil].cz;

	  // Orientation actuelle de la normale :
	  a=EYE_ART[0][2*oeil];
	  b=EYE_ART[0][2*oeil+1];
	  xb=sin(a*PI/180.0)*cos(b*PI/180.0);
	  yb=sin(b*PI/180.0);
	  zb=cos(a*PI/180.0)*cos(b*PI/180.0);

	  // Angles pour la destination :
	  a=180.0/PI*atan2(nx-wt*x,nz-wt*z);
	  lx=nx-wt*x;lz=nz-wt*z;
      b=180.0/PI*atan2(wt*y-ny,sqrt(lx*lx+lz*lz));

	  // On amortit la normale en suivant la corde :
	  xb+=.4*spd*(sin(a*PI/180.0)*cos(b*PI/180.0)-xb);
	  yb+=.4*spd*(sin(b*PI/180.0)-yb);
	  zb+=.4*spd*(cos(a*PI/180.0)*cos(b*PI/180.0)-zb);
	  n=sqrt(xb*xb+yb*yb+zb*zb);if (n!=0) n=1.0/n;

	  // Angles amortis resultants (a,b) :
	  EYE_ART[0][2*oeil]=180.0/PI*atan2(xb,zb);
//	  EYE_ART[0][2*oeil+1]=b=180.0/PI*atan2(yb,sqrt(xb*xb+zb*zb));
	  EYE_ART[0][2*oeil+1]=180.0/PI*asin(yb*n); // Equivalent a la ligne precedente

	  if (EYE_FROM_MDLn) {
		ART[0][EYE_FROM_MDL+EYE_FROM_MDLn*oeil]=atan2(xb,zb);
		ART[0][EYE_FROM_MDL+EYE_FROM_MDLn*oeil+1]=-asin(yb*n);
	  }

//	  xb=sin(a*PI/180.0)*cos(b*PI/180.0);
//	  yb=-sin(b*PI/180.0); // !!!! negatif !
//	  zb=cos(a*PI/180.0)*cos(b*PI/180.0);

	  // Calcul de l'intersection avec le plan ecran
	  n=Minim_dot_product(xb,-yb,zb, nex,ney,nez);
	  if (n!=0) n=Minim_dot_product(cx0-x,cy0-y,cz0-z, nex,ney,nez)/n;
	  cex[oeil]=x+n*xb;
	  cey[oeil]=y-n*yb;
	  cez[oeil]=z+n*zb;
	}
}

// Pour les angles qui sont en degres...
double sin_DEG(double a) {
return(sin(a*PI/180.0));
}

// Pour les angles qui sont en degres...
double cos_DEG(double a) {
return(cos(a*PI/180.0));
}

// Comme  eyes_direction3D, mais corrige les coordonnees pour passer
// du repere buste au repere tete (en compensant le mouvement de la tete)
void Minim_eyes_direction3D(float spd,float xt,float yt,float zt,float wt)
{
  obj_mov mov;
  float nx,ny,nz;
  float t, cs,sn;

/*
  obj_mov *ptr=&OBJ_MOV[(ART_CNT<NB_MOV)?ART_CNT:0];
  ptr->tx=ptr->ty=ptr->tz=ptr->rx=ptr->ry=ptr->rz=0.0;
  ptr->rx=-15;
*/

  // Cas d'un modele a l'ancienne :
  mov=OBJ_MOV[(ART_CNT<NB_MOV)?ART_CNT:0];
  mov.ry+=OBJ_ROT[1];
  mov.rx-=OBJ_ROT[0];

  nx=xt-wt*(mov.tx+mov.cx);
  ny=yt-wt*(mov.ty+mov.cy);
  nz=zt-wt*(mov.tz+mov.cz);

  cs=cos_DEG(mov.rx);sn=sin_DEG(mov.rx);
   t= cs*ny+sn*nz;
  nz=-sn*ny+cs*nz;
  ny=t;

  cs=cos_DEG(mov.ry);sn=sin_DEG(mov.ry);
   t= cs*nx+sn*nz;
  nz=-sn*nx+cs*nz;
  nx=t;

  cs=cos_DEG(-mov.rz);sn=sin_DEG(-mov.rz);
   t= cs*nx+sn*ny;
  ny=-sn*nx+cs*ny;
  nx=t;

  nx+=wt*mov.cx;
  ny+=wt*mov.cy;
  nz+=wt*mov.cz;

  printf("Corrige en : %f %f %f (%f)\n",nx,ny,nz,wt);

  eyes_direction3D(spd,nx,ny,nz,wt);
}

// Dans le repere du monde :
float lx,ly,lz; // Le point de l'ecran pointe par la souris

// Comme precedement, avec une cible dans l'espace ecran
void Minim_eyes_direction2D(float spd,int wx,int wy)
{
	GLdouble model[16];
//	GLdouble proj[16];
	GLint view[4];
	double xt,yt,zt;

//Minim_head_direction2D(.6*spd,.8,wx,wy);

	MEMO_X=wx;
	MEMO_Y=wy;

	// On recupere le contexte de projection 3D
	move_head();
#ifdef USE_OBJS
	if (EYE_REF>-1)
	  trans_obj(&OBJS[EYE_REF]);
#endif // USE_OBJS
	glGetDoublev(GL_MODELVIEW_MATRIX,model);
    //La matrice de projection, c'est l'une des CAM... la 0 par exemple !
	glGetIntegerv(GL_VIEWPORT,view);

	// On inverse un point du plan ecran
	gluUnProject(wx,view[3]-1-wy,-0.0,model,CAM[0],view, &xt, &yt, &zt);

	// On inverse les 4 coins de l'ecran (coordonnes du monde)
	gluUnProject(0*MINIM_WIDTH,0*MINIM_HEIGHT,-0.0,model,CAM[0],view, &cx0, &cy0, &cz0);
	gluUnProject(1*MINIM_WIDTH,0*MINIM_HEIGHT,-0.0,model,CAM[0],view, &cx1, &cy1, &cz1);
	gluUnProject(1*MINIM_WIDTH,1*MINIM_HEIGHT,-0.0,model,CAM[0],view, &cx2, &cy2, &cz2);
	gluUnProject(0*MINIM_WIDTH,1*MINIM_HEIGHT,-0.0,model,CAM[0],view, &cx3, &cy3, &cz3);
	// On calcule le vecteur normal a ce plan
	Minim_cross_product(cx3-cx0,cy3-cy0,cz3-cz0, cx1-cx0,cy1-cy0,cz1-cz0, &nex,&ney,&nez);

	eyes_direction3D(spd, lx=xt,ly=yt,lz=zt+Z_OFF,1.0);

	// Et on re-projette sur l'ecran ! En inversant les y...
	gluProject(cex[0],cey[0],cez[0],model,CAM[0],view,&lex[0],&ley[0],&zt);
	ley[0]=view[3]-1-ley[0];
	gluProject(cex[1],cey[1],cez[1],model,CAM[0],view,&lex[1],&ley[1],&zt);
	ley[1]=view[3]-1-ley[1];
//	printf("%d %d // %d %d\n",(int)lex[0],(int)ley[0],(int)lex[1],(int)ley[1]);
}

void draw_eyes()
{
	int i;
	int replay;
	double trans[16]; // pour la matrice MODEL_VIEW

#ifdef SHOW_SIGHT
if (0) {
glBegin(GL_POINTS);
  // Visu point pointe (souris, yeux)
  glColor3f(0.0, 1.0, 0.0);
  glVertex3f(lx,ly,lz);
  glColor3f(1.0, 0.0, 0.0);
  glVertex3f(cex[0],cey[0],cez[0]);
  glVertex3f(cex[1],cey[1],cez[1]);
glEnd();
glColor3f(0.0, 0.0, 0.0);
glBegin(GL_LINES);
  glVertex3f(EYES[0].cx,EYES[0].cy,EYES[0].cz);
  glVertex3f(cex[0],cey[0],cez[0]);

  glVertex3f(EYES[1].cx,EYES[1].cy,EYES[1].cz);
  glVertex3f(cex[1],cey[1],cez[1]);
glEnd();
}
#endif // SHOW_SIGHT

#ifdef SHOW_SCREEN
{ float k;
glBegin(GL_LINES);
  glColor3f(0.0, 0.0, 0.0);
  // Normale
  glVertex3f((cx0+cx2)/2.0,(cy0+cy2)/2.0,(cz0+cz2)/2.0);
  glVertex4f(cx0+cx2+2*nex,cy0+cy2+2*ney,cz0+cz2+2*nez,2.0);
  // Quadrillage
  for(k=0.1;k<1.0;k+=.2) {
	glVertex3f(cx0+k*(cx1-cx0),cy0+k*(cy1-cy0),cz0+k*(cz1-cz0));
	glVertex3f(cx3+k*(cx2-cx3),cy3+k*(cy2-cy3),cz3+k*(cz2-cz3));
	glVertex3f(cx0+k*(cx3-cx0),cy0+k*(cy3-cy0),cz0+k*(cz3-cz0));
	glVertex3f(cx1+k*(cx2-cx1),cy1+k*(cy2-cy1),cz1+k*(cz2-cz1));
  }
glEnd();
}
#endif // SHOW_SCREEN

	// On va mettre a jour le stencil
	glPolygonMode(GL_FRONT,GL_FILL);
  	glDepthMask(GL_FALSE); // Z buffer lu mais pas ecrit !
#ifdef SHOW_SCREEN
  glColor4f(0.6, 0.4, 0.4, 0.45);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  if (MINIM_NB_TEX_PLUS) {
	glEnable(GL_TEXTURE_2D);
	bind_tex2D(SLOT_BACK); // Background texture ?
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  }
  glBegin(GL_QUADS);
	glTexCoord2f(0.0,1.0);glVertex3f(cx0,cy0,cz0);
	glTexCoord2f(1.0,1.0);glVertex3f(cx1,cy1,cz1);
	glTexCoord2f(1.0,0.0);glVertex3f(cx2,cy2,cz2);
	glTexCoord2d(0.0,0.0);glVertex3f(cx3,cy3,cz3);
  glEnd();
  glDisable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D,0);
  glDisable(GL_BLEND);
#endif // SHOW_SCREEN
	glColor4f(0.6, 0.4, 0.4, 1.0);
//	glColorMask(GL_FALSE,GL_FALSE,GL_FALSE,GL_FALSE);
	if (NB_TMSK) glEnable(GL_STENCIL_TEST); // On va marquer a 1 les pixels visibles
	glStencilFunc(GL_ALWAYS,1,1);
	glStencilOp(GL_KEEP,GL_KEEP,GL_REPLACE);
	glStencilMask(-1);
	glBegin(GL_TRIANGLES);
	for(i=-NB_TMSK;i<0;i++) {
		glVertex3f(PTS[MSH[NB_TRI+i].i0].x,PTS[MSH[NB_TRI+i].i0].y,PTS[MSH[NB_TRI+i].i0].z);
		glVertex3f(PTS[MSH[NB_TRI+i].i1].x,PTS[MSH[NB_TRI+i].i1].y,PTS[MSH[NB_TRI+i].i1].z);
		glVertex3f(PTS[MSH[NB_TRI+i].i2].x,PTS[MSH[NB_TRI+i].i2].y,PTS[MSH[NB_TRI+i].i2].z);
	}
	glEnd();
//	glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
	glDisable(GL_STENCIL_TEST);
	glDepthMask(GL_TRUE);

	replay=(ART_CNT<EYE_ART_MAX)?ART_CNT:EYE_ART_MAX-1;

	// On active la transformation eventuelle de l'objet
	if (EYE_REF>-1) {
	  trans_obj(&OBJS[EYE_REF]);
	  if (EYE_FROM_MDLn) {
		  EYE_ART[replay][2*0+0]=180.0/PI*ART[ART_CNT][EYE_FROM_MDL+EYE_FROM_MDLn*0+0];
		  EYE_ART[replay][2*0+1]=-180.0/PI*ART[ART_CNT][EYE_FROM_MDL+EYE_FROM_MDLn*0+1];
		  EYE_ART[replay][2*1+0]=180.0/PI*ART[ART_CNT][EYE_FROM_MDL+EYE_FROM_MDLn*1+0];
		  EYE_ART[replay][2*1+1]=-180.0/PI*ART[ART_CNT][EYE_FROM_MDL+EYE_FROM_MDLn*1+1];
	  }
	}

	// On recupere la matrice de transformation pts_modele -> pts_monde
    glGetDoublev(GL_MODELVIEW_MATRIX,trans);

	// Pour chaque oeil...
	for(i=0;i<2;i++) {
		float a,b;

		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();

		glTranslatef(EYES[i].cx,EYES[i].cy,EYES[i].cz);
		a=EYE_ART[replay][2*i];
		b=EYE_ART[replay][2*i+1];

#ifdef SHOW_SIGHT
// Dans le repere de l'oeil, mais non tourne
glBegin(GL_LINES);
  glLineWidth(5.0);
  glColor3f(0.0,1.0,0.0);
  glVertex3f(8*sin(a*PI/180.0)*cos(b*PI/180.0),8*sin(-b*PI/180.0),8*cos(a*PI/180.0)*cos(b*PI/180.0));
  glVertex3f(4*sin(a*PI/180.0)*cos(b*PI/180.0),4*sin(-b*PI/180.0),4*cos(a*PI/180.0)*cos(b*PI/180.0));
  glLineWidth(1.0);
glEnd();
#endif // SHOW_SIGHT

		glRotatef(a,0.0,1.0,0.0);
		glRotatef(b,1.0,0.0,0.0);

#ifdef SHOW_SIGHT
// Dans le repere de l'oeil tourne
glColor3f(.6,.6,1.0);
glBegin(GL_LINES);
 glVertex3f(0.0,0.0,0.0);
 glVertex3f(0.0,0.0,125.0);
glEnd();
#endif // SHOW_SIGHT

		// On n'active le rendu que dans les fenetres des yeux !
		if (NB_TMSK) glEnable(GL_STENCIL_TEST);
		glStencilOp(GL_KEEP,GL_KEEP,GL_REPLACE);
		glStencilFunc(GL_EQUAL,1,1);
		glColor3f(0.8,0.8,0.8);

		if (SLOT_EYES<=0) { // Wire-frame only
		  glutSolidSphere(EYES[i].radius,8,8);
		  //~ glColor3f(0.0,0.0,0.0);
		  //~ glutWireSphere(EYES[i].radius,8,8);

		  glTranslatef(EYES[i].dx,EYES[i].dy,EYES[i].dz);
		  glColor3f(0.2,0.2,0.4);
		  glutSolidSphere(EYES[i].radius2+.1,8,8);

		} else { // show textured eyes
//GLdouble myPLANE0[]={0.0,0.0,-1.0,EYES[i].radius*(2.0*EYES[i].sc1-1.0)};
//GLdouble myPLANE1[]={0.0,0.0,1.0,-EYES[i].radius*(2.0*EYES[i].sc1-1.0)};

//		  glShadeModel(GL_SMOOTH);
		  bind_tex2D(SLOT_EYES);
		  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
		  glEnable(GL_TEXTURE_2D);
		  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

		  q = gluNewQuadric();
		  gluQuadricNormals(q, GLU_NONE);
		  gluQuadricTexture(q, GL_TRUE);

//if (NB_SLD>0) glEnable(GL_CLIP_PLANE0);
//glClipPlane(GL_CLIP_PLANE0,myPLANE0);
		  glMatrixMode(GL_TEXTURE);
		  glScalef(1.0,.5/EYES[i].sc1,1.0);
#if 0
glBegin(GL_QUADS);
glTexCoord2f(0.0,0.0);glVertex3f(0,+EYES[i].radius,-EYES[i].radius);
glTexCoord2f(1.0,0.0);glVertex3f(0,-EYES[i].radius,-EYES[i].radius);
glTexCoord2f(1.0,1.0);glVertex3f(0,-EYES[i].radius,+EYES[i].radius);
glTexCoord2f(0.0,1.0);glVertex3f(0,+EYES[i].radius,+EYES[i].radius);
glEnd();
#else
		  my_gluSphere(q,EYES[i].radius,24,36);
#endif
		  glLoadIdentity();
//glClipPlane(GL_CLIP_PLANE0,myPLANE1);
//glDisable(GL_CLIP_PLANE0);

  		  glMatrixMode(GL_MODELVIEW);
		  glTranslatef(EYES[i].dx,EYES[i].dy,EYES[i].dz);

//if (NB_SLD>0) glEnable(GL_CLIP_PLANE0);
//glClipPlane(GL_CLIP_PLANE0,myPLANE1);
		  glMatrixMode(GL_TEXTURE);
		  glTranslatef(0,1.0,0);
		  glScalef(1.0,.5/EYES[i].sc2,1.0);
		  glTranslatef(0,-1.0,0);
#if 0
glBegin(GL_QUADS);
glTexCoord2f(0.0,0.0);glVertex3f(-.01,+EYES[i].radius2,-EYES[i].radius2);
glTexCoord2f(1.0,0.0);glVertex3f(-.01,-EYES[i].radius2,-EYES[i].radius2);
glTexCoord2f(1.0,1.0);glVertex3f(-.01,-EYES[i].radius2,+EYES[i].radius2);
glTexCoord2f(0.0,1.0);glVertex3f(-.01,+EYES[i].radius2,+EYES[i].radius2);
glEnd();
//glDisable(GL_TEXTURE_2D);
#else
		  my_gluSphere(q,EYES[i].radius2,24,24);
#endif
//glDisable(GL_CLIP_PLANE0);
		  glMatrixMode(GL_TEXTURE);
		  glLoadIdentity();

		  glMatrixMode(GL_MODELVIEW);
		  glDisable(GL_TEXTURE_2D);

		  glBindTexture(GL_TEXTURE_2D,0);
//		  glDisable(GL_TEXTURE_GEN_S);
//		  glDisable(GL_TEXTURE_GEN_T);
		  glDisable(GL_TEXTURE_2D);
//		  glShadeModel(GL_FLAT);
//		  glDisable(GL_LIGHTING);
		}

		// Reflet
		if (0) {
		  float xt,yt,zt;
		  float wx,wy,wz,w;
		  float nx,ny,nz;

//~ glDisable(GL_STENCIL_TEST);

		  // Dans le repere du monde
		  glMatrixMode(GL_MODELVIEW);
		  glLoadIdentity();

		  glDisable(GL_DEPTH_TEST);
		  q = gluNewQuadric();
		  gluQuadricNormals(q, GLU_NONE);
		  gluQuadricTexture(q, GL_FALSE);

		  nx=sqrt(.3)*sqrt(0.7);ny=sqrt(.5);nz=sqrt(.3)*sqrt(0.5);
		  //~ nx=sqrt(.7);ny=sqrt(.3);nz=0;
		  nx=-sqrt(.4)*sqrt(.2);ny=sqrt(.6)*sqrt(.2);nz=sqrt(.8);

		  xt=EYES[i].cx;
		  yt=EYES[i].cy;
		  zt=EYES[i].cz;

		  // Pour obtenir les coordoonnees dans le repere du monde
		  wx=trans[0]*xt+trans[4]*yt+ trans[8]*zt+trans[12];
          wy=trans[1]*xt+trans[5]*yt+ trans[9]*zt+trans[13];
          wz=trans[2]*xt+trans[6]*yt+trans[10]*zt+trans[14];
          w =trans[3]*xt+trans[7]*yt+trans[11]*zt+trans[15];
		  if (w!=0) w=1.0/w;
		  wx*=w;wy*=w;wz*=w;

//~ glEnable(GL_DEPTH_TEST);
//~ glLineWidth(2.0);
//~ glBegin(GL_LINES);
//~ glVertex3f(wx,wy,wz);
//~ glVertex3f(LIGHT_X,LIGHT_Y,LIGHT_Z);
//~ glVertex3f(wx,wy,wz);
//~ glVertex3f(wx+nx*EYES[i].radius*3,wy+ny*EYES[i].radius*3,wz+nz*EYES[i].radius*3);
//~ glEnd();
//~ glLineWidth(1.0);

		  glTranslatef(wx+nx*EYES[i].radius,wy+ny*EYES[i].radius,wz+nz*EYES[i].radius);

		  //~ glRotatef(180/PI*asin(nz),0.0,-ny,nx);
		  glColor3f(1.0,1.0,0.8);
		  gluDisk(q,0,.1,20,1);
		  glEnable(GL_DEPTH_TEST);
		}

		glPopMatrix();
		glDisable(GL_STENCIL_TEST);

	} // i oeil
}
#endif // USE_EYES

#ifdef USE_OBJS
// On applique l'articulation a un modele a 2 niveaux (main...)
void anim_obj(tMdl *MDL, int offset)
{
		int i,j;
		float v, x,y,z,t;

		// 1er niveau : Calcul des valeurs a partir des articulateurs
		for(i=0;i<MDL->nb_funct;i++) {
			v=MDL->funct[i][0];
			for(j=1;j<=MDL->nb_art;j++)
				v+=MDL->funct[i][j]*ART[ART_CNT][j-1+offset];
			switch(MDL->t_funct[i]) {
				case fCos: v=cos(v);
				 break;
				case fSin: v=sin(v);
				 break;
				case fLin:
				 ;
			}
			MDL->val[i]=v;
		}

		// 2nd niveau : Calcul des points a partir des valeurs
		for(i=0;i<MDL->nb_pts_calc;i++) {
			x=MDL->mdl[i][0].x;
			y=MDL->mdl[i][0].y;
			z=MDL->mdl[i][0].z;
			// Apply movement computations IF not using (successive) GL acceleration for rot/trans (6 params each)
			for(j=0;j<MDL->nb_funct-((MDL->use_GLtrans>0)?MDL->use_GLtrans:0);j++) {
				float v, rx,ry,rz;

				v=MDL->val[j];
				// lineaire ou rotation partielle ?
				if (MDL->r_funct[j]) {	// modele en rotation
						// centre
						x=x+MDL->rx_funct[j];
						y=y+MDL->ry_funct[j];
						z=z+MDL->rz_funct[j];
						// angles
						rx=v*MDL->mdl[i][j+1].x;
						ry=v*MDL->mdl[i][j+1].y;
						rz=v*MDL->mdl[i][j+1].z;
						// tambouille rotative
						if (rx) {
							t=y*cos(rx)-z*sin(rx);
							z=y*sin(rx)+z*cos(rx);
							y=t;
						}
						if (ry) { // on tourne dans le sens indirect !
							t=z*cos(ry)+x*sin(ry);
							x=-z*sin(ry)+x*cos(ry);
							z=t;
						}
						if (rz) {
							t=x*cos(rz)-y*sin(rz);
							y=x*sin(rz)+y*cos(rz);
							x=t;
						}
						// centre
						x=x-MDL->rx_funct[j];
						y=y-MDL->ry_funct[j];
						z=z-MDL->rz_funct[j];
				} else { // lineaire additif
					x+=MDL->mdl[i][j+1].x*v;
					y+=MDL->mdl[i][j+1].y*v;
					z+=MDL->mdl[i][j+1].z*v;
				} // if
			} // for j
			// S'il y a un mesh, mais pas de modele, alors objFace
			if (MDL->tObj==oTexFace) {
				PTS[i].x=x;
				PTS[i].y=y;
				PTS[i].z=z;
			} else {
				MDL->pts[i].x=x;
				MDL->pts[i].y=y;
				MDL->pts[i].z=z;
			}
		} // for i
}
#endif // USE_OBJS

// On applique l'articulation a la tete
void anim_head()
{
    int i,i_art,r;
    float x,y,z;

#ifdef USE_FNC
{
	int num=0;
	for(i_art=0;i_art<NB_ART_MDL;i_art++) {
		if (MDL_FNC[i_art]) {
			if (num==0)
				ART[0][i_art]=-OBJ_MOV[0].rx/180.0*PI;
			if (num==1)
				// Modif de signe !
				ART[0][i_art]=-OBJ_MOV[0].ry/180.0*PI;
			if (num==2)
				ART[0][i_art]=OBJ_MOV[0].rz/180.0*PI;
			num++;
		}
	}
}
#endif

    // On calcule les coordonnees des points mobiles...
    for(i=0;i<NB_PMV;i++) {
        // ... depuis leur valeur au repos ...
        x=MDL[i][0].x;
        y=MDL[i][0].y;
        z=MDL[i][0].z;
        // ... en appliquant chaque mouvement articulatoire
        for(i_art=0;i_art<NB_ART_MDL;i_art++) {
					// slider dynamique ou statique ?
					r=(i_art<NB_ART_LU)?ART_CNT:0;
#ifdef USE_FNC
					if (MDL_FNC[i_art]==0) {
#endif // USE_FNC
						// modele lineaire
            x+=ART[r][i_art]*MDL[i][1+i_art].x;
            y+=ART[r][i_art]*MDL[i][1+i_art].y;
            z+=ART[r][i_art]*MDL[i][1+i_art].z;
#ifdef USE_FNC
					} else {
						// modele en rotation
						float rx,ry,rz, t;
						// centre
						x=x+MDL_CROT[i_art].x;
						y=y+MDL_CROT[i_art].y;
						z=z+MDL_CROT[i_art].z;
						// angles
						rx=ART[r][i_art]*MDL[i][1+i_art].x;
						ry=ART[r][i_art]*MDL[i][1+i_art].y;
						rz=ART[r][i_art]*MDL[i][1+i_art].z;
						// tambouille
						if (rx) {
							t=y*cos(rx)-z*sin(rx);
							z=y*sin(rx)+z*cos(rx);
							y=t;
						}
						if (ry) {
							// Passage de direct a indirect
							t=z*cos(ry)+x*sin(ry);
							x=-z*sin(ry)+x*cos(ry);
							z=t;
						}
						if (rz) {
							t=x*cos(rz)-y*sin(rz);
							y=x*sin(rz)+y*cos(rz);
							x=t;
						}
						// centre
						x=x-MDL_CROT[i_art].x;
						y=y-MDL_CROT[i_art].y;
						z=z-MDL_CROT[i_art].z;
					}
#endif // USE_FNC
				}
        PTS[i].x=x;
        PTS[i].y=y;
        PTS[i].z=z;
    }
}


// On synchronise les mouvements des yeux sur le discours
#ifdef USE_DICT
void dict_anim_eyes(long lon)
{
  if ((idx_seg<NB_MOTS_VUS)&&(lon>=SEG_START[idx_seg])) {
	  // mot actif ou obsolete ?
	  if (lon<=SEG_STOP[idx_seg]) {
		int idx_mot=SEG_IDX[idx_seg];
		float xt, yt, zt;
		switch(DICO_OBJET[idx_mot]) {
		  case oCible2D:
			  Minim_head_direction2D(.3,.6,DICO_CIBLE[idx_mot].x,DICO_CIBLE[idx_mot].y);
#ifdef USE_EYES
			  Minim_eyes_direction2D(.5,DICO_CIBLE[idx_mot].x,DICO_CIBLE[idx_mot].y);
#endif // USE_EYES
			break;
		  case oCible3D:
			  trans3D_W2S(DICO_CIBLE[idx_mot].x,DICO_CIBLE[idx_mot].y,DICO_CIBLE[idx_mot].z,&xt,&yt,&zt);
			  Minim_head_direction3D(.3,.6,xt,yt,zt);
#ifdef USE_EYES
			  eyes_direction3D(.5,xt,yt,zt,1.0);
#endif // USE_EYES
			break;
		}
	  } else {
		++idx_seg;
	  }
  }
}
#endif // USE_DICT

#ifdef USE_TET

// Materialise le focus (point/zone)
void draw_Tet()
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

	// Sauf en cas d'eye contact...
	if (myTET_state.zone!=NB_LOGO) {

		// On trace la mouche
		glColor3f(1.0,0,0);
		glBegin(GL_POINTS);
		  glVertex2f(myTET_state.X,myTET_state.Y);
		glEnd();

		// et l'eventuelle Bounding Box
		if (myTET_state.zone) {
		  int ncam=myTET_state.zone-1;
		  glColor3f(1.0,myTET_state.col,0.0);
 		  glBegin(GL_LINE_LOOP);
			glVertex2f(LOGOS[ncam].x0,LOGOS[ncam].y0);
			glVertex2f(LOGOS[ncam].x1,LOGOS[ncam].y0);
			glVertex2f(LOGOS[ncam].x1,LOGOS[ncam].y1);
			glVertex2f(LOGOS[ncam].x0,LOGOS[ncam].y1);
		  glEnd();
		}
	}
}

#endif // USE_TET

// On lance le replay du message courant (nb=0) ou du message numero 'nb'
// soit tout de suite, soit synchro avec le prochain redraw.
void play_msg(int nb,int immediate)
{
#ifdef USE_DICT
	idx_seg=0;
	// On re-arme la liste de mots detectes
  	if ((nb>0)&&(nb<=NB_LOGO)) {
	  idx_seg=LOGOS[nb-1].idx_seg;
	}
#endif // USE_DICT

	// On transfere l'un des messages en slot ?
	if ((nb>0)&&(nb<=NB_LOGO)) {
		WAV_DAT=LOGOS[nb-1].wav_dat;
		WAV_SIZ=LOGOS[nb-1].wav_siz;
		// slot utilise ?
		if ((ART_MAX=LOGOS[nb-1].art_max))
			bcopy(LOGOS[nb-1].art,ART,sizeof(ART));
	}

	// Au prochain redraw ou tout de suite ?
	if (immediate) {
			struct timeb now;
			int sec, millisec;

			ftime(&now);
		 	START_TIME.time=now.time;
			START_TIME.millitm=now.millitm;

			// Calcul de la date de fin
			sec=ART_MAX/F_RATE;
			millisec=(((ART_MAX-sec*F_RATE)*1000)/F_RATE)+now.millitm;
			if (millisec>=1000) {
			  MINIM_END_TIME.time=now.time+sec+1;
			  MINIM_END_TIME.millitm=now.millitm+(millisec-1000);
			} else {
			  MINIM_END_TIME.time=now.time+sec;
			  MINIM_END_TIME.millitm=now.millitm;
			}

			WAV_PTR=WAV_SIZ;
#ifdef USE_AUDIO_WIN
			sndPlaySound(WAV_DAT,SND_ASYNC | SND_MEMORY);
			WAV_PTR=0;
#endif // USE_AUDIO_WIN
	}	else {
			// On arme le redemarrage prochain...
			WAV_PTR=-120;
	}

	// Sauf si on avait une pause sur le feu !
	if (MINIM_PAUSED) {
	  struct timeb now;

	  ftime(&now);
	  START_TIME=now;
	  PAUSE_TIME=now;
	  WAV_PTR=WAV_SIZ;
	  update_pause(ART_CNT=0,1);
	}
}

// On arrete l'audio et l'articulation
void Minim_stop_msg()
{
	WAV_PTR=-1;
#ifdef USE_AUDIO_WIN
	sndPlaySound(NULL,SND_ASYNC | SND_MEMORY);
#else
	// A rajouter : flush du buffer audio
#endif
	ART_CNT=0;
	ftime(&MINIM_END_TIME);
}

// Affichage des sliders
void draw_slid()
{
    int i,j;
    char tmp[6];

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0.0L,(double)MINIM_WIDTH,0.0L,(double)MINIM_HEIGHT);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    // On dessine les eventuels sliders
    glColor3i(1,1,1);
  	glPointSize(8);
    glBegin(GL_LINES);
      for(i=NB_SLD;--i>=0;) {
        glVertex2i(40,6+12*i);
        glVertex2i(MINIM_WIDTH,6+12*i);
        for(j=-2;j<=3;j++) {
          glVertex2i(MINIM_WIDTH*(.5+j/3.5/2),6+12*i-4);
          glVertex2i(MINIM_WIDTH*(.5+j/3.5/2),6+12*i+4);
          glVertex2i(MINIM_WIDTH*(.5+(j+.5)/3.5/2),6+12*i-1);
          glVertex2i(MINIM_WIDTH*(.5+(j+.5)/3.5/2),6+12*i+1);
        }
      }
    glEnd();
    glColor3f(.05,.05,.95);
    glBegin(GL_POINTS);
      for(i=NB_SLD;--i>=0;)
        glVertex2i(MINIM_WIDTH*(.5+ART[((NB_ART_MDL-1-i)<NB_ART_LU)?ART_CNT:0]
			  [NB_ART_MDL-1-i]/3.5/2.0),6+12*i);
    glEnd();
    for(i=NB_SLD;--i>=0;) {
        sprintf(tmp,"%+1.2f",ART[((NB_ART_MDL-1-i)<NB_ART_LU)?ART_CNT:0]
		[NB_ART_MDL-1-i]);
        glRasterPos2i(0,2+12*i);
        for(j=0;j<5;j++)
            glutBitmapCharacter(GLUT_BITMAP_8_BY_13,(int)*(char *)(tmp+j));
    }
}
// (re)affichage de tous les elements de la fenetre camera(s)
void draw_all()
{
    int ncam;
    int o;

    // dessin du fond
    DO_draw_background();

    if (!flg_clone_visible)
       return;

    // mise a jour des coordonnees des objets articules
    if (NB_PMV>0) // Modele 'old school'
			anim_head();
#ifdef USE_OBJS
		// Modeles 'nouvelle mode'
		for(o=0;o<NB_OBJS;o++) {
			anim_obj(&OBJS[o],OBJS[o].offset_art);
		}
#endif // USE_OBJS

    // boucle l'affichage (multi-camera) des objets
    for(ncam=0;ncam<NB_CAM;ncam++) {
	  // On oriente la camra
	  glMatrixMode(GL_PROJECTION);
	  glLoadMatrixd(CAM[ncam]);
	  glFrontFace(CAM_MIRROR[ncam]? GL_CW : GL_CCW);

	  // On va tracer chaque objet, exprime dans son repere naturel
	  move_head();

#ifdef USE_OBJS
			for(o=0;o<NB_OBJS;o++) {
//if ((ncam>0)||(o<2))
				if (OBJS[o].tObj==oDiff) draw_nomo(&OBJS[o]);
				else
				// On ne raffiche pas en dots un visage mesh !
				if (OBJS[o].tObj!=oTexFace) draw_obj(&OBJS[o]);
			}
#endif

#if 1
//~ if (ncam<2) {NB_TEX=-NB_TEX;SLOT_EYES=-SLOT_EYES;}
	  if (NB_PMV) { //visage  old school ou nouvelle mode converti
		if (USE_UNPROJ) {
			if (ncam==USE_UNPROJ-1) draw_head_rev();
		} else {
			draw_head();
		}
	  }
#else
	  if (NB_PMV) { //visage  old school ou nouvelle mode converti
		  if (NB_OBJS>0) {
			glMatrixMode(GL_MODELVIEW);
			glPushMatrix();
			trans_obj(&OBJS[0]);
		  }
		  GLdouble myPlaneXP[]={1.0,0.0,0.0, 0.0};
		  GLdouble myPlaneXM[]={-1.0,0.0,0.0, 0.0};
		  glClipPlane(GL_CLIP_PLANE0,myPlaneXP);
		  glEnable(GL_CLIP_PLANE0);
		  if (NB_OBJS>0) glPopMatrix();

		  draw_head();
/*
		  glClipPlane(GL_CLIP_PLANE0,myPlaneXM);
		  NB_TEX=-NB_TEX;
		  draw_head();
		  NB_TEX=-NB_TEX;
*/
		  glDisable(GL_CLIP_PLANE0);
	  }
#endif

#ifdef USE_DENTS
//if ((ncam>0)||(o<2))
{ float aire;
  pt3D *pts=PTS;

#define VERT(n) glVertex3f(pts[n].x,pts[n].y,pts[n].z);
#if 1

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();

			if (PAL_REF>-1) {
			  pts=OBJS[PAL_REF].pts;
	trans_obj(&OBJS[PAL_REF]);
			} else if (MACH_REF>-1) {
			  pts=OBJS[MACH_REF].pts;
	trans_obj(&OBJS[MACH_REF]);
			}


			if ((NB_PAL!=0)||(NB_MACH!=0)||(USE_CLOSE_LIPS)) {
			  aire=fabs(pts[22].x-pts[28].x)*fabs(pts[25].y-pts[20].y)/fabs(MDL[22][0].x-MDL[28][0].x)/fabs(MDL[25][0].y-MDL[20][0].y)*.7;
			  if (aire<0.0) aire=0.0;
			  if (aire>1.0) aire=1.0;
//			  printf("Aire: %f\n",aire);
			  // On lit mais n'ecrit pas les Z
			  glDepthMask(GL_FALSE);
			  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
			  glColor3f(.05+aire*.2,.05+aire*.1,.05);
			  glBegin(GL_TRIANGLE_FAN);
				VERT(29);VERT(20);VERT(25);VERT(26);VERT(27);VERT(28);
			  glEnd();
			  glBegin(GL_TRIANGLE_FAN);
				VERT(21);VERT(22);VERT(23);VERT(24);VERT(25);VERT(20);
			  glEnd();
			  glDepthMask(GL_TRUE);
			}

	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
#endif
}
#endif // USE_DENTS

//if ((ncam>0)||(o<2))
			if (NB_PAL>0) draw_palate();
//if ((ncam>0)||(o<2))
			if (NB_MACH>0) draw_jaw();

#ifdef USE_EYES
			if ((EYE_ART_MAX>0)&&(NB_TMSK>=0))
				draw_eyes();
#endif // USE_EYES

#ifdef USE_TET
	// On materialise le regard
			draw_Tet();
#endif // USE_TET
		}

    // ajout eventuel des sliders
    if (NB_SLD) draw_slid();

}


// Function pour qu'un client externe puisse s'interfacer avec Minim & GLUT :
// Celle-ci est optionnelle, EN PLUS du comportement par defaut
void (*func_init)()= NULL;

// Modifieur par defaut de la camera 0
float CAM_DX=0.0;
float CAM_DY=0.0;
float CAM_ZOOM=1.0;

void Minim_cam_change(float dx,float dy,float zoom)
{
  static int first=1;
  static double cam0[MAX_CAM][16];
  int i;

  if (first) {
	bcopy(CAM,cam0,16*MAX_CAM*sizeof(double));
	first=0;
  }

  CAM_DX=dx;
  CAM_DY=dy;
  CAM_ZOOM=zoom;

  for(i=0;i<=12;i+=4) {
	CAM[0][i]=zoom*cam0[0][i]+dx*cam0[0][3+i];
	CAM[0][1+i]=zoom*cam0[0][1+i]+dy*cam0[0][3+i];
  }

  printf("Camera =x%1.2f%+1.2f%+1.2f\n",zoom,dx,dy);
}

float TX,TY,TZ;

void do_trans(float *x,float *y,float *z,double trans[16])
{
  double nx,ny,nz,nt;

  nx=*x*trans[0]+*y*trans[4]+*z*trans[8]+trans[12];
  ny=*x*trans[1]+*y*trans[5]+*z*trans[9]+trans[13];
  nz=*x*trans[2]+*y*trans[6]+*z*trans[10]+trans[14];
  nt=*x*trans[3]+*y*trans[7]+*z*trans[11]+trans[15];

  if (nt!=0) nt=1.0/nt;
  *x=nx*nt;
  *y=ny*nt;
  *z=nz*nt;
}

// Configuration "initiale" de GL,
// production (voire sauvegarde) des premiers resultats
void Minim_GLinit()
{
	int slot;
	int j;

if (0) { // !!! pre-test YBB
  int i;
  double trans[16];
  FILE *fid;

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(MDL[IND_UT+29][0].x,MDL[IND_UT+29][0].y,MDL[IND_UT+29][0].z);
  glRotatef(4.72, 1.0,0.0,0.0);
  glRotatef(2.05, 0.0,1.0,0.0);
  glRotatef(5.74, 0.0,0.0,1.0);
//  glScalef(1.0,1.0,1.0);
  glTranslatef(- 0.751676,- -0.486748,- 2.254041);
  glGetDoublev(GL_MODELVIEW_MATRIX,trans);

  for(i=0;i<NB_PAL;i++) {
	do_trans(&(PAL[i].x),&(PAL[i].y),&(PAL[i].z),trans);
  }
  do_trans(&CONDYLE.x,&CONDYLE.y,&CONDYLE.z,trans);
  printf("%f %f %f\n",CONDYLE.x,CONDYLE.y,CONDYLE.z);

  glLoadIdentity();
  glRotatef(-7.7246, 1.0,0.0,0.0);
  glRotatef(1.5039, 0.0,1.0,0.0);
  glRotatef(0.4785, 0.0,0.0,1.0);
  glScalef(1.2,1.2,1.2);
  glGetDoublev(GL_MODELVIEW_MATRIX,trans);

  for(i=0;i<NB_MACH;i++) {
	do_trans(&MACH[i].x,&MACH[i].y,&MACH[i].z,trans);
  }

  fid=fopen("/tmp/pts_mach.txt","w");
  fprintf(fid,"Condyle: %f %f %f\n",CONDYLE.x,CONDYLE.y,CONDYLE.z);
  for(i=0;i<NB_MACH;i++) {
    fprintf(fid,"%f %f %f\n",MACH[i].x,MACH[i].y,MACH[i].z);
  }
  fclose(fid);

  fid=fopen("/tmp/pts_pal.txt","w");
  for(i=0;i<NB_PAL;i++) {
    fprintf(fid,"%f %f %f\n",PAL[i].x,PAL[i].y,PAL[i].z);
  }
  fclose(fid);
}

	// Optimisations & configurations diverses
	glEnable(GL_CULL_FACE); // On enleve les faces arrieres
	glDisable(GL_LIGHTING);
	glDisable(GL_COLOR_MATERIAL);

	// On active le Z buffer
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);

	// Pas de lissage (Gouraud...)
	glShadeModel(GL_FLAT);

// !!! On en reserve une systematiquement (anti-bug...)
if (MINIM_NB_TEX_PLUS==0) TOT_TEX++;

	// Declare/reserve l'utilisation future de textures  GL
	MINIM_TEX_ID=(volatile unsigned int *)malloc(TOT_TEX*sizeof(int));
	TEX_MUL=(uv2D *)malloc(TOT_TEX*sizeof(uv2D));
	glGenTextures(TOT_TEX,(unsigned int *)MINIM_TEX_ID);

	// Lecture des eventuelles images supplementaires
	// FORCEMENT A PARTIR DU SLOT 0
	for (slot=0;slot<MINIM_NB_TEX_PLUS;slot++) {
	  if (MINIM_TEX_PLUS[slot][0]) load_tex_img(MINIM_TEX_PLUS[slot],slot);
	}

if (MINIM_NB_TEX_PLUS==0) MINIM_NB_TEX_PLUS++;

	// Lecture des differentes textures pour "-mdl" et xtra
	for(slot=0;slot<fabs(NB_TEX);slot++)
		load_tex_img(TEX_FILE[slot],MINIM_NB_TEX_PLUS+slot);
	// premier slot libre :
	slot+=MINIM_NB_TEX_PLUS;

#ifdef USE_DENTS
	// chargement de la texture du palais
	if (SLOT_PAL) {
	    load_tex_img(TEX_PAL_FILE,SLOT_PAL=slot++);
	    read_pos_all(P2D_PAL_FILE,PAL_POS2D);
//	    set_alpha_pal();
	}

	if (SLOT_MACH) {
	    load_tex_img(TEX_MACH_FILE,SLOT_MACH=slot++);
	    read_pos_all(P2D_MACH_FILE,MACH_POS2D);
	}
#endif // USE_DENTS

#ifdef USE_EYES
	if (SLOT_EYES)
	  load_tex_img(TEX_EYES_FILE,SLOT_EYES=slot++);
#endif

#ifdef USE_OBJS
	for(j=0;j<NB_OBJS;j++)
	  if (OBJS[j].texfile) load_tex_img(OBJS[j].texfile,OBJS[j].slot_tex=slot++);
#endif

	// Lecture de l'eventuelle image de fond
	if ((USE_BACK=(TEX_BACK[0]!=0)))
		load_tex_img(TEX_BACK,SLOT_BACK=slot++);

	// Init eventuelle du client
	if (func_init)
	  func_init();

	// Creation de la premiere image
	glDrawBuffer(GL_BACK);
	draw_all(); // BUG !!!! trop tot pour glut ???

	// sauvegarde eventuelle des points 3D
	if (OUT_PTS!=NULL) save_pts3D(OUT_PTS);
	// sauvegarde eventuelle des points 2D
	if (OUT_POS!=NULL) {
	    move_head();
	    save_pos2D(OUT_POS);
	}

#ifdef USE_DENTS
	// sauvegarde eventuelle des points 2D/3D  machoire/palais
	if (OUT_PTSPAL!=NULL) save_pts3D_pal(OUT_PTSPAL);
	if (OUT_POSPAL!=NULL) save_pos2D_pal(OUT_POSPAL,0);
	if (OUT_POSMACH!=NULL) save_pos2D_pal(OUT_POSMACH,1);
#endif // USE_DENTS
}


typedef enum { // tv_mode
  tv_interlace=0,  // 25 Hz ou 30 Hz, avec trame (du bas en premier)
  tv_double,	 // 50 ou 60 Hz sans trame
  tv_progressive, // 25 Hz ou 30Hz, sans trame
  tv_error
} tv_mode;

unsigned char *def_tv_mode[]={"interlaced","double","pc"};

tv_mode TV_MODE=tv_progressive;

// Sauvegarde d'une sequence video
void video_save()
{
  char tmp_sav[255];
  unsigned char *image;
  unsigned char *buff=NULL;
  int purge;
  int spd_play=0;
  int spd_save=0;
  int bas=1;

  image=(unsigned char *)malloc(3*MINIM_WIDTH*MINIM_HEIGHT);

  glReadBuffer(GL_BACK);
  glDrawBuffer(GL_BACK);

  // 1er redraw pour rien ! Sinon BUG de grab ?
  for(purge=1;purge<2;purge++) {
	draw_all();
#ifdef __UNIX__
	Minim_gl2pnm(image);
#else
	Minim_gl2bmp(image);
#endif
	glutSwapBuffers();
  }

  // on essaye de se ramener a 30Hz ou moins (AVI)
  while (F_RATE>(30<<spd_play)) spd_play++;

  // On ajuste en fonction du mode de sortie
  switch(TV_MODE) {
	case tv_error:
	case tv_interlace:
	  buff=(unsigned char *)malloc(3*MINIM_WIDTH*MINIM_HEIGHT);
	  spd_save=spd_play--;
	  break;
	case tv_double:
	  spd_save=--spd_play;
	  break;
	case tv_progressive:
	  spd_save=spd_play;
	break;
  }

  if (spd_play|spd_save)
	 printf("Facteur de ralentissement : %dx en lecture, %dx en sauvegarde.\n",1<<spd_play,1<<spd_save);
  printf("Sauvegarde a %3.2f Hz (%s frames).\n",F_RATE/(1<<spd_save),(TV_MODE==tv_interlace)?"interlaced":"full");

  // on sauve l'image ou la sequence
  for(ART_CNT=0;(ART_CNT<ART_MAX)||(ART_CNT==0);ART_CNT+=(1<<spd_play)) {

	  // draw
	  dict_anim_eyes(ART_CNT*1000.0/F_RATE);
	  update_pause(ART_CNT,0);
	  draw_all();

	  // Grab
	  if (OUT_IMG_PNM) {
		Minim_gl2pnm((bas==0)?buff:image);
	  } else {
		Minim_gl2bmp((bas==0)?buff:image);
	  }

	  // Entrelacement des deux dernieres images ?
	  if (TV_MODE==tv_interlace) {
		if (bas==0) {
		  int y;
		  unsigned char *dst=image;
		  unsigned char *src=buff;
		  for(y=0;y<MINIM_HEIGHT;y+=2) {
			bcopy(src,dst,3*MINIM_WIDTH);
			dst+=2*3*MINIM_WIDTH;
			src+=2*3*MINIM_WIDTH;
		  }
		}
		bas=1-bas;
	  }

	  // Sauvegarde
	  if (bas==1) {
		// pnm ou bmp ? numerote ou pas ?
		if (ART_MAX>0)
		  sprintf(tmp_sav,"%s_%.4d.%s",OUT_IMG,ART_CNT>>spd_save,OUT_IMG_PNM?"pnm":"bmp");
		else
		  sprintf(tmp_sav,"%s.%s",OUT_IMG,OUT_IMG_PNM?"pnm":"bmp");
		// creation du fichier
		printf("%05d %s%c",ART_CNT,tmp_sav,13);
		if (OUT_IMG_PNM)
		  save_img2pnm(image,tmp_sav);
		else
		  save_img2bmp(image,tmp_sav);
	  }

	  // retour  visuel
	  glutSwapBuffers();
  } // for ART_CNT

  free(image);
  if (buff!=NULL)
	free(buff);
}

// ---- INTERFACAGE AVEC GLUT
int DRAG_I=0;
int MX,MY;

void drag_handler(int x, int y)
{
  int sld;

	// Methode interne a Minim
	if (DRAG_I>=0) {
    if (DRAG_I<NB_SLD) {
      // gestion d'un slider
		sld=NB_ART_MDL-1-DRAG_I;
      ART[(sld<NB_ART_LU)?ART_CNT:0][sld]=((float)x/MINIM_WIDTH-.5)*2.0*3.5;
    } else if (!i_m_a_thread) {
      // changement de l'orientation
      OBJ_ROT[1]-=(x-MX)/3.0;
      OBJ_ROT[0]+=(MY-y)/3.0;
      MX=x;MY=y;
    }
  }
}

void mouse_handler(int button, int state,int x, int y)
{
    // Methode  interne a Minim
	if ((DRAG_I=(MINIM_HEIGHT-1-y)/12)<NB_SLD) {
        if (!state) drag_handler((button==0)?x:(MINIM_WIDTH/2),y);
        if (button!=0) DRAG_I=-1;
    } else {
#ifdef USE_TET_LINUX
			if (state) myTET_state.click=4;
#endif
        MX=x;MY=y;
        if (button>0) OBJ_ROT[0]=OBJ_ROT[1]=0.0;
    }
}

void key_handler(unsigned char key,int x, int y)
{
    int i;

    // Methode  interne a Minim

	// quitter
    if ((key=='q')|(key=='Q'))
	  if ((pending_close=!i_m_a_thread))
		exit(0);

#ifdef USE_DENTS
	// dents
    if ((key=='d')||(key=='D')) {
				NB_PAL=-NB_PAL;
				NB_MACH=-NB_MACH;
    }
#endif // USE_DENTS

	// background
    if ((key=='b')||(key=='B')) {
        if (TEX_BACK[0]!=0) USE_BACK=!USE_BACK;
		if (USE_BACK&&USE_BACKI) update_pause(ART_CNT,1);
	}

#ifdef USE_EYES
	// eyes
	if ((key=='e')||(key=='E'))
		NB_TMSK=-NB_TMSK;
	// look
	if ((key=='y')||(key=='Y')) {
		Z_OFF=(float)y/MINIM_HEIGHT*200.0;
		Minim_eyes_direction2D(1.0,MEMO_X,MEMO_Y);
	} if ((key=='l')||(key=='L'))
		Minim_eyes_direction2D(1.0,x,y);
	if ((key=='w')||(key=='W'))
		printf("Looking at : %f %f\n",2*(float)x/MINIM_WIDTH-1.0,1.0-2*(float)y/MINIM_HEIGHT);
#endif // USE_EYES

#ifdef USE_TET_WIN
	// Lecture d'un fichier de calibration
	if ((key=='c')||(key=='C')) {
		track_cal("Elisei");
	} else if ((key=='g')||(key=='G')) {
		track_cal("Grard");
	} else if (key=='0') {
		track_cal("test");
	}
#endif // USE_TET_WIN

	// face
	if ((key=='f')||(key=='F'))
		Minim_head_direction2D(.8,1.0,x,y);

	// move
	if ((key=='m')||(key=='M'))
		Minim_cam_change(2*x/(float)MINIM_WIDTH-1.0,1.0-2*y/(float)MINIM_HEIGHT,CAM_ZOOM);

	// zoom
	if ((key=='z')||(key=='Z'))
		Minim_cam_change(CAM_DX,CAM_DY,.25+x*.75/MINIM_WIDTH+y*4.0/MINIM_HEIGHT);

	// slider
  if ((key=='s')||(key=='S'))
    NB_SLD=(NB_SLD==0)?NB_ART_MDL:0;

  // pause
  if (key==' ') {
	if ((MINIM_PAUSED=!MINIM_PAUSED)) {
	  ftime(&PAUSE_TIME);
	  update_pause(ART_CNT,1);
	} else {
	  printf("Unpaused\n");
	  // restore pointers ?
	  if (PAUSE_TIME.time) {
		struct timeb now;
		int sec,ms;
	    ftime(&now);
	    sec=now.time-PAUSE_TIME.time+START_TIME.time;
	    ms=now.millitm-PAUSE_TIME.millitm+START_TIME.millitm;
	    if (ms<0) {sec-=1;ms+=1000;}
	    if (ms>999) {sec+=1;ms-=1000;}
	    START_TIME.time=sec;
	    START_TIME.millitm=ms;
	    WAV_PTR=WAV_SIZ*(1.0-(float)ART_CNT/ART_MAX);
	    WAV_PTR=8*((int)WAV_PTR/8);
	  }
	} // paused/unpaused
  } // ' '

  if (MINIM_PAUSED&&(key=='+')) {
	ART_CNT+=(ART_CNT<ART_MAX-1)?1:0;
	update_pause(ART_CNT,1);
  }

  if (MINIM_PAUSED&&(key=='-')) {
	ART_CNT-=(ART_CNT>0)?1:0;
	update_pause(ART_CNT,1);
  }

  if ((key=='g')||(key=='G')) {
	MINIM_PAUSED=1;
	PAUSE_TIME.time=0;
	printf("Frame: ");
	scanf("%d",&ART_CNT);
	if (ART_CNT<0) ART_CNT=0;
	if (ART_CNT>=ART_MAX) ART_CNT=ART_MAX-1;
	  update_pause(ART_CNT,1);
	// printf("Paused at frame: %d/%d\n",ART_CNT,ART_MAX-1);
  }

/*
  // test du mode plein ecran
  if ((key=='p')||(key=='P')) {
	static int IS_FULL_SCREEN=0;
	if ((IS_FULL_SCREEN=~IS_FULL_SCREEN)) {
	  glutEnterGameMode();
	  attach_glut();
	} else {
	  glutLeaveGameMode();
	  attach_glut();
	}
  }
*/

  // texture
  if ((key=='t')||(key=='T')){
#ifdef USE_OBJS
	int i;
	for(i=0;i<NB_OBJS;i++)
	  OBJS[i].nb_tex=-OBJS[i].nb_tex;
#endif // USE_OBJS
    NB_TEX=-NB_TEX;
	if (NB_XTR>0) USE_TEX_XTRA=!USE_TEX_XTRA;
#ifdef USE_EYES
	if (NB_TMSK>0) SLOT_EYES=-SLOT_EYES;
#endif
#ifdef USE_DENTS
	if (NB_PAL>0) SLOT_PAL=-SLOT_PAL;
	if (NB_MACH>0) SLOT_MACH=-SLOT_MACH;
#endif // USE_DENTS
  }

	// visu des triangles 'extra'
	if ((key=='x')||(key=='X'))
		NB_XTR=-NB_XTR;

	// visu des valeurs de slider
	if ((key=='v')||(key=='V')) for (i=0;i<((NB_ART_LU>0)?NB_ART_LU:NB_ART_MDL);i++)
	  printf("%2.5f%c",ART[MINIM_PAUSED?ART_CNT:0][i],(i==((NB_ART_LU>0)?NB_ART_LU:NB_ART_MDL)-1)?10:32);

	// replay de la sequence courante
	if ((key=='r')||(key=='R'))
		play_msg(0,0);

	// replay d'un "logo"
	if ((key>'0')&&(key<='9'))
		play_msg(key-'0',0);

#ifdef USE_DENTS
	// save ?
    if ((key=='s')||(key=='S')) {
      if (OUT_POSPAL!=NULL)
        save_pos2D_pal( OUT_POSPAL, 0 );
      if (OUT_POSMACH!=NULL)
				save_pos2D_pal( OUT_POSMACH, 1 );
		}
#endif // USE_DENTS

}

// Functions pour qu'un client externe puisse s'interfacer avec Minim & GLUT :
// Celles-ci sont optionnelles, EN REMPLACEMENT du comportement par defaut
void (*func_key)(unsigned char key,int x, int y)= key_handler;
void (*func_click)(int button, int state, int x, int y)= mouse_handler;
void (*func_drag)(int x, int y)= drag_handler;
void (*func_move)(int x, int y)= mouse_mov_handler;

// Functions pour qu'un client externe puisse s'interfacer avec Minim & GLUT :
// Celles-ci sont optionnelles, EN PLUS du comportement par defaut
void (*func_display)()= NULL;
void (*func_idle)()= NULL;
void (*func_reshape)(int x,int y)= NULL;

void redisplay_handler(void)
{
	draw_all();
	// Y-a-t-il un client a appeler ?
	if (func_display) {
	  // Contexte graphique simple :
	  glDisable(GL_TEXTURE_2D);
	  glMatrixMode(GL_PROJECTION);
	  glLoadIdentity();
	  glMatrixMode(GL_MODELVIEW);
	  glLoadIdentity();
	  // On passe la main temporairement.
	  func_display();
	}
    glutSwapBuffers();
}

void reshape_handler(int x,int y)
{
    glViewport(0,0,MINIM_WIDTH=x,MINIM_HEIGHT=y);
	// On transmet au client eventuel
	if (func_reshape)
	  func_reshape(x,y);
}

void idle(void)
{
  struct timeb now;
  int is_speaking;
  long signed int lon;

  // On appelle le idle() d'un client ?
  if (func_idle)
    func_idle();

#ifdef USE_SOCK
  unsigned char buf30[30];
  unsigned char *buf=buf30;
  int nb_lu;
  struct sockaddr_in sin;
  int sin_len;
#endif // USE_SOCK

  // Est-ce la premiere passe graphique ?
  if (MINIM_NOT_READY) {
    MINIM_NOT_READY=0;
    MINIM_X=glutGet(GLUT_WINDOW_X);
    MINIM_Y=glutGet(GLUT_WINDOW_Y);
//    printf("%dx%d+%d+%d\n",MINIM_WIDTH,MINIM_HEIGHT,MINIM_X,MINIM_Y);
//    printf("Screen: %dx%d = %dmmx%dmm\n",glutGet(GLUT_SCREEN_WIDTH),glutGet(GLUT_SCREEN_HEIGHT),glutGet(GLUT_SCREEN_WIDTH_MM),glutGet(GLUT_SCREEN_HEIGHT_MM));
  }

  // Fermeture demandee ?
  if (pending_close) {
	MINIM_NOT_READY=1;
	// Provoque un exit mortel si on est en thread !
	if (i_m_a_thread) {
	  glutDestroyWindow(WIN);
	} else {
	  exit(0);
	}
	return;
  }

  // Hide ou show du clone
  if (pending_hc) {
    if (pending_hc>0)
	glutHideWindow();
    else
	glutShowWindow();
    pending_hc=0;
  }

  // Window size
  if (pending_sws) {
    glutReshapeWindow(MINIM_WIDTH=pending_sws_w,MINIM_HEIGHT=pending_sws_h);
    pending_sws=0;
  }

  // Window position
  if (pending_swp) {
    glutPositionWindow(MINIM_X=pending_swp_x,MINIM_Y=pending_swp_y);
    pending_swp=0;
  }

  // Lecture et lancement d'une sequence en attente de traitement ?
  if (pending_input!=pending_input_done) {
    // Le frame rate sera devine d'apres les fichiers
    F_RATE=-50;
    // Le message ne bouclera pas
    LOOP=0;
    // On lit d'abord la sequence (et sa longueur), puis l'audio (et sa duree)
    read_art(pending_art_file,1);
    open_wav(pending_wav_file,1);
    pending_input_done=pending_input;
    if (pending_autorun) play_msg(0,0);
  }

  // Sauvegarde (prioritaire et exclusive) demandee ?
  if (OUT_IMG!=NULL) {
	video_save();
	exit(0);
  }

#ifdef USE_SOCK
  // Gestion d'une eventuelle nouvelle connexion
  if (SOCK_SRV!=-1) {
   	int t;
		t=accept(SOCK_SRV,(struct sockaddr *)&sin,&sin_len);
		if (t>0) {
      if (SOCK!=-1) close(SOCK);
			SOCK=t;
	    ioctl(SOCK,F_SETFL,O_NONBLOCK);
	    ART_CNT=ART_MAX_CN=0;
	    ART_MAX=1;
	    printf("Connection\n");
		}
	}

  // Y a-t-il des parametres en attente d'etre lus ?
  if (SOCK!=-1) {
    ioctl(SOCK,I_NREAD,&nb_lu);
    // attention, (tentative de) lecture en paquets (5x6) des parametres...
    if (((nb_lu=read(SOCK,(void *)buf,30))<0)||(nb_lu==1)) {
			// erreur, ou on a recu un message de fin
			ART_MAX=ART_MAX_CN;
			close(SOCK);
			SOCK=-1;
			printf("Deconnection\n");
		} else {
//      needs_redraw=-1;
      for(;nb_lu>=6;nb_lu-=6) {
        for(i=NB_ART_MDL;--i>=0;)
					ART[0][i]=ART[ART_MAX_CN][i]=buf[i]/256.0*8.0-4.0;
          buf=buf+NB_ART_MDL;
        }
      }
    }
#endif // USE_SOCK

    ftime(&now);

#ifdef USE_TET
if (TET_ACTIF) {
	int zone=0,l;
	float e_spd=0.6;
	float f_spd=0.2;

	// Quel logo (numerote a partir de 1) regarde-t'on ?
	for(l=0;l<NB_LOGO;l++)
	  if ((myTET_state.X>LOGOS[l].x0)&&(myTET_state.X<LOGOS[l].x1) \
		  &&(myTET_state.Y<LOGOS[l].y0)&&(myTET_state.Y>LOGOS[l].y1))	zone=l+1;

	// On "fixe" un meme logo ?
	if (zone==myTET_state.zone) {
	  e_spd=0.9;
	  myTET_state.col+=0.015;
	  if ((now.time>myTET_state.rdv)||(myTET_state.click==4)) {
		  f_spd=0.4;
		  if (zone&&(zone!=NB_LOGO)) {
			  // On desarme le rendez-vous
		  	  myTET_state.rdv+=10000000;
			  // On active art/wav de la zone
				myTET_state.click=5; // Experimental !
				play_msg(zone,0);
		  } else if (myTET_state.off>=12) {
			  // On stoppe le son (et l'articulation ?) !
				Minim_stop_msg();
			}
	  }
	} else { // On arme la fixation
		myTET_state.click=0;
		myTET_state.zone=zone;
		myTET_state.rdv=now.time+3;
		myTET_state.col=0.0;
	}

	// Parole en cours ou eye-contact direct ?
	if ((WAV_PTR>=0)||(zone==NB_LOGO)) {
#ifdef USE_EYES
		eyes_direction3D(e_spd,0.0,0.0,1.0,0.0);
#endif // USE_EYES
		Minim_head_direction2D(f_spd,0.25,MINIM_WIDTH*(myTET_state.X+1.0)/2.0,MINIM_HEIGHT*(1.0-myTET_state.Y)/2.0);
		myTET_state.rdv_oeillade_s=0;
	} else {
		signed long delay;
		if ((delay=(now.time-myTET_state.rdv_oeillade_s))>=-1) {
			if (delay>4) { // on arme pour la premiere fois
				myTET_state.rdv_oeillade_s=1+now.time;
				myTET_state.rdv_oeillade_ms=now.millitm/2;
			} else {
				// on va planifier les mouvements de l'oeillade
				delay=1000*delay+(now.millitm-myTET_state.rdv_oeillade_ms);
#ifdef USE_EYES
				if (delay<200)
					Minim_eyes_direction2D(0.8, MINIM_WIDTH/2, MINIM_HEIGHT/2);
				else
					Minim_eyes_direction2D(0.8,MINIM_WIDTH*(myTET_state.X+1.0)/2.0,MINIM_HEIGHT*(1.0-myTET_state.Y)/2.0);
#endif // USE_EYES
				if (delay>400) {	// on rearme
					myTET_state.rdv_oeillade_s=1+now.time;
					if ((myTET_state.rdv_oeillade_ms=now.millitm/2+(rand() & 1023))>1000) {
						myTET_state.rdv_oeillade_ms-=1000;
						myTET_state.rdv_oeillade_s++;
					}
				}
			}
		}
#ifdef USE_EYES
		else
			Minim_eyes_direction2D(e_spd,MINIM_WIDTH*(myTET_state.X+1.0)/2.0,MINIM_HEIGHT*(1.0-myTET_state.Y)/2.0);
#endif // USE_EYES
		Minim_head_direction2D(f_spd,1.0,MINIM_WIDTH*(myTET_state.X+1.0)/2.0,MINIM_HEIGHT*(1.0-myTET_state.Y)/2.0);
	}
}
#endif // USE_TET

		if (WAV_PTR<0) { // replay termine
		  // On redemarre le replay de la sequence ?
		  if (WAV_PTR==-120) {
				play_msg(0,1);
		  } else if (LOOP&&!MINIM_PAUSED)
			  WAV_PTR-=1;
		} else { // replay en cours
#ifdef USE_AUDIO_LINUX
			// On ecrit un peu de son ?
			if ((WAV_PTR>0)&&!MINIM_PAUSED&&WAV_DEV) {
				int max;
#ifdef BUG_BLOCKING_AUDIOCARD
				// polling 'actif' pour contourner les drivers/cartes audio peu cooperatives
				struct audio_buf_info aubuf;
				ioctl(WAV_DEV,SNDCTL_DSP_GETOSPACE,&aubuf);
  				MAX_AWR=(aubuf.bytes<0)?0:aubuf.bytes; // Feature OSS/ALSA
#endif
				max=(WAV_PTR<MAX_AWR)?WAV_PTR:MAX_AWR;
				if ((lon=write(WAV_DEV,WAV_DAT+(WAV_SIZ-WAV_PTR),max))>0)
					WAV_PTR-=lon;
				if ((lon==-1)&&(errno!=EAGAIN)) {
					printf(" Erreur (audio write) : %d\n",errno);
					WAV_PTR=0;
				}
			}
#endif // Linux

			// Calcul du temps coul (en milli-secondes)
			lon=now.millitm-START_TIME.millitm+1000L*(long signed int)(now.time-START_TIME.time);

#ifdef USE_DICT
			dict_anim_eyes(lon);
#endif // USE_DICT

			// Est-on en butee ?
			if (!MINIM_PAUSED) {
			if ((is_speaking=(lon<1000*ART_MAX/F_RATE))) {
			  ART_CNT=(int)(lon/1000.0*F_RATE);
			} else {
			  if (MINIM_IS_SPEAKING) // On vient de s'arreter
				ftime(&MINIM_END_TIME);
			  ART_CNT=ART_MAX-1;
			  if ((WAV_PTR<=0)) WAV_PTR-=1; // Signal de fin de parole
			}
			if (USE_BACKI&&USE_VIDEO) {
			  static int dec=1;
			  if (!--dec) {
				dec=USE_VIDEO;
				update_pause(ART_CNT,0);
			  }
			}
			MINIM_IS_SPEAKING=is_speaking;
			}
		} // replay en cours

    if (~pending_close)
	  glutPostRedisplay();
}


void attach_glut()
{
    glutDisplayFunc(redisplay_handler);
    glutReshapeFunc(reshape_handler);
    glutIdleFunc(idle);

    glutKeyboardFunc(func_key);
    glutMotionFunc(func_drag);
    glutPassiveMotionFunc(func_move);
    glutMouseFunc(func_click);
}

void open_display()
{
    // 24 bits par pixel, Double buffer, Z buffer reserve
		// eventuellement  stencil (yeux)
		GLenum gl_md=GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH ;
#ifdef USE_EYES
		if (NB_TMSK>0)
			gl_md|= GLUT_STENCIL;
#endif // USE_EYES

    glutInitDisplayMode(gl_md);

    // Position initiale en option
    if (pending_swp) {
	glutInitWindowPosition(pending_swp_x,pending_swp_y);
	pending_swp=0;
    }

    // Taille initiale en option
    if (pending_sws) {
	MINIM_WIDTH=pending_sws_w;
	MINIM_HEIGHT=pending_sws_h;
	pending_sws=0;
    }

#ifdef USE_TET_WIN
    glutInitWindowPosition(1280,0);
#endif // USE_TET_WIN
    glutInitWindowSize(MINIM_WIDTH,MINIM_HEIGHT);
    WIN=glutCreateWindow("Minim");

/*
	// Test du plein ecran :
	attach_glut();
	glutEnterGameMode();
*/

    // Initialisation de GL
    Minim_GLinit();

    // On dclare nos fonctions de rponse aux vnements graphiques
	// Et les options vectorisees/detournables
	attach_glut();

		// Besoin du frame_rate par defaut ?
    if (F_RATE<0) F_RATE=-F_RATE;

    // Boucle des vnements de glut
    glutMainLoop();
}

#ifdef USE_SOCK
int open_srv(char *host_srv)
{
    int cnx_sock;
    struct sockaddr_in sin;
    struct hostent *hp;

    cnx_sock=socket(AF_INET,SOCK_STREAM,0);
    fcntl(cnx_sock,F_SETFL,O_NONBLOCK);

    hp=gethostbyname(host_srv);
    bcopy(hp->h_addr,(char*)&sin.sin_addr,sizeof(struct in_addr));
    sin.sin_family=AF_INET;
    sin.sin_port=htons(2718);
    if (bind(cnx_sock,(struct sockaddr *)&sin,sizeof(sin)))
    	cnx_sock=-1;

    if (listen(cnx_sock,1)<0)
    	cnx_sock=-1;

    printf("Ecoute reseau :\n");
    if (cnx_sock==-1)
	printf("  !!! ECHEC !!! sur %s\n",host_srv);
    else
	printf("  %s\n",host_srv);

    return(cnx_sock);
}
#endif

// Memorisation des chemins des parametres du clone
// ou des valeurs par defaut pour garantir la compatibilite future

char cam_file[MAX_STRING];
char mdl_file[MAX_STRING];
char msh_file[MAX_STRING];
char tex_file[MAX_STRING];
char art_file[MAX_STRING];
char mov_file[MAX_STRING];
char fap_file[MAX_STRING];
char wav_file[MAX_STRING];
char host_srv[MAX_STRING];
char pal_file[MAX_STRING];
char mach_file[MAX_STRING];
char eye_def_file[MAX_STRING];
char eye_art_file[MAX_STRING];
char logo_file[MAX_STRING];
char dic_file[MAX_STRING];

void rgbstr2vals(char *rgbstr,float *r,float *g,float *b)
{
  long RGB=strtol(rgbstr,NULL,16);

  *r=(RGB>>16)/255.0;
  *g=((RGB>>8)&0xFF)/255.0;
  *b=(RGB&0xFF)/255.0;
}


void _new_sequence(char * art_file,char *wav_file, int delete_files, int autorun)
{
 if (pending_delete) {
   printf("  **** Il faudrait effacer :/n");
   printf("  ****  %s/n  ****  %s/n", pending_art_file, pending_wav_file);
   pending_delete=0;
 }
 // On memorise les chemins
 strncpy(pending_art_file, art_file, MAX_STRING);
 strncpy(pending_wav_file, wav_file, MAX_STRING);
 // On signale l'evenement pour le prochain idle
 pending_input++;
 pending_delete=delete_files;
 pending_autorun=autorun;
}

// ----------------------------------------
// Fonctions exportees pour les clients
// ----------------------------------------
// Cf. Minim_lib.h pour les details sur les appels.

void Minim_run_sequence(char * art_file,char *wav_file, int delete_files) {
  _new_sequence(art_file,wav_file,delete_files,1);
}

void Minim_load_sequence(char * art_file,char *wav_file, int delete_files) {
  _new_sequence(art_file,wav_file,delete_files,0);
}

void Minim_def_cloneV(int argc, char *argv[])
{
  int i, unknown=0;

  // GLUT essaye de reconnaitre ses arguments (-display ...)
  glutInit(&argc,argv);

  // Noms de fichier par defaut
  strcpy(cam_file,"cam/default.txt");
  strcpy(msh_file,"msh/null.txt");
  strcpy(art_file,"art/default.txt");
  strcpy(tex_file,"tex/null.txt");
  strcpy(mdl_file,"");
  strcpy(mov_file,"");
  strcpy(fap_file,"");
  strcpy(wav_file,"");
  strcpy(host_srv,"");
  strcpy(TEX_BACK,"");
  strcpy(pal_file,"");
  strcpy(mach_file,"");
  strcpy(eye_art_file,"");
  strcpy(eye_def_file,"");
  strcpy(logo_file,"");
  strcpy(dic_file,"");
#ifdef USE_AUDIO_LINUX
  strcpy(myAUDIODEV,AUDIODEV);
#endif // AUDIO_LINUX

  // Interpretation des arguments reconnus ou pas
  for(i=1;i<argc;i++) {
	// Flags sans parametres
    if (strcmp(argv[i],"-sld")==0) {
      NB_SLD=-1;
	} else if (strcmp(argv[i],"-backi")==0) {
	  USE_BACKI=1;
	} else if (strcmp(argv[i],"-unproject")==0) {
	  USE_UNPROJ++;
	} else if (strcmp(argv[i],"-video")==0) {
	  USE_VIDEO=10;
	} else if (strcmp(argv[i],"-resources")==0) {
	  TRACE_RES=1;
#ifdef USE_DENTS
    } else if (strcmp(argv[i],"-close_lips")==0) {
      USE_CLOSE_LIPS=-1;
#endif // USE_DENTS
#ifdef USE_DICT
	} else if ((strcmp(argv[i],"-dic")==0)&&(i+1<argc)) {
			strcpy(dic_file,argv[++i]);
	} else if (strcmp(argv[i],"-seg")==0) {
			seg_flag=1;
#endif // USE_DICT
#ifdef USE_TET_WIN
	} else if ((strcmp(argv[i],"-tet")==0)&&(i+1<argc)) {
	  CAL_NAME=argv[++i];
	  TET_ACTIF=1;
#endif // USE_TET_WIN
#ifdef USE_TET_LINUX
	} else if (strcmp(argv[i],"-tet")==0) {
	  TET_ACTIF=1;
#endif // USE_TET_LINUX
	// Flags avec au moins un parametre supplementaire
	} else if (i+1<argc) {
        if (strcmp(argv[i],"-cam")==0) {
            strcpy(cam_file,argv[++i]);
			// Scaling/translation ?
			if ((i+1<argc)&&(argv[i+1][0]=='='))
			  sscanf(argv[++i],"=x%f%f%f",&CAM_ZOOM,&CAM_DX,&CAM_DY);
        } else if (strcmp(argv[i],"-mdl")==0) {
            strcpy(mdl_file,argv[++i]);
        } else if (strcmp(argv[i],"-msh")==0) {
            strcpy(msh_file,argv[++i]);
        } else if (strcmp(argv[i],"-tex")==0) {
            strcpy(tex_file,argv[++i]);
        } else if (strcmp(argv[i],"-art")==0) {
            strcpy(art_file,argv[++i]);
        } else if (strcmp(argv[i],"-back")==0) {
			if (argv[++i][0]=='#') { // Couleur
			  rgbstr2vals(&argv[i][1],&BACK_R,&BACK_G,&BACK_B);
			} else { // Image
			  strcpy(TEX_BACK,argv[i]);
			  TOT_TEX++;
			}
        } else if (strcmp(argv[i],"-plus")==0) {
			do {
			  MINIM_TEX_PLUS[MINIM_NB_TEX_PLUS++]=strdup(argv[++i]);
			} while ((MINIM_NB_TEX_PLUS<MAX_TEX_PLUS)&&(i+1<argc)&&(argv[i+1][0]!='-'));
			TOT_TEX+=MINIM_NB_TEX_PLUS;
        } else if (strcmp(argv[i],"-mov")==0) {
            strcpy(mov_file,argv[++i]);
        } else if (strcmp(argv[i],"-fap")==0) {
            strcpy(fap_file,argv[++i]);
        } else if (strcmp(argv[i],"-out_tv")==0) {
			int j;
			TV_MODE=tv_error;
			i++;
            for(j=0;j<=2;j++)
			  if (strcmp(argv[i],def_tv_mode[j])==0) TV_MODE=j;
			if (TV_MODE==tv_error) {
			  printf("ERROR : Invalid option for -out_tv (%s), instead of :\n  %s, %s or %s\n",argv[i],def_tv_mode[0],def_tv_mode[1],def_tv_mode[2]);
			  exit(-1);
			}
//#ifdef USE_AUDIO
        } else if (strcmp(argv[i],"-wav")==0) {
            strcpy(wav_file,argv[++i]);
		} else if (strcmp(argv[i],"-audiodev")==0) {
			strcpy(myAUDIODEV,argv[++i]);
//#endif // USE_AUDIO
        } else if (strcmp(argv[i],"-fps")==0) {
            F_RATE=atof(argv[++i]);
		} else if (strcmp(argv[i],"-logo")==0) {
            strcpy(logo_file,argv[++i]);
        // Fichiers en sortie
        } else if (strcmp(argv[i],"-out_pnm")==0) {
            OUT_IMG=strdup(argv[++i]);
			OUT_IMG_PNM=1;
		} else if (strcmp(argv[i],"-out_bmp")==0) {
            OUT_IMG=strdup(argv[++i]);
			OUT_IMG_PNM=0;
		} else if (strcmp(argv[i],"-out_pts")==0) {
            OUT_PTS=strdup(argv[++i]);
        } else if (strcmp(argv[i],"-out_pos")==0) {
            OUT_POS=strdup(argv[++i]);
#ifdef USE_SOCK
		} else if (strcmp(argv[i],"-srv")==0) {
            strcpy(host_srv,argv[++i]);
#endif // USE_SOCK
#ifdef USE_DENTS
		// le palais
		} else if (strcmp(argv[i],"-ptspal")==0) {
			OUT_PTSPAL=strdup(argv[++i]);
		} else if (strcmp(argv[i],"-pospal")==0) {
			OUT_POSPAL=strdup(argv[++i]);
		} else if (strcmp(argv[i],"-posmach")==0) {
			OUT_POSMACH=strdup(argv[++i]);
		} else if (strcmp(argv[i],"-pal")==0) {
			strcpy(pal_file,argv[++i]);
#ifdef USE_OBJS
			// On memorise un objet de rattachement
			PAL_REF=NB_OBJS-1;
#endif // USE_OBJS
		} else if (strcmp(argv[i],"-mach")==0) {
			strcpy(mach_file,argv[++i]);
#ifdef USE_OBJS
			// On memorise un objet de rattachement
			MACH_REF=NB_OBJS-1;
#endif // USE_OBJS
#endif // USE_DENTS
#ifdef USE_EYES
		} else if ((strcmp(argv[i],"-eye")==0)&&(i+2<argc)) {
			strcpy(eye_def_file,argv[++i]);
			strcpy(eye_art_file,argv[++i]);
#ifdef USE_OBJS
			// On memorise un objet de rattachement
			EYE_REF=NB_OBJS-1;
#endif // USE_OBJS
#endif // USE_EYES
#ifdef USE_OBJS
		} else if ((strcmp(argv[i],"-obj")==0)&&(i+2<argc)) {
			i++; // Type de l'objet ?
			if (strcmp(argv[i],"Face")==0) {
			  OBJS[NB_OBJS].tObj=oFace;
//			  OBJS[NB_OBJS].use_GLtrans=1;
			} else if (strcmp(argv[i],"Diff")==0) {
			  OBJS[NB_OBJS].tObj=oDiff;
			} else if (strcmp(argv[i],"Hand")==0) {
			  OBJS[NB_OBJS].tObj=oHand;
			} else if (strcmp(argv[i],"Mdl2")==0) {
			  OBJS[NB_OBJS].tObj=oMdl2;
			} else printf("\n  ATTENTION: type d'objet \"%s\" inconnu !\n\n",argv[i]);
			// Affectation de l'offset par "=" ? ou valeur par defaut
			if (sscanf(argv[i+1],"=%d",&OBJS[NB_OBJS].offset_art)==1) {
			  ++i;
			} else
			  OBJS[NB_OBJS].offset_art=-1;
			OBJS[NB_OBJS].filename=strdup(argv[++i]);
			// Extra mesh/texture ?
			OBJS[NB_OBJS].meshfile=OBJS[NB_OBJS].texfile=NULL;
			OBJS[NB_OBJS].nb_tex=0;
			if ((i+1!=argc)&&(argv[i+1][0]!='-')&&(argv[i+1][0]!='#')) {
				OBJS[NB_OBJS].meshfile=strdup(argv[++i]);
				// With texture ?
				if ((i+1!=argc)&&(argv[i+1][0]!='-')&&(argv[i+1][0]!='#')) {
				  OBJS[NB_OBJS].texfile=strdup(argv[++i]);
				  TOT_TEX++;
				}
			}
			// Couleur specifiee ?
			if ((i+1==argc)||(argv[i+1][0]!='#'))
			  OBJS[NB_OBJS].mesh_r=OBJS[NB_OBJS].mesh_g=OBJS[NB_OBJS].mesh_b=0;
			else
			  rgbstr2vals(&argv[++i][1],&OBJS[NB_OBJS].mesh_r,&OBJS[NB_OBJS].mesh_g,&OBJS[NB_OBJS].mesh_b);
			// Object definition completed
			NB_OBJS++;
		} else if (strcmp(argv[i],"-pl")==0) {
			USE_PL=atof(argv[++i]);
#endif // USE_OBJS
		}	else
			  unknown=1;
	  } else unknown=1;

  if (unknown) { // Parametre inconnu
    printf("Usage: %s\n [-{cam,mdl,msh,tex,art,mov,fap,wav} IN-FILE]* [-sld] [-unproject]*\n",argv[0]);

#ifdef USE_AUDIO_LINUX
			printf(" [-audiodev DEV]");
#endif
			printf(" [-back #RrGgBb | IN-FILE] [-{out_pts, out_pos} OUT-FILE]*\n");
			printf(" [-out_tv {interlaced, pc, double}] [-{out_bmp, out_pnm} PATH/BASENAME]*\n");

#ifdef USE_OBJS
			printf(" [-obj {Face,Head} IN-FILE [MSH [TEX] ] [#RrGgBb]");
#endif // USE_OBJS
#ifdef USE_SOCK
			printf(" [-srv]");
#endif // USE_SOCK
#ifdef USE_EYES
			printf(" [-eye DEF-FILE ART-FILE]\n");
#endif

#ifdef USE_DICT
			printf(" [-{dic,seg} IN-FILE] ");
#endif // USE_DICT
#ifdef USE_TET_WIN
			printf(" [-tet USER]");
#endif
#ifdef USE_TET_LINUX
			printf(" [-tet]");
#endif
			printf(" [-fps VALUE] [-logo IN-FILE] [-resources]\n");

#ifdef USE_DENTS
			printf(" [-{pal,mach} IN-FILE]* [-{pospal,ptspal} OUT-FILE]* [-close_lips]\n");
#endif // USE_DENTS
      if  (strcmp(argv[i],"-h")!=0)
        printf("  argument #%s# not recognized (or lacked some arguments) !\n",argv[i]);
	exit(1);
  }

 } // for i
}

void Minim_def_cloneS(char *arg_line)
{
  char *argv[80];
  char *my_arg_line, *s;
  int argc=0;

  // On travaille sur une copie, pour strtok()...
  s=my_arg_line=strdup(arg_line);

  // On transforme la chaine en vecteur...
  argv[argc++]=strdup("Minim_lib");
  while ((argv[argc]=strtok(s," "))) {
	argc++;
	s=NULL;
  }

  // ... pour pouvoir utiliser l'appel precedent.
  i_m_a_thread=1;
  Minim_def_cloneV(argc,argv);

  free(my_arg_line); // Mais aussi les argv[] !
}


// Memorisation des eventuels callback GLUT d'un client externe
void Minim_DisplayFunc(void (*display)())
{ func_display=display;}

void Minim_IdleFunc(void (*idle)())
{ func_idle=idle;}

void Minim_InitFunc(void (*init)())
{ func_init=init;}

void Minim_ReshapeFunc(void (*reshape)(int x,int y))
{
  func_reshape=reshape;
}

void (* Minim_KeyboardFunc(void (*key)(unsigned char key,int x, int y)) )(unsigned char key,int x, int y)
{
  func_key=(key)?key:key_handler;
  return key_handler;
}

void (* Minim_MouseFunc(void (*click)(int button, int state, int x, int y)) )(int button, int state, int x, int y)
{
  func_click=(click)?click:mouse_handler;
  return mouse_handler;
}

void (* Minim_MotionFunc(void (*drag)(int x, int y)) )(int x, int y)
{
  func_drag=(drag)?drag:drag_handler;
  return drag_handler;
}

void (* Minim_PassiveMotionFunc(void (*move)(int x, int y)) )(int x, int y)
{
  func_move=(move)?move:mouse_mov_handler;
  return mouse_mov_handler;
}

// Pour suspendre/reactiver le clone sans cacher la fenetre
void Minim_clone_visible(int visible)
{
  flg_clone_visible=visible;
}

// Cet appel chargera les ressources (sauf textures)
void Minim_load_clone()
{
  int o;
  int offset=0;

    // Lecture des modeles (sans les textures, GL n'est pas encore initialise)
    read_cam(cam_file,CAM,CAM_MIRROR);
	Minim_cam_change(CAM_DX,CAM_DY,CAM_ZOOM);
    if (mdl_file[0]!=0)
		read_mdl(mdl_file,MDL,PTS);
		read_msh(msh_file,MSH);

#ifdef USE_OBJS
		// Lecture des modeles a 2 etages
		for (o=0;o<NB_OBJS;o++) {
			read_obj_def(OBJS[o].filename, &OBJS[o],offset);
			// sliders pour le premier objet ?
			if ((o==0)&&!NB_ART_MDL) // ||(OBJS[o].tObj==oFace))
				NB_ART_MDL+=OBJS[o].nb_art;
			offset=OBJS[o].offset_art+OBJS[o].nb_art;
			printf("Objet %d, %d transformations\n",o,OBJS[o].use_GLtrans);
		}

		// On active l'emulation GL des transformations
		if (PAL_REF>=0) OBJS[PAL_REF].use_GLtrans=(OBJS[PAL_REF].use_GLtrans<0)?(-OBJS[PAL_REF].use_GLtrans):(OBJS[PAL_REF].use_GLtrans);
		//  on active l'emulation GL des transformations
		if (MACH_REF>=0) OBJS[MACH_REF].use_GLtrans=(OBJS[MACH_REF].use_GLtrans<0)?(-OBJS[MACH_REF].use_GLtrans):(OBJS[MACH_REF].use_GLtrans);

		// On masque certaines accelerations des transformations
		for (o=0;o<NB_OBJS;o++) if (OBJS[o].use_GLtrans<0) {
		  // On active l'acceleration pour la main
		  if (OBJS[o].tObj==oHand)
			OBJS[o].use_GLtrans=-OBJS[o].use_GLtrans;
		}
#endif // USE_OBJS

    // lecture de l'eventuelle config de textures
    if (tex_file[0]!=0) read_tex(tex_file,TEX_POIDS,TEX_FILE);

#ifdef USE_DENTS
	    ANG_JW = (2*acos(0.0))/4;

    // lecture de l'eventuel modele de dents superieures
    if (pal_file[0]!=0) {
      read_dents(pal_file, &PAL, &NB_PAL,0, &TEX_PAL_FILE, P2D_PAL_FILE );
    }

    // lecture de l'eventuel modele de dents inferieures
    if (mach_file[0]!=0) {
      read_dents(mach_file, &MACH, &NB_MACH,1,&TEX_MACH_FILE,P2D_MACH_FILE );
    }
#endif

#ifdef USE_EYES
		// Activation/Desactivation des yeux
		// Lecture du modele et de l'articulation des yeux
		if (eye_def_file[0]!=0) {
			read_eyes_def(eye_def_file,EYES);
			read_eyes_art(eye_art_file);
		} else
#endif // USE_EYES
			NB_TMSK=0;

#ifdef USE_SOCK
    // demarrage eventuel d'une ecoute
    if (host_srv[0]!=0) SOCK_SRV=open_srv(host_srv);
#endif

	// lecture et identification des mots vs le dictionnaire
	if (dic_file[0]!=0) read_dic(dic_file);

    // lecture eventuelle de modele d'inversion de fap et fichier fap
    if (fap_file[0]!=0) read_fap(fap_file);
	else read_art(art_file,1);

    // Lecture eventuelle de mouvement objet
    if (mov_file[0]!=0) read_mov(mov_file,OBJ_MOV);

#ifdef USE_AUDIO
    // Lecture eventuelle du fichier son
    if (wav_file[0]!=0) open_wav(wav_file,1);
#endif // USE_AUDIO

	// Besoin du frame_rate par defaut ?
	if (F_RATE<0) F_RATE=-F_RATE;

	// lecture de logos, art et wav multiples
	if (logo_file[0]!=0)
	  read_logo(logo_file);
}

//Permet de lancer l'ouverture de la fenetre
// (et le chargement des textures, apres la lecture des ressources)
void Minim_start_clone() {
	Minim_load_clone();

#ifdef USE_TET_WIN
	if (TET_ACTIF)
	  track_start(CAL_NAME);
#endif // USE_TET_WIN

    // Sliders visibles ?
    // if ( ((ART_MAX<=1)&&(logo_file[0]==0)&&(SOCK==-1)) || (NB_SLD<0))
	if (NB_SLD<0)
        NB_SLD=(NB_ART_MDL<0)?NB_ART_MDL:NB_ART_MDL;

    // ouverture d'un contexte d'affichage, par GLUT
    open_display();

#ifdef USE_TET_WIN
	if (TET_ACTIF)
		Tet_Disconnect();
#endif
}

void Minim_finish_clone()
{
  if (pending_delete) {
   printf("  **** Il faudrait effacer :/n");
   printf("  ****  %s/n  ****  %s/n", pending_art_file, pending_wav_file);
   pending_delete=0;
  }
  pending_close=1;
}

void Minim_hide_clone()
{
  pending_hc=+1;
}

void Minim_show_clone()
{
  pending_hc=-1;
}

void Minim_show_back(int flag)
{
  USE_BACK=flag;
//	int tmp;
//	tmp=(SLOT_BACK<0)?-SLOT_BACK:SLOT_BACK;
//	if (!flag) SLOT_BACK=-tmp; else SLOT_BACK=tmp;
}

/* Permet de specifier que c'est MINIM_TEX_ID[slot] qui sera utilisee comme texture de fond */
void Minim_set_back_slot(int slot)
{
  if ((slot>=0)&&(slot<TOT_TEX)) {
	SLOT_BACK=slot;
  }
}

void Minim_set_window_size(int W,int H)
{
  pending_sws=1;
  pending_sws_w=W;
  pending_sws_h=H;
}

void Minim_set_window_position(int X,int Y)
{
  pending_swp=1;
  pending_swp_x=X;
  pending_swp_y=Y;
}

void Minim_play_msg(int nb)
{
  play_msg(nb,0);
}

